#! /bin/bash
default()
{
    grep "DEFAULT_MODULE_DIR"  $AST_SRC_DIR/defaults.h > /tmp/gsmtmp
    sed -e s/#define.DEFAULT_MODULE_DIR.\"// /tmp/gsmtmp > /tmp/gsmtmp1
    AST_MOD_DIR=`sed -e s/\"$// /tmp/gsmtmp1`

    grep "DEFAULT_CONFIG_DIR"  $AST_SRC_DIR/defaults.h > /tmp/gsmtmp
    sed -e s/#define.DEFAULT_CONFIG_DIR.\"// /tmp/gsmtmp > /tmp/gsmtmp1
    AST_CONF_DIR=`sed s/\"$// /tmp/gsmtmp1`
}

ast()
{
     grep "AST_CONFIG_DIR" $AST_SRC_DIR/defaults.h > /tmp/gsmtmp
     sed -e s/#define.AST_CONFIG_DIR.\"// /tmp/gsmtmp > /tmp/gsmtmp1
     AST_CONF_DIR=`sed -e s/\"$// /tmp/gsmtmp1`

     grep "AST_MODULE_DIR"  $AST_SRC_DIR/defaults.h > /tmp/gsmtmp
     sed -e s/#define.AST_MODULE_DIR.\"// /tmp/gsmtmp > /tmp/gsmtmp1
     AST_MOD_DIR=`sed s/\"$// /tmp/gsmtmp1`
}

search()
{
      grep DEFAULT_MODULE_DIR $AST_SRC_DIR/defaults.h
      if [ $? == 0 ];
      then
            default;
      else
             ast;
      fi
   rm /tmp/gsmtmp /tmp/gsmtmp1
}

detect_number_of_cards()
{
        MAX_GSM_PORTS=1
        r=a
       #echo
       #read -p "Enter the number of NUMBER of ALLO GSM BOARDS you wish to Compile DRIVER for OR enter A/a for auto Detect: " r
       #echo
        case $r in
                [Aa]*)
                        r=`lspci -n | grep -c -e "10b5:9030" -e "10b5:d44e"`
                        MAX_GSM_PORTS=$(expr $(expr $r \* 4) + 1)
                        echo 
			echo ALLO GSM DRIVER DETECTED $r ALLO GSM CARDS!!!
                        echo ;;
                1|2|3|4)
                        MAX_GSM_PORTS=$(expr $(expr $r \* 4) + 1)
			echo
                        echo;;
         #              exit 0;;
                * )     echo
                        echo "ENTERED  INVALID OPTION TRY AGAIN"
                        exit 1 ;;
        esac

        line="#define MAX_GSM_PORTS"
        rep="#define MAX_GSM_PORTS   $MAX_GSM_PORTS"
	MAX_GSM_PORTS=$(expr $MAX_GSM_PORTS - 1)

	if [ "$1" = "elastix" ] ;
	then
		temp=`pwd`
		PATH_CHAN_GSM=$temp/chan_gsm
	else
		PATH_CHAN_GSM=$AST_SRC_DIR/channels/chan_gsm
	fi

	sed -i.bak "s/${line}.*/${rep}/g" $PATH_CHAN_GSM/gsmctl.h

	PATH_GSM_ADD_CONF=$PATH_CHAN_GSM/gsm_additional.conf
	cp $PATH_GSM_ADD_CONF.orig $PATH_GSM_ADD_CONF

	for i in `seq $MAX_GSM_PORTS`; do
		echo "[gsm$i]" >> $PATH_GSM_ADD_CONF
		echo "context=gsm-incoming$i" >> $PATH_GSM_ADD_CONF
		echo "pin=none" >> $PATH_GSM_ADD_CONF
		echo "channel=$i" >> $PATH_GSM_ADD_CONF
		echo "rxgain=64" >> $PATH_GSM_ADD_CONF
		echo "txgain=64" >> $PATH_GSM_ADD_CONF
		
	done
}

files()
{
INSTALL_DIR=$PWD
PLX_SRC_DIR=/usr/src/
   cd $INSTALL_DIR
   if [ ! -e $INSTALL_DIR/PlxSdk.tar ] && [ ! -e $INSTALL_DIR/chan_gsm.tar ] ;
   then
                   echo "#####################################################"
                   echo 
                   echo "REQUIRED PlxSdk.tar , chan_gsm.tar  FILES TO PROCEED"
                   echo 
                   echo "#####################################################"
        exit 1
else
                  echo  "#####################################################"
                  echo
                  echo             "STARTING ALLO GSM  INSTALLATION"
                  echo 
                  echo  "######################################################"
   fi
}

export AST_SRC_DIR=$1
plx()
{
files
cd $PLX_SRC_DIR
 if [ -e $PLX_SRC_DIR/PlxSdk ]
    then
    echo  
    read -p   "DO YOU WANT TO REPLACE THE EXISTING PlxSdk FILE Y/N :" res
    echo
    case $res in
        [Yy]* ) rm -rf $PLX_SRC_DIR/PlxSdk;
                tar -xvf  $INSTALL_DIR/PlxSdk.tar ;;

        [Nn]* )  echo
                 echo "PROCEEDING WITH THE NORMAL STEPS" ;
                 echo ;;
            * )  echo 
                 echo "ENTERED INVALID OPTION TRY AGAIN" ;
                 exit 1 ;;

     esac
else
    tar -xvf  $INSTALL_DIR/PlxSdk.tar
fi

export PLX_SDK_DIR=$PLX_SRC_DIR/PlxSdk/
cd  "$PLX_SRC_DIR"/PlxSdk/Linux/Driver
     chmod u+x builddriver
     ./builddriver 9030 d

if [ -e $PLX_SRC_DIR/PlxSdk/Linux/Driver/Plx9030/Plx9030_dbg.ko ];
then
     lsmod |  grep "Plx9030_dbg" > /dev/null
     if [ $? == 0 ]
     then
     echo "removing already existing moudule" 
      rmmod Plx9030_dbg
     if [ $? != 0 ]
     then
                echo      
                echo "STOP ASTERISK TO CONTINUE INSTALLATION"
                echo 
                exit 1;
                fi
      fi
     cd ../../Bin
     chmod u+x Plx_load
     ./Plx_load 9030 d
     if [ $? != 0 ]
     then
                echo 
                echo "PLX INSTALLATION INCOMPLETE..."
                echo    
                exit 1;
     fi
else
                echo        
                echo "BUILD INCOMPLETE  PLXSDK..."
                echo 
                exit 1;
fi
                echo "####################################################"
                echo
                echo                    " PLX INSTALLATION DONE"
                echo
                echo "####################################################"

}

if [ "$1" != "" ];then
gsm()
{
search
cd $AST_SRC_DIR/channels/
if [ -e chan_gsm ];then
        echo
        read -p "chan_gsm ALREADY EXISTS...DO YOU WANT TO REINSTALL  ? Y/N:" res
        echo
        case $res in
         [Yy]* ) rm -rf  $AST_SRC_DIR/channels/chan_gsm;
                    tar -xvf $INSTALL_DIR/chan_gsm.tar;;

         [Nn]* ) echo
                 echo "PROCEEDING WITH NORMAL STEPS" ;
                 echo  ;;
             *)  echo 
                 echo "ENTERED INVALID ARGUMENT PLEASE TRY AGAIN" ;
                 echo
                 exit 1 ;;
        esac 
else
        tar -xvf $INSTALL_DIR/chan_gsm.tar
fi
AST_FULL_VERSION=`cat $AST_SRC_DIR/.version`
v=${AST_FULL_VERSION%%.*}
AST_VERSION=`cat $AST_SRC_DIR/.version | awk -F "." '{print $1 "."$2}'`
if [ $v == 10 ]; then
VER=10_4
fi
if [ $v == 11 ]; then
VER=11_4
fi
if [ $AST_VERSION == 1.4 ];then
VER=1_4
elif [ $AST_VERSION == 1.6 ];then
VER=1_6_2
elif [ $AST_VERSION == 1.8 ];then
VER=1_8
fi

cat > $AST_SRC_DIR/channels/chan_gsm/Makefile.dyn <<EOF
ASTDIR=../../
ASTERISK_$VER = 1
EOF
detect_number_of_cards "pc"
cd chan_gsm/compat
cp Makefile_gen Makefile
make clean
make
cp -v *.so $AST_MOD_DIR
cd ../
make clean
make
cp -v gsm.conf gsm_additional.conf $AST_CONF_DIR
cp -v chan_gsm.so $AST_MOD_DIR
if [ $? -ne 0 ];
then
                  echo "########################################################"
                  echo 
                  echo                 "ALLO  GSM NOT LOADED "
                  echo
                  echo "########################################################"
                  exit 1
else
                  echo "########################################################"
                  echo
                  echo                 "ALLO GSM LOADED SUCCESSFULLY"
                  echo
                  echo "########################################################"
                  echo
fi
#grep "plx_install" /etc/rc.local
#if [ $? != 0 ];then
#cat >> /etc/rc.local << EOF
#bash $INSTALL_DIR/plx_install
#EOF
#fi
cd $INSTALL_DIR
var=`grep -c "allogsm_plx" /etc/init.d/asterisk`
if [ $var -eq "0" ]; then
        echo "Appending asterisk init script"
        sed -i.bak '/Should-St/ s/$/ allogsm_plx/' /etc/init.d/asterisk
	rm -f /etc/init.d/asterisk.bak
fi

var=`grep -c "plx_install" /etc/rc.local`
if [ $var != 0 ];then
	sed -i.bak '/plx_install/d' /etc/rc.local
	rm -f /etc/rc.local.bak
fi

cp $INSTALL_DIR/allogsm_plx /etc/init.d/ 
/sbin/chkconfig --add allogsm_plx
cd /etc/

                 echo "#######################################################"
                 echo
                 echo                  " PLX MODULE LOADS AT BOOT TIME"
                 echo 
                 echo "#######################################################"
exit 0
}
     plx
     gsm

else
ast_headers()
{
if [ -e /usr/include/asterisk ]; then
                echo "#############################################################"
                echo
                echo            "ASTERISK HEADER FILES FOUND"
                echo
                echo "#############################################################"
else
               yum search asterisk > /tmp/ast
               grep ^asterisk$1-devel /tmp/ast >> /tmp/ast1
               filename=`cat /tmp/ast1`
               AST_DEVEL=${filename/: St*/}
               yum install $AST_DEVEL
fi
}
gsm_trix_elas()
{
uname -m>>li
lb=`cat li`
rm li
if [ $lb == i686 ] || [ $lb == i386 ];then
libd=lib
else
libd=lib64
fi
asterisk -V >ver
p=` cat ver | awk -F "." '{print $1 "."$2}' `
AST_VERSION=${p#* }
rm ver
v=${AST_VERSION%%.*}
if [ $v == 10 ]; then
        VER=10_4
        DEVAL_VER=10
fi
if [ $v == 11 ]; then
        VER=11_4
        DEVAL_VER=11
fi
if [ $AST_VERSION == 1.4 ];then
        VER=1_4
        DEVAL_VER=14
elif [ $AST_VERSION == 1.6 ];then
        VER=1_6_2
        DEVAL_VER=16
elif [ $AST_VERSION == 1.8 ];then
        VER=1_8
        DEVAL_VER=18
fi
ast_headers $DEVAL_VER
cd $INSTALL_DIR
if [ -e chan_gsm ];then
         echo
         read -p "chan_gsm ALREADY EXISTS...DO YOU WANT TO REINSTALL  ? Y/N:" res
        
         case $res in
        [Yy]* ) rm -rf  $INSTALL_DIR/chan_gsm;
                tar -xvf chan_gsm.tar;;

        [Nn]* ) echo
                echo "PROCEEDING WITH NORMAL STEPS" ;
                echo  ;;
             *) echo 
                echo "ENTERED INVALID ARGUMENT PLEASE TRY AGAIN" ;
                echo
                exit 1 ;;
        esac
else
        tar -xvf chan_gsm.tar
fi
cat > $INSTALL_DIR/chan_gsm/Makefile.dyn <<EOF
ASTDIR=/usr/
ASTERISK_$VER = 1
EOF
detect_number_of_cards "elastix"
cd chan_gsm/compat
cp Makefile_elax Makefile
make clean
make
cp -v *.so /usr/$libd/asterisk/modules/
if [ $? == 0 ];then
cd ../
make clean
make
cp -v gsm.conf gsm_additional.conf /etc/asterisk/
cp -v chan_gsm.so /usr/$libd/asterisk/modules/
if [ $? -ne 0 ];
then
               echo "####################################################"
               echo 
               echo                "ALLO GSM NOT LOADED "
               echo
               echo "####################################################"
exit 1
else
              echo "####################################################"
              echo
              echo                 "ALLO GSM LOADED SUCCESSFULLY"
              echo
              echo "####################################################"
fi
grep "chan_gsm.so" /etc/asterisk/modules.conf
if [ $? != 0 ];then
cat >>/etc/asterisk/modules.conf <<EOF
load => chan_gsm.so
EOF
fi

#grep "plx_install" /etc/rc.local
#if [ $? != 0 ];then
#cat >> /etc/rc.local << EOF
#bash $INSTALL_DIR/plx_install&
#EOF
#fi
var=`grep -c "allogsm_plx" /etc/init.d/asterisk`
if [ $var -eq "0" ]; then
        echo "Appending asterisk init script"
        sed -i.bak '/Should-St/ s/$/ allogsm_plx/' /etc/init.d/asterisk
	rm -f /etc/init.d/asterisk.bak
fi

var=`grep -c "plx_install" /etc/rc.local`
if [ $var != 0 ];then
	sed -i.bak '/plx_install/d' /etc/rc.local
	rm -f /etc/rc.local.bak
fi

cd ../
cp $INSTALL_DIR/allogsm_plx /etc/init.d/ 
/sbin/chkconfig --add allogsm_plx

exit 0
else
              echo
              echo "COMPILATION STOPPED DUE TO SOME DEPENDENCIES CHECK DEPENDENCIES"
              exit 1
fi

}
              echo
              read -p "PROCEED TO TRIX-BOX/ELASTIX ALLO GSM INSTALLATION : Y/N  " r
              echo
    case $r in
       [Yy]*)  plx 
               gsm_trix_elas;
               echo ;; 
       [Nn]*)  echo "####################################################"
               echo
               echo "ALLO GSM INSTALLATION TERMINATED"
               echo
               echo "####################################################"
               exit 0;;
         * )   echo
               echo "ENTERED  INVALID OPTION TRY AGAIN"
               exit 1 ;;
   esac
fi
