#include <stdio.h>
#include <errno.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/ioctl.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>

/*
#include "CmdLine.h"
#include "Monitor.h"
#include "MonCmds.h"
#include "PlxApi.h"
#include "PciRegs.h"
#include "RegDefs.h"
#include "ConsFunc.h"
#include "PlxInit.h"
*/
#include "gsmctl.h"


#define GSM_IOC_MAGIC                           'G'
#define GSM_SETLED                              _IO(GSM_IOC_MAGIC, 0)
#define GSM_GETLED                              _IO(GSM_IOC_MAGIC, 1)
#define GSM_SETSTATE                            _IO(GSM_IOC_MAGIC, 2)
#define GSM_SETNEXTSIMSLOT                      _IO(GSM_IOC_MAGIC, 3)
#define GSM_KILLME                              _IO(GSM_IOC_MAGIC, 4)
#define GSM_PEEK_FPGA                           _IO(GSM_IOC_MAGIC, 5)
#define GSM_POKE_FPGA                           _IO(GSM_IOC_MAGIC, 6)
#define GSM_POWERCYCLE_RADIO                    _IO(GSM_IOC_MAGIC, 7)
#define GSM_SET_RX_GAIN                         _IO(GSM_IOC_MAGIC, 8)
#define GSM_SET_TX_GAIN                         _IO(GSM_IOC_MAGIC, 9)
#define GSM_INTR_STAT                           _IO(GSM_IOC_MAGIC,10)

#define INCLUDE_NEWLINE 1

#define GSM_DEV "/dev/gsm/ctl" 

const char *progname = "" ;
static int debug=0;

void print_usage(void)
{
	fprintf( stderr, "usage: %s <gsm-port> [[detect|read|write data]]\n", progname ) ;
}

#define MAX_DATA_SIZE (1024*8)

/**********************************************
 *                 Globals
 **********************************************/
void gsm_write_audio ( PLXCM_COMMAND *pCmd );
char gsm_read_audio ( PLXCM_COMMAND *pCmd );



#if 0
/* This function is commented as of now but need to be modified soon ...... */
int cem_plx_play_file ()
{

	char buffer[256]="";
		/* Here we will read the sring of data from the file, and we write it to the PLX */
		FILE *fp = fopen("/home/projects/gsm/morning_coffee.alaw" , "r");
		if(!fp){
			fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] Failed to open the audio file..... exiting the function !!!!! \n" , __FILE__ , __func__ , __LINE__  );
			exit(-1);
		} else {
			/* We can able to open the file........*/
			char string[256]="";
			while(!feof(fp)){
				memset(&string , 0x00 , sizeof(string) );
				int i ; 
				int ret = fread(string , sizeof(string) -1 , 1 , fp );
				//fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] End of for loop ret '%d' sizeof(string) '%d' string '%s' \n" , __FILE__ , __func__ , __LINE__ , ret , sizeof(string) , string );
				for(i = 0 ; i < 255 ; i++){
					memset(&buffer , 0x00 , sizeof(buffer) );
					snprintf(buffer , sizeof(buffer) -1 , "%s %02x" , audio_write , string[i] );
					time_t result;
					struct tm tm;
					char timenow[256]="";
					result = time(NULL);
					localtime_r(&result , &tm );
					strftime (timenow ,sizeof (timenow),"%I:%M:%S %p %Z",&tm);
					//fprintf(stderr,"'%s':'%s':'%s':'%d'[ALLO_GSM] buffer '%s'  and hex '%02x' i '%d' \n" , timenow , __FILE__ , __func__ , __LINE__ , buffer , string[i] , i );
					pCmd = CmdLine_CmdAdd( buffer );
        			Cmd_MemWrite( pDevice, pCmd );
					//usleep(5);
				}
				//nanosleep(NULL , NULL);
				usleep(9999);
				usleep(9999);
				usleep(999);
				usleep(99);
			}
			fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] We have completed the file playing !!!!\n" , __FILE__ , __func__ , __LINE__  );
		}
}
#endif

char gsm_read_audio ( PLXCM_COMMAND *pCmd )
{

	static U8  *pCurrAddr = NULL;
	PLXCM_ARG  *pArg;


	// Set current address
	if (pCmd->NumArgs >= 1){
		// Get starting address
		pArg = CmdLine_ArgGet( pCmd, 0 );
		
		// Verify argument
		if (pArg->ArgType != PLXCM_ARG_TYPE_INT){
			Cons_printf("Error: '%s' [G1] is not a valid address\n", pArg->ArgString);
			return 'f';
		}
		
		// Set current address
		pCurrAddr = PLX_CAST_64_TO_8_PTR( (PLX_UINT_PTR)pArg->ArgIntHex );
		char c= PlxCm_MemRead_8(pCurrAddr);
		return c;
	}


	//fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] address '%08x'  hex '%04x' dec '%d' \n" , __FILE__ , __func__ , __LINE__ , (PLX_UINT_PTR)pCurrAddr , c , c );

	return (char)'0';
	
}

void gsm_write_audio ( PLXCM_COMMAND *pCmd )
{

	static U8  *pCurrAddr = NULL;
	PLXCM_ARG  *pArg;

    // Get starting address
    pArg = CmdLine_ArgGet( pCmd, 0 );

    // Verify argument
    if (pArg->ArgType != PLXCM_ARG_TYPE_INT)
    {
        Cons_printf("Error: '%s' [G2] is not a valid address\n", pArg->ArgString);
        return ;
    }

    // Set current address
    pCurrAddr = PLX_CAST_64_TO_8_PTR( (PLX_UINT_PTR)pArg->ArgIntHex );

	//fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] add '%08x' data '%02x' \n" , __FILE__ , __func__ , __LINE__ , (PLX_UINT_PTR)pCurrAddr , (U8)pArg->ArgIntHex );
	PlxCm_MemWrite_8( pCurrAddr, (U8)pArg->ArgIntHex);
}


VOID PciSpacesMap( PLX_DEVICE_OBJECT *pDevice , DEVICE_NODE *pNodeCurrent, int card_idx )
{
    U8   i;
    char strVar[5];
    char strVal[25];

    // Skip if no device is selected
    if (pNodeCurrent == NULL){
		//fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] Error !!! pNodeCurrent is NULL !!!!!\n" , __FILE__ , __func__ , __LINE__  );
        return;
	}
    for (i=0; i<6; i++)
    {
        // Map PCI BAR into user space
        PlxPci_PciBarMap(
            pDevice,
            i,
            (VOID**)&(pNodeCurrent->Va_PciBar[i])
            );
    
        // Add to variable table
        if (pNodeCurrent->Va_PciBar[i] != 0)
        {
            // Prepare variable & add to table
            sprintf( strVar, "%c%d", 'V'+card_idx, i);
            sprintf( strVal, "%08lX", (PLX_UINT_PTR)pNodeCurrent->Va_PciBar[i] );	

            CmdLine_VarAdd(
                strVar,
                strVal,
                TRUE        // System variable
                );
        }
    }
	//fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] End of the function.......\n" , __FILE__ , __func__ , __LINE__  );
}

/**********************************************************
 *
 * Function   :  CommonBufferMap
 *
 * Description:  Get common buffer information & map to virtual space
 *
 *********************************************************/
VOID CommonBufferMap( PLX_DEVICE_OBJECT *pDevice )
{
    char              strVal[25];
    VOID             *pBuffer;
    PLX_PHYSICAL_MEM  PciBuffer;


    // Get PCI buffer properties
    PlxPci_CommonBufferProperties(
        pDevice,
        &PciBuffer
        );

    if (PciBuffer.Size != 0)
    {
        // Map buffer into user space
        PlxPci_CommonBufferMap(
            pDevice,
            &pBuffer
            );

        // Add to variable table
        if (pBuffer != 0)
        {
            // Prepare variable
            sprintf( strVal, "%08lX", (PLX_UINT_PTR)pBuffer );
            CmdLine_VarAdd(
                "hbuf",
                strVal,
                TRUE        // System variable
                );
        }
    }
}

#if 1 //ALLO_GSM NOT USED
/**********************************************************
 *
 * Function   :  DeviceNodeSelectByIndex
 *
 * Description:
 *
 *********************************************************/
DEVICE_NODE* DeviceSelectByIndex( U8 index , DEVICE_NODE *pNodeCurrent )
{
    DEVICE_NODE *pNode;


    // Get 
    pNode =
        DeviceNodeGetByNum(
            index,
            FALSE           // Non-PLX device is ok
            );

    if (pNode == NULL)
        return NULL;

    // De-select current device is selected
    if (pNodeCurrent != NULL)
    {
        pNodeCurrent->bSelected = FALSE;
        PciSpacesUnmap( &Gbl_DeviceObj[index] , pNodeCurrent, 0 );
        CommonBufferUnmap( &Gbl_DeviceObj[index] );
        PlxPci_DeviceClose( &Gbl_DeviceObj[index] );
    }

    // Select new device
   printf("Before Opening Device\n");	
    PlxPci_DeviceOpen(
        &pNode->Key,
        &Gbl_DeviceObj[index]
        );
   printf("After Opening Device\n");	

    // Update current node
    pNodeCurrent = pNode;

    // Map valid PCI BAR spaces
    PciSpacesMap( &Gbl_DeviceObj[index] , pNodeCurrent, 0 );

    // Get Common buffer properties
    CommonBufferMap( &Gbl_DeviceObj[index] );

    pNode->bSelected = TRUE;

    return pNode;
}

#endif


/**********************************************************
 *
 * Function   :  Mon_PostCommand
 *
 * Description:  Places a command into the buffer for processing
 *
 *********************************************************/
VOID Mon_PostCommand( PLXCM_COMMAND *pCmd )
{
    // Store the command
    Gbl_pPostedCmd = pCmd;
}



/**********************************************************
 *
 * Function   :  PciSpacesUnmap
 *
 * Description:
 *
 *********************************************************/
VOID PciSpacesUnmap( PLX_DEVICE_OBJECT *pDevice , DEVICE_NODE *pNodeCurrent, int card_idx )
{
    U8   i;
    char strVar[5];


    // Skip if no device is selected
    if (pNodeCurrent == NULL)
        return;

    for (i=0; i<6; i++)
    {
        if (pNodeCurrent->Va_PciBar[i] != 0)
        {
            // Unmap PCI BAR from user space
            PlxPci_PciBarUnmap(
                pDevice,
                (VOID**)&(pNodeCurrent->Va_PciBar[i])
                );

            // Prepare variable & remove from table
            sprintf( strVar, "%c%d",'V'+card_idx, i);

            CmdLine_VarDelete(
                strVar,
                TRUE        // System variable
                );
        }
    }
}



/**********************************************************
 *
 * Function   :  CommonBufferUnmap
 *
 * Description:  Unmap common buffer & clear information
 *
 *********************************************************/
VOID CommonBufferUnmap( PLX_DEVICE_OBJECT *pDevice )
{
    VOID      *pBuffer;
    PLXCM_VAR *pVar;


    // Get buffer address from variable table
    pVar = CmdLine_VarLookup( "hbuf" );

    if (pVar != NULL)
    {
        pBuffer = (VOID*)htol( pVar->strValue );

        // Unmap buffer
        PlxPci_CommonBufferUnmap(
            pDevice,
            pBuffer
            );

        // Remove variable from table
        CmdLine_VarDelete(
            "hbuf",
            TRUE        // System variable
            );
    }
}
		
#if INCLUDE_NEWLINE

BOOLEAN Cem_MemRead_with_newline( PLX_DEVICE_OBJECT *pDevice, PLXCM_COMMAND *pCmd , char **bufferptr, int *len)
{

	int         i = 0;
	int         x;
	int         CharsToPrint;
	int         SpacesToInsert;
	U8          size = sizeof(U16);
	U8         *pEndAddr;
	static U8  *pCurrAddr = NULL;
	U64         CurrValue;
	BOOLEAN     bDone;
	BOOLEAN     bRepeat;
	BOOLEAN     bEndLine;
	PLXCM_ARG  *pArg;
	char *buffer= *bufferptr;
	char *ptr = buffer;

	int maxlen = *len;

	*len=0;
	// Set current address
	if (pCmd->NumArgs >= 1){
		// Get starting address
		pArg = CmdLine_ArgGet( pCmd, 0 );
		
		// Verify argument
		if (pArg->ArgType != PLXCM_ARG_TYPE_INT){
			Cons_printf("Error: '%s' [G3] is not a valid address\n", pArg->ArgString);
			return FALSE;
		}
		// Set current address
		pCurrAddr = PLX_CAST_64_TO_8_PTR( (PLX_UINT_PTR)pArg->ArgIntHex );
	}

	memset(buffer , 0x00 , sizeof(buffer) );
	bDone    = FALSE; /* Read till its true !!! */
	do{
		if (i == 0){
			// Set initial number of characters to display
			CharsToPrint = 0;
			
			// Set initial Spaces to insert
			SpacesToInsert = (U8)((((size * 2) + 1) * (16 / size)) + 3);
			
			//Cons_printf("We are reading from address '%08x' \n ", (PLX_UINT_PTR)pCurrAddr);
			i++;
		}

#if 1 /* This code is for reading the one byte form the PLX.....*/
		char c1 = PlxCm_MemRead_8(pCurrAddr); 
                if(isascii(c1)){
			if( (c1 != '\0') && (c1 != 4) ){
				if (debug){
					if ((c1>=0x20) && (127>c1))
						printf("%c",c1); 
					else
						printf("(%X)",c1);
				}
				*(buffer++) = c1;
				*len = *len + 1;
			}
		}
#endif
/* This code is for reading the two bytes form the PLX.....*/
/*code for reading two bytes from plx is present in Cem_MemRead.. this function is exact copy of that fn.. just some minor changes*/
		
		// Adjust characters to print
		CharsToPrint += size;
		
		// Adjust spaces
		SpacesToInsert -= (size * 2) + 1;

		//if( (((U8*)(&CurrValue))[0] == 4) && (((U8*)(&CurrValue))[1] == 4) ){
		if( (c1 == 4) ){
			bDone    = TRUE;/* End of the reading !!!! */
			*buffer = '\0';
		}

		if(*len == (maxlen-1)){
			bDone    = TRUE;/* End of the reading !!!! */
			*buffer = '\0';
		}

	}while(!bDone);
	return TRUE;
}
#endif

BOOLEAN Cem_MemRead( PLX_DEVICE_OBJECT *pDevice, PLXCM_COMMAND *pCmd , char **bufferptr, int *len)
{

	int         i = 0;
	int         x;
	int         CharsToPrint;
	int         SpacesToInsert;
	U8          size = sizeof(U16);
	U8         *pEndAddr;
	static U8  *pCurrAddr = NULL;
	U64         CurrValue;
	BOOLEAN     bDone;
	BOOLEAN     bRepeat;
	BOOLEAN     bEndLine;
	PLXCM_ARG  *pArg;
	char *buffer= *bufferptr;
	char *ptr = buffer;

	int maxlen = *len;

	*len=0;
	//printf("HERE :%d:\n", maxlen);
	// Set current address
	if (pCmd->NumArgs >= 1){
		// Get starting address
		pArg = CmdLine_ArgGet( pCmd, 0 );
		
		// Verify argument
		if (pArg->ArgType != PLXCM_ARG_TYPE_INT){
			Cons_printf("Error: '%s' [G3] is not a valid address\n", pArg->ArgString);
			return FALSE;
		}
		
		// Set current address
		pCurrAddr = PLX_CAST_64_TO_8_PTR( (PLX_UINT_PTR)pArg->ArgIntHex );
	}

	memset(buffer , 0x00 , sizeof(buffer) );
	bDone    = FALSE; /* Read till its true !!! */
	do{
		if (i == 0){
			// Set initial number of characters to display
			CharsToPrint = 0;
			
			// Set initial Spaces to insert
			SpacesToInsert = (U8)((((size * 2) + 1) * (16 / size)) + 3);
			
			//Cons_printf("We are reading from address '%08x' \n ", (PLX_UINT_PTR)pCurrAddr);
			i++;
		}
		/*if(i <= 5){
			Cons_printf("%08x: ", (PLX_UINT_PTR)pCurrAddr);
		}*/

#if 1 /* This code is for reading the one byte form the PLX.....*/
		char c1 = PlxCm_MemRead_8(pCurrAddr);
	//	printf("'%x'\n", c1);
		if(isascii(c1)){
			//fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] we are reading c1 '%x' \n" , __FILE__ , __func__ , __LINE__ , c1 );
			if( (c1 != '\0') && (c1 != '\n') && (c1 != '\r') && (c1 != 4) ){
				*(buffer++) = c1;
				*len = *len + 1;
			}
		}
#endif
#if 0 /* This code is for reading the two bytes form the PLX.....*/
		// Read the PLX 16bits i.e ONE WORD !!!!
		CurrValue = PlxCm_MemRead_16(pCurrAddr);
		//Cons_printf("%04x ", (U16)CurrValue);

		//if ( ((((U8*)(&CurrValue))[0] != ' ' ) || (((U8*)(&CurrValue))[1] != ' ' ) ) && (!isgraph(((U8*)(&CurrValue))[0]) && (!isgraph(((U8*)(&CurrValue))[1]))) )
		char c1 = ((U8*)(&CurrValue))[0];
		char c2 = ((U8*)(&CurrValue))[1];
		//if(isascii(((U8*)(&CurrValue))[0]) && isascii(((U8*)(&CurrValue))[1]) )
		if(isascii(c1) && isascii(c2))
		{
			if( (c1 != '\0') && (c1 != '\n') && (c1 != '\r') && (c1 != 4) ){
				//fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] We are storing into buffer c1 \n" , __FILE__ , __func__ , __LINE__  );
				*(buffer++) = c1;
			}
			if( (c2 != '\0') /*&& (c2 != '\n')*/ && (c2 != '\r') && (c2 != 4) ){
				//fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] We are storing into buffer c2 \n" , __FILE__ , __func__ , __LINE__  );
				*(buffer++) = c2;
			}
			//fprintf(stderr,"[ALLO_GSM] %c%c ['%x''%x']-------- %c%c buffer '%p' \n", c1 , c2 , c1,c2 , *buffer , *buffer , buffer );
		}
#endif
		
		// Adjust characters to print
		CharsToPrint += size;
		
		// Adjust spaces
		SpacesToInsert -= (size * 2) + 1;

		//if( (((U8*)(&CurrValue))[0] == 4) && (((U8*)(&CurrValue))[1] == 4) ){
		if( (c1 == 4) ){
			bDone    = TRUE;/* End of the reading !!!! */
			*buffer = '\0';
			//fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] We have reached to the end of the reading !!!\n" , __FILE__ , __func__ , __LINE__  );
		}

		if(*len == (maxlen-1)){
			bDone    = TRUE;/* End of the reading !!!! */
			*buffer = '\0';
		}

	}while(!bDone);

	
//	fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] Returning from mem read .. buffer '%s':'%d' \n" , __FILE__ , __func__ , __LINE__ , ptr , buffer-ptr);

	return TRUE;

}

U64 Cem_Single_MemRead( PLX_DEVICE_OBJECT *pDevice, PLXCM_COMMAND *pCmd )
{

	int         i = 0;
	int         x;
	int         CharsToPrint;
	int         SpacesToInsert;
	char        buffer[1024];
	U8          size = sizeof(U16);
	U8         *pEndAddr;
	static U8  *pCurrAddr = NULL;
	U64         CurrValue;
	BOOLEAN     bDone;
	BOOLEAN     bRepeat;
	BOOLEAN     bEndLine;
	PLXCM_ARG  *pArg;


	// Set current address
	if (pCmd->NumArgs >= 1){
		// Get starting address
		pArg = CmdLine_ArgGet( pCmd, 0 );
		
		// Verify argument
		if (pArg->ArgType != PLXCM_ARG_TYPE_INT){
			Cons_printf("Error: '%s' [G4] is not a valid address\n", pArg->ArgString);
			return FALSE;
		}
		
		// Set current address
		pCurrAddr = PLX_CAST_64_TO_8_PTR( (PLX_UINT_PTR)pArg->ArgIntHex );
	}

	//fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] reading from address '%08x' \n" , __FILE__ , __func__ , __LINE__ , (PLX_UINT_PTR)pCurrAddr );
	memset(&buffer , 0x00 , sizeof(buffer) );
	bDone    = FALSE; /* Read till its true !!! */
	do{
		if (i == 0){
			// Set initial number of characters to display
			CharsToPrint = 0;
			
			// Set initial Spaces to insert
			SpacesToInsert = (U8)((((size * 2) + 1) * (16 / size)) + 3);
			
			//Cons_printf("%08x: ", (PLX_UINT_PTR)pCurrAddr);
			//fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] reading from address '%08x' \n" , __FILE__ , __func__ , __LINE__ , (PLX_UINT_PTR)pCurrAddr );
			i++;
		}
		/*if(i <= 5){
			Cons_printf("%08x: ", (PLX_UINT_PTR)pCurrAddr);
		}*/

		// Read the PLX 16bits i.e ONE WORD !!!!
		CurrValue = PlxCm_MemRead_16(pCurrAddr);
		//Cons_printf("%04x ", (U16)CurrValue);


	}while(0);

	//fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] buffer '%d''%d' \n" , __FILE__ , __func__ , __LINE__ , ((U8*)(&CurrValue))[0] , ((U8*)(&CurrValue))[1] );

	
	return CurrValue;

}

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>


//static int soc_fd[4];//pawan
static int soc_fd[MAX_GSM_PORTS-1];
static int cmd_fifo_fd[MAX_GSM_PORTS-1];
//struct sockaddr server_addr[MAX_GSM_PORTS-1];
struct sockaddr_in server_addr[MAX_GSM_PORTS-1];

void start_client_soc( void )
{

#if 1 /* This module if for the UDP Sockets.....*/
	int i = 0;
	struct hostent *host=NULL;
	host= (struct hostent *) gethostbyname((char *)"127.0.0.1");
	//for(i = 0 ; i < 4 ; i++){
	for(i = 0 ; i < 8 ; i++){
		soc_fd[i] = socket(AF_INET, SOCK_DGRAM, 0);
		if ( soc_fd[i] == -1)	{
			perror("socket");
			exit(1);
		}

		server_addr[i].sin_family = AF_INET;
		server_addr[i].sin_port = htons(5001+i);
		server_addr[i].sin_addr = *((struct in_addr *)host->h_addr);
		bzero(&(server_addr[i].sin_zero),8);
	}

#endif

#if 0 /* This module is for the UNIX Socket */
	int i = 0;
	char soc_audio[4][128];
	memset(&soc_audio, 0x00 , sizeof(soc_audio) );

	snprintf(soc_audio[0], sizeof(soc_audio[0])-1 , "/tmp/gsm1.soc" );
	snprintf(soc_audio[1], sizeof(soc_audio[1])-1 , "/tmp/gsm2.soc" );
	snprintf(soc_audio[2], sizeof(soc_audio[2])-1 , "/tmp/gsm3.soc" );
	snprintf(soc_audio[3], sizeof(soc_audio[3])-1 , "/tmp/gsm4.soc" );

	fprintf(stderr,"[ALLO_GSM] staring the loooooooooooooooooooooooooooooooooop \n");
	for(i = 0 ; i < 4 ; i++){
		int t, len;
		struct sockaddr_un remote;
		
		if ((soc_fd[i] = socket(AF_UNIX, SOCK_STREAM, 0 )) == -1) {
			perror("(audio)socket");
			return FALSE;
		}
		fcntl(soc_fd[i] , F_SETFL , O_NONBLOCK );
		
		printf("(audio)Trying to connect...\n");
		
		remote.sun_family = AF_UNIX;
		strcpy(remote.sun_path, soc_audio[i] );
		len = strlen(remote.sun_path) + sizeof(remote.sun_family);
		while (connect( soc_fd[i] , (struct sockaddr *)&remote, len) == -1) {
			perror("(audio)connect");
			sleep(2);
			continue;
		}
		fprintf(stderr,"[ALLO_GSM] connected the socket '%d' going for next \n" , i );
	}
#endif
}

void plx_debug(int debug_level){
	debug = debug_level;
}

BOOLEAN Cem_Int_Notify_Register(PLX_DEVICE_OBJECT *pDevice , PLX_INTERRUPT *PlxInterrupt, PLX_NOTIFY_OBJECT *NotifyObject){

	PlxInterrupt->LocalToPci = (1 << 0);
	PLX_STATUS rc = PlxPci_NotificationRegisterFor( pDevice, PlxInterrupt, NotifyObject );

	if (rc != ApiSuccess){
		fprintf(stderr, "*ERROR* [ALLO_GSM] Couldnt register wait object on Plx...!!\n");
		PlxSdkErrorDisplay(rc);
		return FALSE;
	}
return TRUE;

}

BOOLEAN Cem_Int_Enable(PLX_DEVICE_OBJECT *pDevice , PLX_INTERRUPT *PlxInterrupt, PLX_NOTIFY_OBJECT *NotifyObject){
	if(debug)	printf("'%s':'%s':'%d'[ALLO_GSM] WE are enabling the INTERUPT.........................................................................................\n" , __FILE__ , __func__ , __LINE__  );
	PLX_STATUS rc = PlxPci_InterruptEnable( pDevice, PlxInterrupt );
	if (rc != ApiSuccess){
		fprintf(stderr, "*ERROR* [ALLO_GSM] Inerrupt enable failed..\n");
		PlxSdkErrorDisplay(rc);
		return FALSE;
	}
return TRUE;
}

BOOLEAN Cem_Int_Notify_Cancel(PLX_DEVICE_OBJECT *pDevice , PLX_INTERRUPT *PlxInterrupt, PLX_NOTIFY_OBJECT *NotifyObject){
	PlxPci_NotificationCancel(pDevice, NotifyObject);
return TRUE;
}
	
BOOLEAN Cem_Int_Disable(PLX_DEVICE_OBJECT *pDevice , PLX_INTERRUPT *PlxInterrupt, PLX_NOTIFY_OBJECT *NotifyObject){
	PlxPci_InterruptDisable( pDevice, PlxInterrupt );

return TRUE;
}

PLX_STATUS Cem_IntRead( PLX_DEVICE_OBJECT *pDevice, PLX_INTERRUPT *PlxInterrupt, PLX_NOTIFY_OBJECT *NotifyObject, int card_idx){
		
	PLXCM_COMMAND     *pCmd;
	PLXCM_COMMAND     *pCmd_intr = NULL , *pCmd_intw = NULL	;
	PLX_STATUS        rc;

	char read[128]="";
	char soc_send[128]="";
	char line[LINE_BUFFER_SIZE]="";
	memset(&line , 0x00 , sizeof(line) );
	memset(&read , 0x00 , sizeof(read) );

	do{

		Cem_Int_Enable(pDevice,PlxInterrupt,NotifyObject);

		if(debug)printf("[ALLO_GSM] Waiting for the Inturrept notification\n");
		rc = PlxPci_NotificationWait( pDevice, NotifyObject, 120 * 1000 );
		if(debug)printf("[ALLO_GSM] after Waiting for the Inturrept notification\n");

		Cem_Int_Disable(pDevice,PlxInterrupt,NotifyObject);

		switch (rc){
			case ApiSuccess:
				if(debug)printf("Ok (Int received)\n");
				/************************************************
				 *
				 * Custom code to clear the OEM source of the
				 * interrupt should be placed here.  Another option
				 * is to modify the PLX driver interrupt handler
				 * to perform the souce clear.  In that case, it
				 * will not constantly need to be masked/re-enabled.
				 *
				 ***********************************************/
				/************************************************
				 * After receiving the INturupt we need to read
				 * memory location -- ALLO_GSM --- 14-09-2011  
				 ***********************************************/
				char int_read[64]="";
				snprintf(int_read, sizeof(int_read) , "dw %c2+%04x" , 'V'+card_idx, 124+128+4);
				pCmd_intr = CmdLine_CmdAdd( int_read );
				U16 isr ;
				if(pCmd_intr)	
					isr = Cem_Single_MemRead(pDevice , pCmd_intr );

				if(debug)printf("[ALLO_GSM] Check who has genrated interrupt..:'%d'\n",((U8*)(&isr))[0]);

				char int_write[64]="";
				snprintf(int_write, sizeof(int_write) , "ew %c2+0%01x 00 00" ,'V'+card_idx, 124+128+4);
				pCmd_intw = CmdLine_CmdAdd( int_write );
				if(pCmd_intw)	
					Cmd_MemWrite( pDevice, pCmd_intw );

				if(debug)printf("[ALLO_GSM] Clear interrupt after reading..:'%d'\n",((U8*)(&isr))[0]);

				if( ((U8*)(&isr))[0] != 0 ){
					int gsm_no = 0;
					U8 intreg = ((U8*)(&isr))[0];

					while( gsm_no < 4){
					/* This if condition is for the commands..... */
						U8 intmask = 0x01 << gsm_no;	

						if(debug)printf("[ALLO_GSM] Check interrupt on port:%d mask:%x ireg:%x intr:%d\n", gsm_no+1, intmask, intreg, (intreg & intmask)?1:0);
						if( !(intreg & intmask)){
							gsm_no++;
							continue;
						}

						if(debug)printf("[ALLO_GSM] Got interrupt on :%d \n", gsm_no+1);

						char soc_cmd[128];
						memset(&soc_cmd, 0x00 , sizeof(soc_cmd) );

						snprintf(read , sizeof(read)-1 , "db %c2+%04x", 'V'+card_idx, gsm_no*4 );
						snprintf(soc_cmd, sizeof(soc_cmd)-1 , "/tmp/gsm_ctl_cmd_%d_%d", (gsm_no+1)+(card_idx*4), getuid());

						int len=0;
						pCmd = CmdLine_CmdAdd( read );

						if(pCmd){
							//char *bufptr = malloc(sizeof(line));
							char *bufptr = &line[0]; 
							len=sizeof(line);
#if INCLUDE_NEWLINE
							Cem_MemRead_with_newline(pDevice , pCmd , &bufptr, &len );
#else
							Cem_MemRead(pDevice , pCmd , &bufptr, &len );
#endif

#if 1
							if(len>0){
								if(bufptr[len-1]==0x0c){
									line[len-1]='\0';	/*Data ends with carriage return JUNK DATA FIXME*/
								}
							}


#endif

#if 0 
							if(len>0 && len < sizeof(line))
								memcpy(line, bufptr, len);
							free(bufptr);
#endif
						}

						if(debug)printf("[ALLO_GSM] Read interrupt data on port:%d:addr:%s len:%d  \n", gsm_no+1, read, len);

						if(strlen(line) > 0){
							if(debug) printf("[ALLO_GSM] Got data on port:%d  datalen:'%d'\n" , gsm_no+1, len);
							if(debug) printf("[ALLO_GSM] Got data on port:%d  datalen:'%d' data:>>%s<<\n" , gsm_no+1, len, line);
							if (access(soc_cmd, F_OK) == -1) {
						        if(debug)  fprintf(stderr, "[ALLO_GSM] CMD FIFO not ready drop interreupt on %d..\n", gsm_no+1);
							}else{ 
								int cmd_fifo_fd = open(soc_cmd, O_RDWR );
								if(cmd_fifo_fd < 0)
									perror("open");
								write( cmd_fifo_fd , line , strlen(line) );
								close( cmd_fifo_fd );/* As we send successfully close the client socket..... */
//ast_verbose("[ALLO_GSM] Data Writing on cmd fifo: %s, port:%d card_idx:%d data: \n>>>>\r\n%s\r\n<<<<\n" ,soc_cmd, gsm_no+1, card_idx, line);//pawan print
							}
						}

						gsm_no++;		// increment for check next port interrupt
#ifndef COMMAND_DELETE_END /* ALLO_GSM Deleting ALL commands at the end */
						if(pCmd){
							if(debug)printf("[ALLO_GSM] Free Cmd mem..\n");
							CmdLine_ArgDeleteAll(pCmd);
							free(pCmd);
							pCmd = NULL;
						}
#endif
					}
				}
#ifndef COMMAND_DELETE_END /* ALLO_GSM Deleting ALL commands at the end */
				if(pCmd_intr){	
					if(debug)printf("[ALLO_GSM] Free pCmd_intr mem..\n");
					CmdLine_ArgDeleteAll(pCmd_intr);
					free(pCmd_intr);
					pCmd_intr = NULL;
				}
				if(pCmd_intw){
					if(debug)printf("[ALLO_GSM] Free pCmd_intr mem..\n");
					CmdLine_ArgDeleteAll(pCmd_intw);
					free(pCmd_intw);
					pCmd_intw = NULL;
				}
#endif

				break;
			case ApiWaitTimeout:
				if (debug)Cons_printf(" - Timeout waiting for Int Event\n");
				if (debug)fprintf(stderr, "[ALLO_GSM]  - Timeout waiting for Int Event\n");
				return rc;
				break;
				
			case ApiWaitCanceled:
				Cons_printf("*ERROR* - Interrupt event cancelled\n");
				fprintf(stderr, "[ALLO_GSM] *ERROR* - Interrupt event cancelled\n");
				break;
				
			case ApiInvalidDeviceInfo:
				if (debug )fprintf(stderr, "[ALLO_GSM] *ERROR* - ApiInvalidDeviceInfo\n");
				PlxSdkErrorDisplay(rc);
				return rc;
				break;	
			default:
//				Cons_printf("*ERROR* - API failed\n");
				if (debug )fprintf(stderr, "[ALLO_GSM] *ERROR* - API failed\n");
				if (debug )PlxSdkErrorDisplay(rc);
				break;
		}

		if(debug)printf("  Check notification status...... ");
		rc = PlxPci_NotificationStatus( pDevice, NotifyObject, PlxInterrupt );
		if (rc == ApiSuccess) {
			if(debug)printf("[ALLO_GSM] Ok (triggered ints:");
	//		Cons_printf("Ok (triggered ints:");
			
			//if (PlxInterrupt.LocalToPci & (1 << 0))
			//	Cons_printf(" L->P 1");
			
			//Cons_printf(")\n");
		}else{
			if(debug) fprintf(stderr, "[ALLO_GSM] *ERROR* - API failed\n");
			//Cons_printf("*ERROR* - API failed\n");
			if(debug) PlxSdkErrorDisplay(rc);
		}
	}while (0);

return rc;
}
