#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 )
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <semaphore.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <time.h>
#include <errno.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/file.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>

#include <asterisk.h>
#include <asterisk/module.h>
#include <asterisk/channel.h>
#include <asterisk/config.h>
#include <asterisk/logger.h>
#include <asterisk/pbx.h>
#include <asterisk/options.h>
#include <asterisk/io.h>
#include <asterisk/frame.h>
#include <asterisk/translate.h>
#include <asterisk/cli.h>
#include <asterisk/musiconhold.h>
#include <asterisk/dsp.h>
#include <asterisk/translate.h>
#include <asterisk/file.h>
#include <asterisk/callerid.h>
#include <asterisk/indications.h>
#include <asterisk/app.h>
#include <asterisk/features.h>
#include <asterisk/manager.h>
#include <asterisk/rtp_engine.h>
#include <asterisk/sched.h>
#include <asterisk/configman.h>
#include <asterisk/astobj.h>
#endif

#if ( defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <semaphore.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <time.h>
#include <errno.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/file.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/msg.h>

#include <asterisk.h>
#include <asterisk/module.h>
#include <asterisk/channel.h>
#include <asterisk/config.h>
#include <asterisk/logger.h>
#include <asterisk/pbx.h>
#include <asterisk/options.h>
#include <asterisk/io.h>
#include <asterisk/frame.h>
#include <asterisk/translate.h>
#include <asterisk/cli.h>
#include <asterisk/musiconhold.h>
#include <asterisk/dsp.h>
#include <asterisk/translate.h>
#include <asterisk/file.h>
#include <asterisk/callerid.h>
#include <asterisk/indications.h>
#include <asterisk/app.h>
#include <asterisk/features.h>
#include <asterisk/manager.h>
#include <asterisk/sched.h>

#include <asterisk/configman.h>
#include <asterisk/csel.h>
#endif 

#ifdef ASTERISK_1_4
#include "asterisk.h"
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <net/if.h>
#include <errno.h>
#include <stdlib.h>
#include <fcntl.h>
#include <netdb.h>
#include <signal.h>
#include <sys/signal.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <arpa/inet.h>
#include <netinet/ip.h>
#include <regex.h>

#include "asterisk/lock.h"
#include "asterisk/channel.h"
#include "asterisk/config.h"
#include "asterisk/logger.h"
#include "asterisk/module.h"
#include "asterisk/pbx.h"
#include "asterisk/options.h"
#include "asterisk/sched.h"
#include "asterisk/io.h"
#include "asterisk/rtp.h"
#include "asterisk/udptl.h"
#include "asterisk/acl.h"
#include "asterisk/manager.h"
#include "asterisk/callerid.h"
#include "asterisk/cli.h"
#include "asterisk/app.h"
#include "asterisk/musiconhold.h"
#include "asterisk/dsp.h"
#include "asterisk/features.h"
#include "asterisk/srv.h"
#include "asterisk/astdb.h"
#include "asterisk/causes.h"
#include "asterisk/utils.h"
#include "asterisk/file.h"
#include "asterisk/astobj.h"
#include "asterisk/devicestate.h"
#include "asterisk/linkedlists.h"
#include "asterisk/stringfields.h"
#include "asterisk/monitor.h"
#include "asterisk/localtime.h"
#include "asterisk/abstract_jb.h"
#include "asterisk/compiler.h"
#include "asterisk/threadstorage.h"
#include "asterisk/translate.h"
#include "asterisk/astobj2.h"
#include "asterisk/configman.h"

#ifndef FALSE
#define FALSE    0
#endif

#ifndef TRUE
#define TRUE     1
#endif
#endif

#include "gsmctl.h"
//#include "gsm_version.h"



#include "CmdLine.h"
#include "Monitor.h"
#include "MonCmds.h"
#include "PlxApi.h"
#include "PciRegs.h"
#include "RegDefs.h"
#include "ConsFunc.h"
#include "PlxInit.h"
#include "PlxApi.h"
#include "PexApi.h"



#if 0
#define LOG_DEBUG LOG_ERROR 
#define LOG_WARNING LOG_ERROR 
#define LOG_NOTICE LOG_ERROR 
#endif

void* load_module_thread(void* data);
static int unload_module(void);
static int close_plx();
int gsm_sms_destroy(int port);
int gsm_sms_init(int port);

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
ast_mutex_t gsm_mutex;
#endif
#ifdef ASTERISK_1_4
AST_MUTEX_DEFINE_STATIC(gsm_mutex);
#endif
static int gsm_debug = 0; /* SAM DBG */
static int at_debug[17] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}; 
static int gsm_initialized=0;
static int gsm_save_out_msgs=0;	/* FUTURE CONFIGURATION OPTION */
static int sms_sched_id=0;	

/* we do a-law */
#define GSM_AUDIO_FORMAT 				AST_FORMAT_ALAW
#define REGISTRATION_STATUS_CHECK_PERIOD_SEC		10
#define LCD_UPDATE_DELAY				10

/* and check call status every second for a channel that's dialing out */
#define CALL_STATUS_CHECK_PERIOD_SEC			1
#define SMS_SEND_PERIOD_SEC				10
#define SMS_SENDING					2
#define MAX_FPGA_OFFSET					0x4044
#define GSM_PROJ_ID					0x1234567
#define GSM_PATH_NAME					"/var/spool/asterisk/smsin"
#define DIALPLAN_SMS					1
#define INCLUDE_NEWLINE					1


//static const FILE *fp = NULL;
static int total_plx_devices = 0;


enum cme_error_code {
	CME_ERROR_PHONE_FAILURE = 0,
	CME_ERROR_NO_PHONE_CONNECTION = 1,
	CME_ERROR_PHONE_ADAPTER_LINK_RESERVED = 2,
	CME_ERROR_OPERATION_NOT_ALLOWED = 3,
	CME_ERROR_OPERATION_NOT_SUPPORTED = 4,
	CME_ERROR_PH_SIM_PIN_REQUIRED = 5,
	CME_ERROR_PH_FSIM_PIN_REQUIRED = 6,
	CME_ERROR_PH_FSIM_PUK_REQUIRED = 7,
	CME_ERROR_SIM_NOT_INSERTED = 10,
	CME_ERROR_SIM_PIN_REQUIRED = 11,
	CME_ERROR_SIM_PUK_REQUIRED = 12,
	CME_ERROR_SIM_FAILURE = 13,
	CME_ERROR_SIM_BUSY = 14,
	CME_ERROR_SIM_WRONG = 15,
	CME_ERROR_INCORRECT_PASSWORD_PIN = 16,
	CME_ERROR_SIM_PIN2_REQUIRED = 17,
	CME_ERROR_SIM_PUK2_REQUIRED = 18,
	CME_ERROR_MEMORY_FULL = 20,
	CME_ERROR_INVALID_INDEX = 21,
	CME_ERROR_NOT_FOUND = 22,
	CME_ERROR_MEMORY_FAILURE = 23,
	CME_ERROR_TEXT_STRING_TOO_LONG = 24,
	CME_ERROR_INVALID_CHARS_IN_TEXT_STRING = 25,
	CME_ERROR_DIAL_STRING_TOO_LONG = 26,
	CME_ERROR_INVALID_CHARS_IN_DIALSTRING = 27,
	CME_ERROR_NO_NETWORK_SERVICE = 30,
	CME_ERROR_NETWORK_TIMEOUT = 31,
	CME_ERROR_EMERGENCY_CALLS_ONLY = 32,
	CME_ERROR_NETWORK_PERS_PIN_REQUIRED = 40,
	CME_ERROR_NETWORK_PERS_PUK_REQUIRED = 41,
	CME_ERROR_NETWORK_SUBS_PERS_PIN_REQUIRED = 43,
	CME_ERROR_SERVICE_PROVIDER_PERS_PIN_REQUIRED = 44,
	CME_ERROR_SERVICE_PROVIDER_PERS_PUK_REQUIRED = 45,
	CME_ERROR_CORPORATE_PERS_PIN_REQUIRED = 46,
	CME_ERROR_CORPORATE_PERS_PUK_REQUIRED = 47,
	CME_ERROR_UNKNOWN = 100,
	CME_ERROR_ILLEGAL_MS = 103,
	CME_ERROR_ILLEGAL_ME = 106,
	CME_ERROR_GRPS_SERVICES_NOT_ALLOWED = 107,
	CME_ERROR_PLMN_NOT_ALLOWED = 111,
	CME_ERROR_LOCATION_AREA_NOT_ALLOWED = 112,
	CME_ERROR_ROAMING_NOT_ALLOWED = 113,
	CME_ERROR_SERVICE_OPTION_NOT_SUPPORTED = 132,
	CME_ERROR_REQUESTED_SERVICE_OPTION_NOT_SUBSCRIBED = 133,
	CME_ERROR_SERVICE_OPTION_TEMP_OUT_OF_ORDER =134,
	CME_ERROR_UNSPECIFIED_GPRS_ERROR = 148,
	CME_ERROR_PDP_AUTHENTICATION_FAILURE = 149,
	CME_ERROR_INVALID_MOBILE_CLASS = 150,
	CME_ERROR_AUDIO_MANAGER_NOT_READY = 673,
	CME_ERROR_AUDIO_FORMAT_NOT_CONFIGURED = 674,
	CME_ERROR_SIM_TOOLKIT_NOT_CONFIGURED = 705,
	CME_ERROR_SIM_TOOLKIT_ALREADY_IN_USE = 706,
	CME_ERROR_SIM_TOOLKIT_NOT_ENABLED = 707,
	CME_ERROR_CSCS_TYPE_NOT_SUPPORTED = 737,
	CME_ERROR_CSCS_TYPE_NOT_FOUND = 738,
	CME_ERROR_MUST_INCLUDE_FORMAT_OPER = 741,
	CME_ERROR_INCORRECT_OPER_FORMAT = 742,
	CME_ERROR_OPER_LENGTH_TOO_LONG = 743,
	CME_ERROR_SIM_FULL = 744,
	CME_ERROR_CANNOT_CHANGE_PLMN_LIST = 745,
	CME_ERROR_NETWORK_OP_NOT_RECOGNIZED = 746,
	CME_ERROR_INVALID_COMMAND_LENGTH = 749,
	CME_ERROR_INVALID_INPUT_STRING = 750,
	CME_ERROR_INVALID_SIM_COMMAND = 754,
	CME_ERROR_INVALID_FILE_ID = 755,
	CME_ERROR_MISSING_P123_PARAMETER = 756,
	CME_ERROR_INVALID_P123_PARAMETER = 757,
	CME_ERROR_MISSING_REQD_COMMAND_DATA = 758,
	CME_ERROR_INVALID_CHARS_IN_COMMAND_DATA = 759,
	CME_ERROR_INVALID_INPUT_VALUE = 765,
	CME_ERROR_UNSUPPORTED_VALUE_OR_MODE = 766,
	CME_ERROR_OPERATION_FAILED = 767,
	CME_ERROR_MUX_ALREADY_ACTIVE = 768,
	CME_ERROR_SIM_INVALID_NETWORK_REJECT = 770,
	CME_ERROR_CALL_SETUP_IN_PROGRESS = 771,
	CME_ERROR_SIM_POWERED_DOWN = 772,
	CME_ERROR_SIM_FILE_NOT_PRESENT = 773
};

enum cms_error_code {
	CMS_ERROR_ME_FAILURE = 300,
	CMS_ERROR_SMS_ME_RESERVED = 301,
	CMS_ERROR_OPERATION_NOT_ALLOWED = 302,
	CMS_ERROR_OPERATION_NOT_SUPPORTED = 303,
	CMS_ERROR_INVALID_PDU_MODE = 304,
	CMS_ERROR_INVALID_TEXT_MODE = 305,
	CMS_ERROR_SIM_NOT_INSERTED = 310,
	CMS_ERROR_SIM_PIN_NECESSARY = 311,
	CMS_ERROR_PH_SIN_PIN_NECESSARY = 312,
	CMS_ERROR_SIM_FAILURE = 313,
	CMS_ERROR_SIM_BUSY = 314,
	CMS_ERROR_SIM_WRONG = 315,
	CMS_ERROR_SIM_PUK_REQUIRED = 316,
	CMS_ERROR_SIM_PIN2_REQUIRED = 317,
	CMS_ERROR_SIM_PUK2_REQUIRED = 318,
	CMS_ERROR_MEMORY_FAILURE = 320,
	CMS_ERROR_INVALID_MEMORY_INDEX = 321,
	CMS_ERROR_MEMORY_FULL = 322,
	CMS_ERROR_SMSC_ADDRESS_UNKNOWN = 330,
	CMS_ERROR_NO_NETWORK = 331,
	CMS_ERROR_NETWORK_TIMEOUT = 332,
	CMS_ERROR_UNKNOWN = 500,
	CMS_ERROR_SIM_NOT_READY = 512,
	CMS_ERROR_UNREAD_RECORDS_ON_SIM = 513,
	CMS_ERROR_CB_ERROR_UNKNOWN = 514,
	CMS_ERROR_PS_BUSY = 515,
	CMS_ERROR_SIM_BL_NOT_READY = 517,
	CMS_ERROR_INVALID_CHARS_IN_PDU = 528,
	CMS_ERROR_INCORRECT_PDU_LENGTH = 529,
	CMS_ERROR_INVALID_MTI = 530,
	CMS_ERROR_INVALID_CHAR_IN_ADDRESS = 531,
	CMS_ERROR_INVALID_ADDRESS = 532,
	CMS_ERROR_INVALID_PDU_LENGTH = 533,
	CMS_ERROR_INCORRECT_SCA_LENGTH = 534,
	CMS_ERROR_INVALID_FIRST_OCTECT = 536,
	CMS_ERROR_INVALID_COMMAND_TYPE = 537,
	CMS_ERROR_SRR_BIT_NOT_SET = 538,
	CMS_ERROR_SRR_BIT_SET = 539,
	CMS_ERROR_INVALID_USER_DATA_IN_IE = 540
};


typedef struct error_code {
	int code;
	const char *message;
} error_code_t;


const error_code_t cme_error_codes[] = {
	{ CME_ERROR_PHONE_FAILURE, "phone failure" },
	{ CME_ERROR_NO_PHONE_CONNECTION, "no connection to phone" },
	{ CME_ERROR_PHONE_ADAPTER_LINK_RESERVED, "phone-adaptor link reserved" },
	{ CME_ERROR_OPERATION_NOT_ALLOWED, "operation not allowed" },
	{ CME_ERROR_OPERATION_NOT_SUPPORTED, "operation not supported" },
	{ CME_ERROR_PH_SIM_PIN_REQUIRED, "ph-sim pin required" },
	{ CME_ERROR_PH_FSIM_PIN_REQUIRED, "ph-fsim pin required" },
	{ CME_ERROR_PH_FSIM_PUK_REQUIRED, "ph-fsim puk required" },
	{ CME_ERROR_SIM_NOT_INSERTED, "sim not inserted" },
	{ CME_ERROR_SIM_PIN_REQUIRED, "sim pin required" },
	{ CME_ERROR_SIM_PUK_REQUIRED, "sim puk required" },
	{ CME_ERROR_SIM_FAILURE, "sim failure" },
	{ CME_ERROR_SIM_BUSY, "sim busy" },
	{ CME_ERROR_SIM_WRONG, "sim wrong" },
	{ CME_ERROR_INCORRECT_PASSWORD_PIN, "incorrect password/pin" },
	{ CME_ERROR_SIM_PIN2_REQUIRED, "sim pin2 required" },
	{ CME_ERROR_SIM_PUK2_REQUIRED, "sim puk2 required" },
	{ CME_ERROR_MEMORY_FULL, "memory full" },
	{ CME_ERROR_INVALID_INDEX, "invalid index" },
	{ CME_ERROR_NOT_FOUND, "not found" },
	{ CME_ERROR_MEMORY_FAILURE, "memory failure" },
	{ CME_ERROR_TEXT_STRING_TOO_LONG, "text string too long" },
	{ CME_ERROR_INVALID_CHARS_IN_TEXT_STRING, "invalid characters in text string" },
	{ CME_ERROR_DIAL_STRING_TOO_LONG, "dial string too long" },
	{ CME_ERROR_INVALID_CHARS_IN_DIALSTRING, "invalid characters in dial string" },
	{ CME_ERROR_NO_NETWORK_SERVICE, "no network service" },
	{ CME_ERROR_NETWORK_TIMEOUT, "network timeout" },
	{ CME_ERROR_EMERGENCY_CALLS_ONLY, "network not allowed - emergency calls only" },
	{ CME_ERROR_NETWORK_PERS_PIN_REQUIRED, "network personalization PIN required" },
	{ CME_ERROR_NETWORK_PERS_PUK_REQUIRED, "network personalization PUK required" },
	{ CME_ERROR_NETWORK_SUBS_PERS_PIN_REQUIRED, "network subset personalization PIN required" },
	{ CME_ERROR_SERVICE_PROVIDER_PERS_PIN_REQUIRED, "service provider personalization PIN required" },
	{ CME_ERROR_SERVICE_PROVIDER_PERS_PUK_REQUIRED, "service provider personalization PUK required" },
	{ CME_ERROR_CORPORATE_PERS_PIN_REQUIRED, "corporate personalization PIN required" },
	{ CME_ERROR_CORPORATE_PERS_PUK_REQUIRED, "corporate personalization PUK required" },
	{ CME_ERROR_UNKNOWN, "unknown" },
	{ CME_ERROR_ILLEGAL_MS, "illegal MS" },
	{ CME_ERROR_ILLEGAL_ME, "illegal ME" }, 
	{ CME_ERROR_GRPS_SERVICES_NOT_ALLOWED, "GPRS services not allowed" },
	{ CME_ERROR_PLMN_NOT_ALLOWED, "PLMN not allowed" },
	{ CME_ERROR_LOCATION_AREA_NOT_ALLOWED, "location area not allowed" },
	{ CME_ERROR_ROAMING_NOT_ALLOWED, "roaming not allowed in this location area" },
	{ CME_ERROR_SERVICE_OPTION_NOT_SUPPORTED, "service option not supported" },
	{ CME_ERROR_REQUESTED_SERVICE_OPTION_NOT_SUBSCRIBED, "requested service option not subscribed" },
	{ CME_ERROR_SERVICE_OPTION_TEMP_OUT_OF_ORDER, "service option temporarily out of order" },
	{ CME_ERROR_UNSPECIFIED_GPRS_ERROR, "unspecified GPRS error" },
	{ CME_ERROR_PDP_AUTHENTICATION_FAILURE, "PDP authentication failure" },
	{ CME_ERROR_INVALID_MOBILE_CLASS, "invalid mobile class" },
	{ CME_ERROR_AUDIO_MANAGER_NOT_READY, "audio manager not ready" },
	{ CME_ERROR_AUDIO_FORMAT_NOT_CONFIGURED, "audio format cannot be configured" },
	{ CME_ERROR_SIM_TOOLKIT_NOT_CONFIGURED, "sim toolkit menu has not been configured" },
	{ CME_ERROR_SIM_TOOLKIT_ALREADY_IN_USE, "sim toolkit already in use" },
	{ CME_ERROR_SIM_TOOLKIT_NOT_ENABLED, "sim toolkit not enabled" },
	{ CME_ERROR_CSCS_TYPE_NOT_SUPPORTED, "+CSCS type not supported" },
	{ CME_ERROR_CSCS_TYPE_NOT_FOUND, "CSCS type not found" },
	{ CME_ERROR_MUST_INCLUDE_FORMAT_OPER, "must include <format> with <oper>" },
	{ CME_ERROR_INCORRECT_OPER_FORMAT, "incorrect <oper> format" },
	{ CME_ERROR_OPER_LENGTH_TOO_LONG, "<oper> length too long" },
	{ CME_ERROR_SIM_FULL, "SIM full" },
	{ CME_ERROR_CANNOT_CHANGE_PLMN_LIST, "unable to change PLMN list" },
	{ CME_ERROR_NETWORK_OP_NOT_RECOGNIZED, "network operator not recognized" },
	{ CME_ERROR_INVALID_COMMAND_LENGTH, "invalid command length" },
	{ CME_ERROR_INVALID_INPUT_STRING, "invalid input string" },
	{ CME_ERROR_INVALID_SIM_COMMAND, "invalid SIM command" },
	{ CME_ERROR_INVALID_FILE_ID, "invalid file id" },
	{ CME_ERROR_MISSING_P123_PARAMETER, "missing required P1/2/3 parameter" },
	{ CME_ERROR_INVALID_P123_PARAMETER, "invalid P1/2/3 parameter" },
	{ CME_ERROR_MISSING_REQD_COMMAND_DATA, "missing required command data" },
	{ CME_ERROR_INVALID_CHARS_IN_COMMAND_DATA, "invalid characters in command data" },
	{ CME_ERROR_INVALID_INPUT_VALUE, "invalid input value" },
	{ CME_ERROR_UNSUPPORTED_VALUE_OR_MODE, "unsupported value or mode" },
	{ CME_ERROR_OPERATION_FAILED, "operation failed" },
	{ CME_ERROR_MUX_ALREADY_ACTIVE, "multiplexer already active" },
	{ CME_ERROR_SIM_INVALID_NETWORK_REJECT, "sim invalid - network reject" },
	{ CME_ERROR_CALL_SETUP_IN_PROGRESS, "call setup in progress" },
	{ CME_ERROR_SIM_POWERED_DOWN, "sim powered down" },
	{ CME_ERROR_SIM_FILE_NOT_PRESENT, "sim file not present" }
};


const error_code_t cms_error_codes[] = {
	{ CMS_ERROR_ME_FAILURE, "ME failure" },
	{ CMS_ERROR_SMS_ME_RESERVED, "SMS ME reserved" },
	{ CMS_ERROR_OPERATION_NOT_ALLOWED, "operation not allowed" },
	{ CMS_ERROR_OPERATION_NOT_SUPPORTED, "operation not supported" },
	{ CMS_ERROR_INVALID_PDU_MODE, "invalid PDU mode" },
	{ CMS_ERROR_INVALID_TEXT_MODE, "invalid text mode" },
	{ CMS_ERROR_SIM_NOT_INSERTED, "SIM not inserted" },
	{ CMS_ERROR_SIM_PIN_NECESSARY, "SIM PIN necessary" },
	{ CMS_ERROR_PH_SIN_PIN_NECESSARY, "PH SIM pin necessary" },
	{ CMS_ERROR_SIM_FAILURE, "SIM failure" },
	{ CMS_ERROR_SIM_BUSY, "SIM busy" },
	{ CMS_ERROR_SIM_WRONG, "SIM wrong" },
	{ CMS_ERROR_SIM_PUK_REQUIRED, "SIM PUK required" },
	{ CMS_ERROR_SIM_PIN2_REQUIRED, "SIM PIN2 required" },
	{ CMS_ERROR_SIM_PUK2_REQUIRED, "SIM PUK2 required" },
	{ CMS_ERROR_MEMORY_FAILURE, "memory failure" },
	{ CMS_ERROR_INVALID_MEMORY_INDEX, "invalid memory index" },
	{ CMS_ERROR_MEMORY_FULL, "memory full" },
	{ CMS_ERROR_SMSC_ADDRESS_UNKNOWN, "SMSC address unknown" },
	{ CMS_ERROR_NO_NETWORK, "no network" },
	{ CMS_ERROR_NETWORK_TIMEOUT, "network timeout" },
	{ CMS_ERROR_UNKNOWN, "unknown" },
	{ CMS_ERROR_SIM_NOT_READY, "SIM not ready" },
	{ CMS_ERROR_UNREAD_RECORDS_ON_SIM, "unread records on SIM" },
	{ CMS_ERROR_CB_ERROR_UNKNOWN, "CB error unknown" },
	{ CMS_ERROR_PS_BUSY, "PS busy" },
	{ CMS_ERROR_SIM_BL_NOT_READY, "SM BL not ready" },
	{ CMS_ERROR_INVALID_CHARS_IN_PDU, "Invalid (non-hex) chars in PDU" },
	{ CMS_ERROR_INCORRECT_PDU_LENGTH, "Incorrect PDU length" },
	{ CMS_ERROR_INVALID_MTI, "Invalid MTI" },
	{ CMS_ERROR_INVALID_CHAR_IN_ADDRESS, "Invalid (non-hex) chars in address" },
	{ CMS_ERROR_INVALID_ADDRESS, "Invalid address (no digits read)" },
	{ CMS_ERROR_INVALID_PDU_LENGTH, "Incorrect PDU length (UDL)" },
	{ CMS_ERROR_INCORRECT_SCA_LENGTH, "Incorrect SCA length" },
	{ CMS_ERROR_INVALID_FIRST_OCTECT, "Invalid first octet (should be 2 or 34)" },
	{ CMS_ERROR_INVALID_COMMAND_TYPE, "Invalid Command Type" },
	{ CMS_ERROR_SRR_BIT_NOT_SET, "SRR bit not set" },
	{ CMS_ERROR_SRR_BIT_SET, "SRR bit set" },
	{ CMS_ERROR_INVALID_USER_DATA_IN_IE, "Invalid User Data Header IE" }
};





/* the main schedule context for stuff like l1 watcher, overlap dial, ... */
static struct sched_context *gsm_tasks = NULL;
static pthread_t gsm_tasks_thread;
//static pthread_t _gsm_restart_threads[MAX_GSM_PORTS];

static void _init_mod_port(int port);
int _gsm_shutdown_port(int port, int powercycle);
int gsm_cleanup();

const char tdesc[]="GSM driver";

static int gsm_text(struct ast_channel *c, const char *text);
static int gsm_call(struct ast_channel *c, char *dest, int timeout);
static int gsm_answer(struct ast_channel *c);
static int gsm_hangup(struct ast_channel *c);
static int gsm_write(struct ast_channel *c, struct ast_frame *f);
static struct ast_frame *gsm_read(struct ast_channel *c);
static struct ast_frame *gsm_read_dtmf(struct ast_channel *c, char *event);

static int gsm_fixup(struct ast_channel *oldchan, struct ast_channel *newchan);
#if 1
static int gsm_digit_begin(struct ast_channel *c, char digit);
static int gsm_indicate(struct ast_channel *c, int cond, const void *data, size_t datalen);
static int gsm_digit_end(struct ast_channel *c, char digit, unsigned int duration);
#else
static int gsm_indicate(struct ast_channel *c, int cond);
static int gsm_digit_end(struct ast_channel *c, char digit);
#endif
#ifdef ASTERISK_11_4
static struct ast_channel *gsm_request(const char *type, struct ast_format_cap *cap, const struct ast_channel *requestor, const char *data, int *cause);
#endif
//#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 )
#ifdef ASTERISK_10_4
static struct ast_channel *gsm_request(const char *type, struct ast_format_cap *cap, const struct ast_channel *requestor, void *data, int *cause);
#endif
#ifdef ASTERISK_1_8
static struct ast_channel *gsm_request(const char *type, format_t format, const struct ast_channel *requestor , void *gsm_data, int *cause);
#endif
#if (defined ASTERISK_1_4 || defined ASTERISK_1_6_2)
static struct ast_channel *gsm_request(const char *type, int format, void *gsm_data, int *cause);
#endif

static void _gsm_restart_port(int port, int postwait);
static int _gsm_send_sms(int port, const char *number, const char *sms);
static int _gsm_queue_sms(int port, const char *number, const char *sms);
static int check_and_fetch_port(int port);
static void gsm_send_channel_state(int channel, int state);
static int _gsm_read_sms(int port, int smsnum);

static struct ast_channel_tech gsm_tech = {
	.type = "GSM",
	.description = tdesc,
#if ( defined ASTERISK_1_4 || defined ASTERISK_1_6_2 || defined ASTERISK_1_8 )
        .capabilities = AST_FORMAT_ULAW,
#endif
	.requester = gsm_request,
#if 1
	.send_digit_begin = gsm_digit_begin,
	.send_digit_end = gsm_digit_end,
#else
	.send_digit= gsm_digit_end,
#endif
	.send_text = gsm_text,
	.hangup = gsm_hangup,
	.answer = gsm_answer,
	.read = gsm_read,
	.call = gsm_call,
	.write = gsm_write,
	.indicate = gsm_indicate,
	.fixup = gsm_fixup,
};

enum gsm_state {
	GSM_STATE_ATD_OUT,
	GSM_STATE_PROCEEDING,
	GSM_STATE_ALERTING,
	GSM_STATE_ANSWERED,
	GSM_STATE_HANGUPED,
	GSM_STATE_RINGING,
	GSM_STATE_NONE,
	GSM_STATE_COLLISION,
	GSM_STATE_PRE_ATD
};

enum channel_state {
	CHANNEL_STATE_DOWN,
	CHANNEL_STATE_IN_USE,
	CHANNEL_STATE_READY
};

enum channel_call_type {
	GSM_CALL_TYPE_VOICE,
	GSM_CALL_TYPE_SMS
};

#define GSM_STATE_DOWN 		"CHANNEL_DOWN"
#define GSM_STATE_IN_USE 	"CHANNEL_IN_USE"
#define GSM_STATE_READY		"CHANNEL_READY"

static char default_context[]="default";
static char default_exten[]="s";


static struct gsm_config gsm_cfg[MAX_GSM_PORTS];

/*DON'T FORGET THE STRING ARRAY (Status2txt)!!*/
enum gsm_status {
		GSM_STATUS_NOTCONFIGURED=0,
		GSM_STATUS_UNAVAILABLE,
		GSM_STATUS_UNINITIALIZED,
		GSM_STATUS_INITIALIZED,
		GSM_STATUS_UNREGISTERED,
		GSM_STATUS_REGISTERED,
};

char *status2txt[]={
		"NOT CONFIGURED",
		"UNAVAILABLE",
		"UNINITIALIZED",
		"INITIALIZED",
		"UNREGISTERED",
		"REGISTERED"
};

enum gsm_sms_work {
	GSM_SMS_WORK_SHOW=0,
	GSM_SMS_WORK_FETCH,
	GSM_SMS_WORK_FLUSH,
	GSM_SMS_WORK_READ_LAST_MSG,
};
#ifdef INCLUDE_NEWLINE
enum gsm_sms_recv_state {
	GSM_SMS_RECV_NONE=0,
	GSM_SMS_RECV_CMGR,
	GSM_SMS_RECV_BODY,
	GSM_SMS_RECV_OK,
};
#endif

enum gsm_sms_state {
	GSM_SMS_STATE_NONE=0,
	GSM_SMS_STATE_EXPECTING_OK,
	GSM_SMS_STATE_EXPECTING_PROMPT,
	GSM_SMS_STATE_EXPECTING_SMSLIST,
	GSM_SMS_STATE_SMS_SENT,
	GSM_SMS_STATE_SMS_OK,
	GSM_SMS_STATE_LIST,
	GSM_SMS_STATE_GET_TEXT,
	GSM_SMS_STATE_FLUSHING,
	GSM_SMS_STATE_EXPECTING_SMS,
};

#define SMS_MSG_SZ	162
#define SMS_PART_MSG_SZ	256
#define SMS_NUM_SZ	32
#define MAX_WAITING_SMS 25 
struct gsm_sms_message {
	int mtype;
	int idx;
	char number[SMS_NUM_SZ];
	char date[32];
	char text[SMS_MSG_SZ];
	int pdu_len;
};

struct gsm_sms_msg_item {
	long mtype;
	struct gsm_sms_message msg;
}; 

struct gsm_sms {
	enum gsm_sms_state state;
	char sms[SMS_MSG_SZ];
	char sms_part[SMS_PART_MSG_SZ];
	char number[SMS_NUM_SZ];

	enum gsm_sms_work work;
#ifdef INCLUDE_NEWLINE
	enum gsm_sms_recv_state sms_recv_state;
#endif
	int last_sms_idx;

	/*index on sim card at which msg is stored. This index number will help to receive sms based on index no.*/
	int index__waiting_incoming_sms[MAX_WAITING_SMS]; 
	int number__waiting_incoming_sms;	/*Number of sms waiting to be read from sim to asterisk*/

	int incoming_sms_counter;

	/*manager stuff*/
	struct mansession *s;
	struct message *m;

	struct gsm_sms_message inbound_msg; /* temporary message, where we work on*/
	struct gsm_sms_message outbound_msg; /* temporary message, where we work on*/
	int sms_mq_id;	/* socket id */
	int soc_id;	/* socket id */
	char soc_filename[64];
	int retry;

} gsm_sms[MAX_GSM_PORTS];

char *rssi2txt(int rssi, int status) {
	static char txt[8];
	if (status != GSM_STATUS_REGISTERED)
		return "not measurable";

	if (rssi == 99)
		return "not measurable";
	if (rssi == 0)
		return "<= -113 dbm";
	if (rssi == 31)
		return ">= -51dbm";

	sprintf(txt, "-%d dbm", 113 - 2 * rssi);
	return txt;
}

struct gsm_status_s {
		int status;
		char provider[128];
		int homezone;
		int rssi;
} gsm_status[MAX_GSM_PORTS];

struct gsm_pvt {
	enum gsm_state state;
	enum channel_call_type call_type;
	int port;
	int portfd;
	char context[256];
	char exten[256];
	struct ast_channel *ast_chan;
	struct ast_frame read_f;
	char readbuf[160];
	int hidecallerid;
	struct ast_dsp *dsp;
	struct ast_trans_pvt *trans;
	int dropcnt ;
};

/** Config Stuff **/

/*
 * Global Variables
 */


/*see doc p.151*/
struct gsm_slcc {
	int idx,dir,stat,mode,mpty,tca;
	enum channel_state channel_state;
	char callerid[64];
	int type;
	int ringcount;
	int ringing;
} gsm_slcc[MAX_GSM_PORTS];


struct csel_groups {
	char *name;
	struct csel *cs;
} csel_groups[MAX_GSM_PORTS];


#define CONFIG_FILE     "gsm.conf"
#define GROUPNAME_MAX   128

static cm_t *config = NULL;

/*
 * Configuration
 */
static const cm_dir_t gen_dirs[] = {
	{},
	{ "debug", "0", "debug level" },
	{ "syslogdebug","no", "Say yes to debug in syslog with identy 'chan_gsm'." },
	{ "smsdir", "/var/spool/asterisk/smsin", "The directory where inbound sms are stored" },
	{ "smsdialplan", "yes", "Enable of Disable receiving of sms in dialplan(Default Enable)" },
	{ "smsbak", "yes", "Take backup of msg received in path specified by smsdir. Take a look at var smsdel" },
	{ "smsdel", "yes", "Delete SMS from SIM memory as soon as message is received. Enable smsbak to avoid non receipt" },
	{ "check_homezone", "no", "whether the homezone should be checked every 10 seconds." },
	{ "skip_plus", "no", "if the number comes with a '+' prefix, we skip it." },
	{ "relaxdtmf", "no", "whether radio/gsm optimzed dtmf detection mechanism should be used" },
	{ "dtmfbegin", "yes", "whether dtmf regeneration should start at the beginning of the dtmf frame" },
};

enum {
	CFG_GEN_NAME = 0,
	CFG_GEN_DEBUG,
	CFG_GEN_SYSLOG_DEBUG,
	CFG_GEN_SMS_DIR,
	CFG_GEN_SMS_DIALPLAN,
	CFG_GEN_SMS_BAK,
	CFG_GEN_SMS_DEL,
	CFG_GEN_CHEKHZ,
	CFG_GEN_SKIP_PLUS,
	CFG_GEN_RELAXDTMF,
	CFG_GEN_DTMFBEGIN,
};

static const cm_dir_t port_dirs[] = {
	{ "name", 0, "name of the group" },
	{ "channel", 0, "comma separated list of channel numbers" },
	{ "slot", 0, "default slot (none given means 0)" },
	{ "pin", "", "PIN for all ports in this group" },
	{ "context", "default", "context to use for incoming calls" },
	{ "exten", "s", "extension to use for incoming calls" },
	{ "initfile", "", "filename containing an alternative module init sequence" },
	{ "hidecallerid", "no", "if set to yes hide the callerid" },
	{ "smsc", "", "The number of your SMS Service Provider" },
	{ "sms_pdu_mode", "", "If the SMS should be provided in PDU or ClearText mode." },
	{ "provider", "", "Name of your GSM Provider (Number Format, try \"gsm show ops\" to get a list of all possible values" },
	{ "method", "standard", "Strategy for choosing channels in a group." },
	{ "cid_prefix", "", "If the callerid comes without Internation Code and without '+' prefix, the cidprefix is used as prefix." },
	{ "resetinterval", "0", "If you want chan_gsm to restart a module periodically, set this to the amount of seconds which should expire.\n After this time has expired chan_gsm will check if there is a call on this channel and if not restart it, else it will wait again." },
	{ "rxgain", 0, "GSM receive gain setting, set this to a number between -10 and +10 (0 for default values)" },
	{ "txgain", 0, "GSM transmit gain setting, set this to a number between -10 and +10 (0 for default values)" },
	{ "dtmfduration", "100", "whether dtmf regeneration should start at the beginning of the dtmf frame" },
	{ "early_media", "yes", "if set to no, disable early media" },
};

enum {
	CFG_PORT_NAME = 0,
	CFG_PORT_PORTS,
	CFG_PORT_SLOT,
	CFG_PORT_PIN,
	CFG_PORT_CONTEXT,
	CFG_PORT_EXTEN,
	CFG_PORT_INITFILE,
	CFG_PORT_HIDECALLERID,
	CFG_PORT_SMSC,
	CFG_PORT_SMS_PDU_MODE,
	CFG_PORT_PROVIDER,
	CFG_PORT_METHOD,
	CFG_PORT_CID_PREFIX,
	CFG_PORT_RESET_INTERVAL,
	CFG_PORT_RX_GAIN,
	CFG_PORT_TX_GAIN,
	CFG_PORT_DTMF_DURATION,
	CFG_PORT_EARLY_MEDIA,
	};

static const cm_section_t config_sections[] = {
	{ "general", NULL, NULL, KTYPE_NONE, sizeof(gen_dirs) / sizeof(cm_dir_t), gen_dirs},
	{ "port", "default", "channel", KTYPE_INTEGER, sizeof(port_dirs) / sizeof(cm_dir_t), port_dirs},
};

enum {
	SECT_GENERAL = 0,
	SECT_PORT
};



/* we could merge the two functions into a common one */

const char *gsm_get_cms_text(int cms_code)
{
	const int cms_list_size = sizeof(cms_error_codes) / sizeof(error_code_t);
	int found = 0;
	int ii;

	for (ii = 0; ii < cms_list_size; ii++) {
		if (cms_error_codes[ii].code == cms_code) {
			found = 1;
			break;
		}
	}

	if (found) {
		return (&cms_error_codes[ii].message[0]);
	} else {
		return NULL;
	}
}	

const char *gsm_get_cme_text(int cme_code)
{
	const int cme_list_size = sizeof(cme_error_codes) / sizeof(error_code_t);
	int found = 0;
	int ii;

	for (ii = 0; ii < cme_list_size; ii++) {
		if (cme_error_codes[ii].code == cme_code) {
			found = 1;
			break;
		}
	}

	if (found) {
		return (&cme_error_codes[ii].message[0]);
	} else {
		return NULL;
	}
}






//static int gsm_config_init (void)
int gsm_config_init (void)
{
	if (!(config = cm_create("allogsm", config_sections, sizeof(config_sections) / sizeof(cm_section_t)))) {
		ast_log(LOG_ERROR, "failed to initialize config manager!\n");
		goto err1;
	}

	if (cm_load(config, CONFIG_FILE)) {
		ast_log(LOG_ERROR, "failed to load config file: %s\n", CONFIG_FILE);
		goto err2;
	}

	return 0;

err2:
	cm_destroy(config);
	config = NULL;
err1:
	return -1;
}

static void gsm_config_exit (void)
{
	if (config) {
		cm_destroy(config);
		config = NULL;
	}
}

#if 0
#if (defined ASTERISK_10_4 || defiend ASTERISK_1_8 || defined ASTERISK_1_6_2)
		/*ast_log(LOG_WARNING, "Port: %d not configured\n", bb); \*/
#define CLI_CHECK_PORT(bb) { \
	if ( gsm_status[bb].status == GSM_STATUS_NOTCONFIGURED) { \
		ast_cli(a->fd, "Port: %d not configured\n", bb); \
		ast_log(LOG_WARNING , "[ALLO_GSM] Port: %d not configured \n" , bb );
		return CLI_FAILURE; 	\
	}	\
}
#endif
#endif

#if 0
		/*ast_log(LOG_WARNING, "Port: %d not configured\n", bb); \*/
#define CLI_CHECK_PORT(bb) { \
	if ( gsm_status[bb].status == GSM_STATUS_NOTCONFIGURED) { \
		ast_cli(fd, "Port: %d not configured\n", bb); \
		ast_log(LOG_WARNING , "[ALLO_GSM] Port: %d not configured \n" , bb );
		return RESULT_FAILURE; 	\
	}	\
}
#endif
/** LCD STUFF **/
static void gsm_send_channel_state(int channel, int state)
{
//	const char channel_name[] = "gsm";
	char channel_state[GSM_MAX_STR];
//	int channel_number;

	memset(channel_state, 0, sizeof(channel_state));

	switch (state) {
		case CHANNEL_STATE_DOWN:
			strncpy(channel_state, GSM_STATE_DOWN, GSM_MAX_STR);
			break;
		case CHANNEL_STATE_IN_USE:
			strncpy(channel_state, GSM_STATE_IN_USE, GSM_MAX_STR);
			break;
		case CHANNEL_STATE_READY:
			strncpy(channel_state, GSM_STATE_READY, GSM_MAX_STR);
			break;
		default:
			break;
	}

#if 0
	channel_number = channel + gsm_get_channel_offset();
	if ((gsm_translate_channel(&channel_number, channel) >= 0) && (strlen(channel_state))) {
		if (gsm_debug)
			ast_log(LOG_DEBUG, "channel (%d) ---> channel_number (%d) state (%d)\n",
				channel, channel_number, state);
		manager_event(EVENT_FLAG_SYSTEM,
				"ChannelStatus",
				"Channel: PIKA/%s/%d\r\nState: %s\r\n", channel_name, channel_number, channel_state);
	}
#endif
}

static void gsm_set_channel_state(int channel, int state)
{
	if ((channel >= 1) && (channel < MAX_GSM_PORTS)) {
		gsm_slcc[channel].channel_state = state;
	}
}

static int gsm_get_channel_state(int channel, enum channel_state *state)
{
	if ((gsm_port_is_valid(channel)) && ((channel >= 1) && (channel < MAX_GSM_PORTS))) {
		*state = gsm_slcc[channel].channel_state;
		return 0;
	} else {
		return -1;
	}
}

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_request_state(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_request_state(int fd, int argc, char *argv[])
#endif
{
	enum channel_state channel_state;
	int ii;

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm request state";
		e->usage = "Usage: for astmanproxy only\n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif
	for (ii = 0; ii < MAX_GSM_PORTS; ii++) {
		if ((gsm_port_is_valid(ii)) && (gsm_get_channel_state(ii, &channel_state)>=0)) {	
			gsm_send_channel_state(ii, channel_state);
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
			ast_cli(a->fd, "sending state (%d) for channel (%d)\n", channel_state, ii);
#endif
#ifdef ASTERISK_1_4
			ast_cli(fd, "sending state (%d) for channel (%d)\n", channel_state, ii);
#endif
			usleep(500 * 1000); /* TODO : check */
		}
	}

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	return CLI_SUCCESS;
#endif
#ifdef ASTERISK_1_4
	return RESULT_SUCCESS;
#endif
}

void restart_plx( void );

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_restart_plx(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_restart_plx(int fd, int argc, char *argv[])
#endif
{
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm restart plx";
		e->usage = "Usage: allogsm show info\n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif

	restart_plx();
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	ast_cli(a->fd, " Plx reinitialization success !!!!! \n");

	return CLI_SUCCESS;
#endif
#ifdef ASTERISK_1_4
	ast_cli(fd, " Plx reinitialization success !!!!! \n");
	return RESULT_SUCCESS;
#endif

}


#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_show_info(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_show_info(int fd, int argc, char *argv[])
#endif
{
	int gsm_channel_mask = gsm_get_channel_mask();
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm show info";
		e->usage = "Usage: allogsm show info\n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	ast_cli(a->fd, "Gsm Mask:          0x%04x\n", gsm_channel_mask);
	return CLI_SUCCESS;
#endif
#ifdef ASTERISK_1_4
	ast_cli(fd, "Gsm Mask:          0x%04x\n", gsm_channel_mask);
	return RESULT_SUCCESS;
#endif
}

/** CLI STUFF **/
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_send_at(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_send_at(int fd, int argc, char *argv[])
#endif
{
	char *portstr, *command, *p;
	int port;

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm send at";
		e->usage = "Usage: allogsm send at <port> \"<command>\"\n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
        if (a->argc != 5)
                return CLI_SHOWUSAGE;

        portstr = a->argv[3];
        command = strdup(a->argv[4]);
#endif
#ifdef ASTERISK_1_4
        if (argc != 5)
                return RESULT_SHOWUSAGE;

        portstr = argv[3];
        command = strdup(argv[4]);
#endif

	port=atoi(portstr);

	//CLI_CHECK_PORT(port);

	while( (p=strchr(command,'/')) )
		*p='?';

	gsm_send(port, command, 100);

	free (command);
    	command = NULL;

	return 0;
}


#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_send_sms_end(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_send_sms_end(int fd, int argc, char *argv[])
#endif
{
	char *portstr;
	int port;

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm send sms end";
		e->usage = "Usage: allogsm send sms end <port> \n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
        if (a->argc != 5)
                return CLI_SHOWUSAGE;
        portstr = a->argv[4];
#endif
#ifdef ASTERISK_1_4
        if (argc != 5)
                return RESULT_SHOWUSAGE;
        portstr = argv[4];
#endif

	port=atoi(portstr);

		ast_log(LOG_ERROR , "[ALLO_GSM] we are calling the sms end command for port %d???????????????\n", port );
	gsm_send_sms_end(port);


	return 0;
}


/*************** Helpers END *************/
static void sighandler(int sig)
{
	ast_verbose("[ALLO_GSM] Here got SIGUSR1..\n");
}

static int gsm_sms_sender_func(const void *data);
static void* gsm_tasks_thread_func (void *data)
{
	int wait;
#if 1
	struct sigaction sa;

	sa.sa_handler = sighandler;
	sa.sa_flags = SA_NODEFER;
	sigemptyset(&sa.sa_mask);
	sigaddset(&sa.sa_mask, SIGUSR1);
	sigaction(SIGUSR1, &sa, NULL);

#endif
#if 0
	sem_post((sem_t *)data);
#endif
	
	if(gsm_debug) ast_log(LOG_DEBUG, "gsm_tasks_thread_func start\n");

	while (1) {
		wait = ast_sched_wait(gsm_tasks);
		if (wait < 0)
			wait = 8000;
		if (poll(NULL, 0, wait) < 0)
			ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Waking up gsm_tasks thread\n");
		ast_sched_runq(gsm_tasks);
	}

	ast_verbose("gsm_tasks_thread_func stop\n");
pthread_exit(NULL);
return NULL;
}

static void gsm_tasks_init (void)
{
	sem_t blocker;
//	int i = 1;

#if 0
	if (sem_init(&blocker, 0, 0)) {
		perror("chan_gsm: Failed to initialize semaphore!");
		exit(1);
	}
#endif

	ast_log(LOG_DEBUG, "Starting gsm_tasks thread\n");


#if ( defined ASTERISK_1_8 || defined ASTERISK_1_6_2 || defined ASTERISK_1_4)
	gsm_tasks = sched_context_create();
#endif
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 )

	gsm_tasks = ast_sched_context_create();
#endif
        if (gsm_tasks==NULL){
                ast_verbose("%s:%s:%d:Failed to Obtain Context id For gsm_tasks\n", __FILE__, __func__, __LINE__);
                return;
        }
	pthread_create(&gsm_tasks_thread, NULL, gsm_tasks_thread_func, &blocker);

#if 0
#if 0
	pthread_join(gsm_tasks_thread, NULL);
#else
	while (sem_wait(&blocker) && --i);
#endif
	sem_destroy(&blocker);
#endif
}
static void gsm_tasks_destroy (void)
{
	if (gsm_tasks) {
		if(gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Killing gsm_tasks thread\n");
		if ( pthread_cancel(gsm_tasks_thread) == 0 ) {
			if(gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Joining gsm_tasks thread\n");
			pthread_join(gsm_tasks_thread, NULL);
		}
#if ( defined ASTERISK_1_8 || defined ASTERISK_1_6_2 || defined ASTERISK_1_4)
		sched_context_destroy(gsm_tasks);
#endif
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 )
               ast_sched_context_destroy(gsm_tasks);
#endif
		gsm_tasks = NULL;
	}
}

static inline void gsm_tasks_wakeup (void)
{
	pthread_kill(gsm_tasks_thread, SIGUSR1);
}

static inline int _gsm_tasks_add_variable (int timeout, ast_sched_cb callback, void *data, int variable)
{
	int task_id;

	if (!gsm_tasks) {
		gsm_tasks_init();
	}
        if (!gsm_tasks) {
                return 0;
        }
	task_id = ast_sched_add_variable(gsm_tasks, timeout, callback, data, variable);
//	gsm_tasks_wakeup();

	return task_id;
}

static int gsm_tasks_add (int timeout, ast_sched_cb callback, void *data)
{
	return _gsm_tasks_add_variable(timeout, callback, data, 0);
}
#if 0
static int gsm_check_homezone(const void *data)
{
	int port;

	for (port=0; port < MAX_GSM_PORTS; port++) {
		if (gsm_status[port].status == GSM_STATUS_REGISTERED) {
			gsm_send(port, "AT+CSQ", 0); /*query the signal strength */
			if (gsm_debug)
				ast_log(LOG_DEBUG, "Check the homezone for port %d\n", port);
		}
	}

	return 1;
}
#endif

/* function to send sms messages */
static int gsm_sms_sender_func(const void *data)
{
#if 1
	int msglen = sizeof(struct gsm_sms_message) - sizeof(long);
#else
	int msglen = sizeof(struct gsm_sms_message);
#endif
	struct ast_channel *ast;
	struct gsm_pvt *gsm=NULL;
	int port, retval;
	for (port=0; port < MAX_GSM_PORTS; port++) {
		/* the port must be registered, so that we can send SMS messages */
		/* the port must not be busy doing call setups, and we must have a message to send */
		/* note that we cannot and we do not block on this function */
		if ((gsm_status[port].status == GSM_STATUS_REGISTERED) && \
		    (gsm_sms[port].state == GSM_SMS_STATE_NONE)) {
			/* we don't send SMS messages during call establishment */
		 	if (gsm_slcc[port].ringing) {
				if (gsm_debug)
					ast_log(LOG_DEBUG, "skipping port(%d) sms send as we have an incoming call\n", port);
				continue;
			}	
			/* we do this when we're idle or already in a call */
			if ((ast=gsm_get_priv(port))) {
#ifdef ASTERISK_11_4
				if ( (gsm = ast_channel_tech_pvt(ast)) && \
				     ( (gsm_port_in_use_get(port)) || \
				       (gsm->state == GSM_STATE_ATD_OUT) || \
				       (gsm->state == GSM_STATE_PRE_ATD) || \
				       (gsm->state == GSM_STATE_PROCEEDING) || \
				       (gsm->state == GSM_STATE_ALERTING) /*|| \
				       (gsm->state == GSM_STATE_HANGUPED) || \   FIXME: currently not working
				       (gsm->state == GSM_STATE_RINGING) */
				     )
				   ) {
#else
				if ( (gsm = ast->tech_pvt) && \
				     ( (gsm_port_in_use_get(port)) || \
				       (gsm->state == GSM_STATE_ATD_OUT) || \
				       (gsm->state == GSM_STATE_PRE_ATD) || \
				       (gsm->state == GSM_STATE_PROCEEDING) || \
				       (gsm->state == GSM_STATE_ALERTING) /*|| \
				       (gsm->state == GSM_STATE_HANGUPED) || \   FIXME: currently not working
				       (gsm->state == GSM_STATE_RINGING)*/
				     )
				   ) {
#endif
					if (gsm_debug)
						ast_log(LOG_DEBUG, "skipping port(%d) sms send as we are now setting up a call\n", port);
					continue;
				}
			}
			/* get the message and send it out */
#if 0
                        if ((retval = msgrcv(gsm_sms[port].sms_mq_id, &gsm_sms[port].outbound_msg, msglen, 1, IPC_NOWAIT)) > 0) {
					ast_log(LOG_NOTICE, "Message Queue :%d: port :%d: outbound_msg.text '%s' \n", gsm_sms[port].sms_mq_id, port , gsm_sms[port].outbound_msg.text );
				if (gsm_debug)
                                        ast_verbose(CHAN_GSM_VERBOSE_PREFIX " SMS SEND :%s:%s:%d \n", __FILE__, __func__, __LINE__);
#else
			if ((retval = read(gsm_sms[port].soc_id, &gsm_sms[port].outbound_msg, msglen)) > 0) {
					ast_log(LOG_DEBUG, "Message Queue :%d: port :%d: outbound_msg.text '%s' \n", gsm_sms[port].soc_id, port , gsm_sms[port].outbound_msg.text );
#endif
				/* send the message */
				_gsm_send_sms(port, gsm_sms[port].outbound_msg.number, gsm_sms[port].outbound_msg.text);
				gsm_sms[port].incoming_sms_counter=(gsm_sms[port].incoming_sms_counter) - 1;	
//	                       sms_sched_id=ast_sched_replace_variable(sms_sched_id,gsm_tasks,SMS_SENDING*1000,gsm_sms_sender_func, NULL ,0); // Reschedule SMS thread
			/* print more debug output here */
				if (gsm_debug)
                                        ast_verbose(CHAN_GSM_VERBOSE_PREFIX " OUT OF SMS SEND :%s:%s:%d \n", __FILE__, __func__, __LINE__);
				if (gsm_debug) 
					ast_log(LOG_VERBOSE, "sending SMS message (%s) to (%s) on port (%d)\n",
						gsm_sms[port].outbound_msg.text,
						gsm_sms[port].outbound_msg.number,
						port);
			} else {
				if (gsm_debug){
					//ast_log(LOG_WARNING, "nothing to send from port (%d) got (%s)\n", port, strerror(errno));
				}
//        	              		sms_sched_id=ast_sched_replace_variable(sms_sched_id,gsm_tasks,SMS_SEND_PERIOD_SEC*1000,gsm_sms_sender_func, NULL ,0);
			}
		}
	}
	return 1;
}

static int gsm_handle_cme_error(int port, int cme_error_code)
{
	struct ast_channel *ast=gsm_get_priv(port);
	struct gsm_pvt *gsm=NULL;

	if (ast)
#ifdef ASTERISK_11_4
                gsm=ast_channel_tech_pvt(ast);
#else
                gsm=ast->tech_pvt;
#endif

	if (gsm_debug)
		ast_log(LOG_DEBUG, "%s() received error code %d\n",
			__FUNCTION__, cme_error_code);
	
	switch (cme_error_code) {

		case CME_ERROR_PHONE_FAILURE ... CME_ERROR_EMERGENCY_CALLS_ONLY:
		case CME_ERROR_AUDIO_MANAGER_NOT_READY:
		case CME_ERROR_AUDIO_FORMAT_NOT_CONFIGURED:
		case CME_ERROR_CALL_SETUP_IN_PROGRESS:
			if (ast && gsm && gsm->state != GSM_STATE_HANGUPED) {
				gsm->state=GSM_STATE_HANGUPED;
#ifdef ASTERISK_11_4
                                ast_channel_hangupcause_set(ast, 3); /* check corresponding codes for each cme error code */
#else
                                ast->hangupcause=3; /* check corresponding codes for each cme error code */
#endif
				ast_queue_hangup(ast);
			}
			break;

		default:
			break;
	}

	return 0;
}

static int gsm_handle_cms_error(int port, int cms_error_code)
{
	struct ast_channel *ast=gsm_get_priv(port);
	struct gsm_pvt *gsm=NULL;

	if (ast)
#ifdef ASTERISK_11_4 
                gsm=ast_channel_tech_pvt(ast);
#else
                gsm=ast->tech_pvt;
#endif

	if (gsm_debug)
		ast_log(LOG_DEBUG, "%s() received error code %d\n",
			__FUNCTION__, cms_error_code);
	
	switch (cms_error_code) {

		case CMS_ERROR_ME_FAILURE ... CMS_ERROR_OPERATION_NOT_SUPPORTED:
			if (ast && gsm->state != GSM_STATE_HANGUPED) {
				gsm->state=GSM_STATE_HANGUPED;
#ifdef ASTERISK_11_4
                                ast_channel_hangupcause_set(ast, 3); /* check corresponding codes for each cms error code */
#else
                                ast->hangupcause=3;
#endif
				ast_queue_hangup(ast);
			}
			break;

		default:
			break;
	}

	return 0;
}


static int gsm_config_get_bool(int sec, int parameter)
{
        char t[16];
        cm_get(config, t, sizeof(t), sec, parameter);
        return ast_true(t)==-1?1:ast_true(t);
}

/* query the call state for the instance of the channel driver */
static int gsm_query_call_state(const void *data)
{
	struct ast_channel *ast=NULL;
	struct gsm_pvt *gsm=NULL;
	int port;

	for (port=0; port < MAX_GSM_PORTS; port++) {
		if (gsm_port_is_valid(port) && \
		    (gsm_status[port].status == GSM_STATUS_REGISTERED))  {
			/* send query only if you're in one of dialing out/proceeding/alerting states for a given port */
			if ((ast=gsm_get_priv(port))) {
#ifdef ASTERISK_11_4
                                if ((gsm = ast_channel_tech_pvt(ast)) && \
                                    ((gsm->state == GSM_STATE_ATD_OUT) || \
                                     (gsm->state == GSM_STATE_ALERTING) || \
                                     (gsm->state == GSM_STATE_PROCEEDING))) {
#else
                                if ((gsm = ast->tech_pvt) && \
                                    ((gsm->state == GSM_STATE_ATD_OUT) || \
                                     (gsm->state == GSM_STATE_ALERTING) || \
                                     (gsm->state == GSM_STATE_PROCEEDING))) {
#endif
					gsm_send(port, "AT+CLCC", 0);
				}
			}
		}
/*********Scheduling SMS Read using this scheduler.*****************/
		if (gsm_port_is_valid(port)){
			if ((ast=gsm_get_priv(port))) {
#ifdef ASTERISK_11_4
				if ( (gsm = ast_channel_tech_pvt(ast)) && \
				     ( (gsm->state == GSM_STATE_ATD_OUT) || \
				       (gsm->state == GSM_STATE_PRE_ATD) || \
				       (gsm->state == GSM_STATE_PROCEEDING) || \
				       (gsm->state == GSM_STATE_ALERTING) || \
/*				       (gsm->state == GSM_STATE_HANGUPED) || \		FIXME: Currently not working
				       (gsm->state == GSM_STATE_RINGING) || \ */
		 		       (gsm_slcc[port].ringing == 1) || \
				       (gsm_port_in_use_get(port))	
				     )
				   ) {
#else
				if ((gsm = ast->tech_pvt) && \
				     ( (gsm->state == GSM_STATE_ATD_OUT) || \
				       (gsm->state == GSM_STATE_PRE_ATD) || \
				       (gsm->state == GSM_STATE_PROCEEDING) || \
				       (gsm->state == GSM_STATE_ALERTING) || \
/*				       (gsm->state == GSM_STATE_HANGUPED) || \		FIXME: Currently not working
				       (gsm->state == GSM_STATE_RINGING) || \*/
		 		       (gsm_slcc[port].ringing == 1) || \
				       (gsm_port_in_use_get(port))	
				     )
				   ) {
#endif
				}else{
//ast_verbose( "%s %d waiting sms %d state :%d\n", __func__, __LINE__, gsm_sms[port].number__waiting_incoming_sms, gsm_sms[port].state); //pawan print
					if (( gsm_sms[port].number__waiting_incoming_sms > 0 ) && ( gsm_sms[port].state == GSM_SMS_STATE_NONE )){
						gsm_sms[port].last_sms_idx = gsm_sms[port].index__waiting_incoming_sms[ gsm_sms[port].number__waiting_incoming_sms ];
						gsm_sms[port].index__waiting_incoming_sms[ gsm_sms[port].number__waiting_incoming_sms ] = 0;
						--gsm_sms[port].number__waiting_incoming_sms;
						gsm_sms[port].work = GSM_SMS_WORK_READ_LAST_MSG;
						_gsm_read_sms(port, gsm_sms[port].last_sms_idx); //Obtain Last message Received in Var
					}
				}
			}else{
//ast_verbose( "%s %d waiting sms %d state :%d\n", __func__, __LINE__, gsm_sms[port].number__waiting_incoming_sms, gsm_sms[port].state); //pawan print
				if (( gsm_sms[port].number__waiting_incoming_sms > 0 ) && ( gsm_sms[port].state == GSM_SMS_STATE_NONE )){
					gsm_sms[port].last_sms_idx = gsm_sms[port].index__waiting_incoming_sms[ gsm_sms[port].number__waiting_incoming_sms ];
					gsm_sms[port].index__waiting_incoming_sms[ gsm_sms[port].number__waiting_incoming_sms ] = 0;
					--gsm_sms[port].number__waiting_incoming_sms;
					gsm_sms[port].work = GSM_SMS_WORK_READ_LAST_MSG;
					_gsm_read_sms(port, gsm_sms[port].last_sms_idx); //Obtain Last message Received in Var
				}
			}
		}
/*******************************************************************/
	}

	return 1;
}

static int gsm_update_lcd_status(const void *data)
{
       enum channel_state channel_state;
       int ii;

       for (ii = 0; ii < MAX_GSM_PORTS; ii++) {
               if ((gsm_port_is_valid(ii)) && (gsm_get_channel_state(ii, &channel_state) >= 0)) {
                       gsm_send_channel_state(ii, channel_state);
                       if (gsm_debug) 
				ast_log(LOG_VERBOSE, "sending state (%d) for channel (%d)\n", channel_state, ii);
                       usleep(500 * 1000);
               }
       }

       /* run this just once */
       return 0;
}

static int gsm_resetinterval(const void *data)
{
	int port=(int)data;

	if (port>0 && port < MAX_GSM_PORTS)  {
		if (!gsm_port_in_use_get(port)) {
			ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Restarting port: %d after resetinterval\n", port);
			_gsm_restart_port(port, 1);
		}
	}
	return 1;
}

static int _gsm_send_sms(int port, const char *number, const char *sms)
{
  	strcpy(gsm_sms[port].number, number);
	strcpy(gsm_sms[port].sms, sms);

	if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX " SMS SEND :%s:%s:%d \n", __FILE__, __func__, __LINE__);
	if (gsm_sms[port].state != GSM_SMS_STATE_NONE) {
		ast_verbose(CHAN_GSM_VERBOSE_PREFIX "SMS Statemachine busy, try later\n");
		ast_log(LOG_WARNING, "SMS Statemachine busy, try later\n");
		return -1;
	}

	if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX " SMS SEND :%s:%s:%d \n", __FILE__, __func__, __LINE__);
	gsm_sms[port].state = GSM_SMS_STATE_EXPECTING_OK;
	if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX " SMS SEND :%s:%s:%d \n", __FILE__, __func__, __LINE__);
	gsm_send(port, "AT+CMGF=1", 0); // SAM -- always sending text mode SMS
	if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX " SMS SEND :%s:%s:%d \n", __FILE__, __func__, __LINE__);

	return 0;
}

static int _gsm_queue_sms(int port, const char *number, const char *sms)
{
	struct ast_channel *ast=gsm_get_priv(port);
	struct gsm_sms_message outbound_msg; /* temporary message, where we work on*/
#if 1
	int msglen = sizeof(outbound_msg) - sizeof(long);
#else
	int msglen = sizeof(outbound_msg);
#endif

	memset(&outbound_msg, 0, sizeof(outbound_msg));

	/* queue the gsm message */
	outbound_msg.mtype = 1;
	strncpy(outbound_msg.number, number, SMS_NUM_SZ-1);
	strncpy(outbound_msg.text, sms, SMS_MSG_SZ-2);
#if 0
	ast_log(LOG_NOTICE, "Sending to msgq :%d: port :%d: outbound_msg.text '%s'\n", gsm_sms[port].sms_mq_id, port , outbound_msg.text );
	if (msgsnd(gsm_sms[port].sms_mq_id, (void*)&outbound_msg, msglen, IPC_NOWAIT) < 0) {
		ast_log(LOG_ERROR, "error queuing message (%s) to number (%s) err(%s)\n",
			sms, number, strerror(errno));
		return -1;
	}
#else
	ast_log(LOG_DEBUG, "Sending to msgq :%d: port :%d: outbound_msg.text '%s'\n", gsm_sms[port].soc_id, port , outbound_msg.text );
	if (write(gsm_sms[port].soc_id, (void*)&outbound_msg, msglen) < 0) {
#if ( defined ASTERISK_1_8 || defined ASTERISK_10_4 || defined ASTERISK_10_4  )
	 ast_manager_event(ast,EVENT_FLAG_CALL,
                                        "SMS_STATUS_BUFFER_FULL",
                                        "Channel: GSM/%d\r\n",                                        
                                         port);
#endif	
		ast_log(LOG_ERROR, "error queuing message (%s) to number (%s) err(%s)\n",
			sms, number, strerror(errno));
		return -1;
	}
#endif

	return 0;
}

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_send_sms(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_send_sms(int fd, int argc, char *argv[])
#endif
{	
	int result;


#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )	
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm send sms";
		e->usage = "Usage: allogsm send sms <port> <number> \"<message>\"\n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
        if (a->argc != 6)
                return CLI_SHOWUSAGE;

	int port=strtol(a->argv[3], NULL, 10);
#endif
#ifdef ASTERISK_1_4
        if (argc != 6)
                return RESULT_SHOWUSAGE;

	int port=strtol(argv[3], NULL, 10);
#endif

	//CLI_CHECK_PORT(port);

	if (!gsm_port_is_valid(port)) {
		ast_log(LOG_WARNING, "Port:'%d' is not configured, please review your gsm.conf\n",port);

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
		return CLI_FAILURE;
#endif
#ifdef ASTERISK_1_4
		return RESULT_FAILURE;
#endif
	}

	ast_log(LOG_VERBOSE, "Port:'%d' sending sms through port\n",port);

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	result = _gsm_queue_sms(port, a->argv[4], a->argv[5]);
#endif
#ifdef ASTERISK_1_4
	result = _gsm_queue_sms(port, argv[4], argv[5]);
#endif

	/* we print out ACK when we have successful receipt of the message */
	if (result < 0)
		ast_log(LOG_ERROR, "error queuing SMS message\n");
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	return (result >= 0) ? CLI_SUCCESS : CLI_FAILURE;
#endif
#ifdef ASTERISK_1_4
	return (result >= 0) ? RESULT_SUCCESS : RESULT_FAILURE;
#endif
}

#if 0
static int _gsm_read_sms(int port, int smsnum)
{
	char buf[32];
	snprintf(buf,32, "AT+CMGR=%d",smsnum);
	/* the mode is already set at initialization */
	/* ask to read particular messages, so change the sms state to something other than NONE */
	gsm_sms[port].state=GSM_SMS_STATE_EXPECTING_SMSLIST;
	gsm_send(port, buf,100);

	return 0;
}

#endif

#ifdef DIALPLAN_SMS
static int _gsm_read_sms(int port, int smsnum)
{
	char buf[32];
	snprintf(buf,32, "AT+CMGR=%d",smsnum);
	/* the mode is already set at initialization */
	/* ask to read particular messages, so change the sms state to something other than NONE */
	gsm_sms[port].state=GSM_SMS_STATE_EXPECTING_SMS;
	gsm_send(port, buf,100);

	return 0;
}
#endif

static int _gsm_list_sms(int port)
{
	if (gsm_cfg[port].sms_pdu_mode) {
		/* the mode is already set at initialization */
		/* ask a list of all messages, so change the sms state to something other than NONE */
		gsm_sms[port].state=GSM_SMS_STATE_EXPECTING_SMSLIST;
		gsm_send(port, "AT+CMGL=4",100);
	} else {
		/* the mode is already set at initialization */
		/* ask a list of all messages, so change the sms state to something other than NONE */
		gsm_sms[port].state=GSM_SMS_STATE_EXPECTING_SMSLIST;
		gsm_send(port, "AT+CMGL=\"ALL\"",100);
	}

	return 0;
}

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_fetch_sms(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_fetch_sms(int fd, int argc, char *argv[])
#endif
{
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm fetch sms";
		e->usage = "Usage: allogsm fetch sms <port>\n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	if (a->argc != 4)
		return CLI_SHOWUSAGE;
	int port=strtol(a->argv[3], NULL, 10);
#endif
#ifdef ASTERISK_1_4
	if (argc != 4)
		return RESULT_SHOWUSAGE;
	int port=strtol(argv[3], NULL, 10);
#endif

	//CLI_CHECK_PORT(port);

	if (!gsm_port_is_valid(port)) {
		ast_log(LOG_WARNING, "Port:'%d' is not configured, please review your gsm.conf\n",port);
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
		return CLI_FAILURE;
#endif
#ifdef ASTERISK_1_4
		return RESULT_FAILURE;
#endif
	}
	if (gsm_sms[port].state!=GSM_SMS_STATE_NONE){
		ast_log(LOG_WARNING, "Port:'%d' We are already in a diffrent SMS transaction. Please try after some time\n",port);
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
		return CLI_FAILURE;
#endif
#ifdef ASTERISK_1_4
		return RESULT_FAILURE;
#endif
	}
	struct ast_channel *ast=gsm_get_priv(port);
	struct gsm_pvt *gsm=NULL;
	if (ast){
#ifdef ASTERISK_11_4
                if ( (gsm = ast_channel_tech_pvt(ast)) && \
                     ( (gsm->state == GSM_STATE_ATD_OUT) || \
		       (gsm->state == GSM_STATE_PRE_ATD) || \
                       (gsm->state == GSM_STATE_PROCEEDING) || \
                       (gsm->state == GSM_STATE_ALERTING) || \
              	       (gsm->state == GSM_STATE_HANGUPED) || \	
                     /*  (gsm->state == GSM_STATE_RINGING) || \ */
		       (gsm_slcc[port].ringing == 1)
		     ) 
		   )  {
#else
		if ( (gsm = ast->tech_pvt) && \
                     ( (gsm->state == GSM_STATE_ATD_OUT) || \
		       (gsm->state == GSM_STATE_PRE_ATD) || \
                       (gsm->state == GSM_STATE_PROCEEDING) || \
                       (gsm->state == GSM_STATE_ALERTING) || \
              	       (gsm->state == GSM_STATE_HANGUPED) || \	
                     /*  (gsm->state == GSM_STATE_RINGING) || \ */
		       (gsm_slcc[port].ringing == 1)
		     )
		   ) {
#endif
			ast_log(LOG_WARNING, "Port:'%d' Processing Call. Please try after some time\n",port);
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
			return CLI_FAILURE;
#endif
#ifdef ASTERISK_1_4
			return RESULT_FAILURE;
#endif
		}
	}

	gsm_sms[port].work=GSM_SMS_WORK_FETCH;
	_gsm_list_sms(port);
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	return CLI_SUCCESS;
#endif
#ifdef ASTERISK_1_4
	return RESULT_SUCCESS;
#endif
}

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_show_sms(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_show_sms(int fd, int argc, char *argv[])
#endif
{
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm show sms";
		e->usage = "Usage:allogsm show sms <port>\n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	if (a->argc != 4)
		return CLI_SHOWUSAGE;

	int port=strtol(a->argv[3], NULL, 10);
#endif
#ifdef ASTERISK_1_4
	if (argc != 4)
		return RESULT_SHOWUSAGE;

	int port=strtol(argv[3], NULL, 10);
#endif

	//CLI_CHECK_PORT(port);

	if (!gsm_port_is_valid(port)) {
		ast_log(LOG_WARNING, "Port:'%d' is not configured, please review your gsm.conf\n",port);
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
		return CLI_FAILURE;
#endif
#ifdef ASTERISK_1_4
		return RESULT_FAILURE;
#endif
	}
	if (gsm_sms[port].state!=GSM_SMS_STATE_NONE){
		ast_log(LOG_WARNING, "Port:'%d' We are already in a diffrent SMS transaction. Please try after some time\n",port);
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
		return CLI_FAILURE;
#endif
#ifdef ASTERISK_1_4
		return RESULT_FAILURE;
#endif
	}

	struct ast_channel *ast=gsm_get_priv(port);
	struct gsm_pvt *gsm=NULL;
	if (ast){
#ifdef ASTERISK_11_4
                if ( (gsm = ast_channel_tech_pvt(ast)) && \
                     ( (gsm->state == GSM_STATE_ATD_OUT) || \
		       (gsm->state == GSM_STATE_PRE_ATD) || \
                       (gsm->state == GSM_STATE_PROCEEDING) || \
                       (gsm->state == GSM_STATE_ALERTING) || \
              	       (gsm->state == GSM_STATE_HANGUPED) || \	
                     /*  (gsm->state == GSM_STATE_RINGING) || \ */
		       (gsm_slcc[port].ringing == 1)
		     ) 
		   )  {
#else
		if ( (gsm = ast->tech_pvt) && \
                     ( (gsm->state == GSM_STATE_ATD_OUT) || \
		       (gsm->state == GSM_STATE_PRE_ATD) || \
                       (gsm->state == GSM_STATE_PROCEEDING) || \
                       (gsm->state == GSM_STATE_ALERTING) || \
              	       (gsm->state == GSM_STATE_HANGUPED) || \	
                     /*  (gsm->state == GSM_STATE_RINGING) || \ */
		       (gsm_slcc[port].ringing == 1)
		     )
		   ) {
#endif
			ast_log(LOG_WARNING, "Port:'%d' Processing Call. Please try after some time\n",port);
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
			return CLI_FAILURE;
#endif
#ifdef ASTERISK_1_4
			return RESULT_FAILURE;
#endif
		}
	}

#define CMGL_READ 1
#if CMGL_READ
	gsm_sms[port].work=GSM_SMS_WORK_SHOW;
	_gsm_list_sms(port);
#else
#define MAX_SMS_MEMORY 25
	gsm_sms[port].work=GSM_SMS_WORK_SHOW;
	int i;
	for (i=0; i<MAX_SMS_MEMORY; ++i){
		++gsm_sms[port].number__waiting_incoming_sms;
		gsm_sms[port].index__waiting_incoming_sms[gsm_sms[port].number__waiting_incoming_sms]=i;
	}
#endif
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	return CLI_SUCCESS;
#endif
#ifdef ASTERISK_1_4
	return RESULT_SUCCESS;
#endif
}


#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_debug_port(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_debug_port(int fd, int argc, char *argv[])
#endif
{
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm debug port";
		e->usage = "Usage:allogsm debug port <port> <level>\n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
        if (a->argc != 5)
                return CLI_SHOWUSAGE;
	int port= atoi(a->argv[3]);
	at_debug[port]=atoi(a->argv[4]);
#endif
#ifdef ASTERISK_1_4
        if (argc != 5)
                return RESULT_SHOWUSAGE;
	int port= atoi(argv[3]);
	at_debug[port]=atoi(argv[4]);
#endif

	gsm_set_debug_port(port, at_debug[port]);

	ast_verbose("[GSM] Setting debug level %d\n", at_debug[port]);

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	return CLI_SUCCESS;
#endif
#ifdef ASTERISK_1_4
	return RESULT_SUCCESS;
#endif
}

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_set_debug(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_set_debug(int fd, int argc, char *argv[])
#endif
{
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm set debug";
		e->usage = "Usage:allogsm set debug <level>\n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
        if (a->argc != 4)
                return CLI_SHOWUSAGE;

	gsm_debug=atoi(a->argv[3]);
#endif
#ifdef ASTERISK_1_4
        if (argc != 4)
                return RESULT_SHOWUSAGE;
	gsm_debug=atoi(argv[3]);
#endif

	gsm_set_debuglevel(gsm_debug);

	ast_verbose("[GSM] Setting debug level %d\n", gsm_debug);

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	return CLI_SUCCESS;
#endif
#ifdef ASTERISK_1_4
	return RESULT_SUCCESS;
#endif
}


#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_debug_info(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_debug_info(int fd, int argc, char *argv[])
#endif
{
	int port;

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm debug info";
		e->usage = "Usage:allogsm debug info\n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif 

	for (port = 0; port < MAX_GSM_PORTS; port++) {
		if (gsm_port_is_valid(port)) 
			ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Sms_State (%d) sms_work (%d) on PORT:%d\n", gsm_sms[port].state, gsm_sms[port].work, port);
	}
	
	for (port = 0; port < MAX_GSM_PORTS; port++) {
		if (gsm_port_is_valid(port)) 
			ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Port %d IMEI (%-15s) Firmware (%s)\n", port, gsm_get_imei_number(port), gsm_get_firmware_info(port));
	}

	ast_verbose("\n");
	for (port = 0; port < MAX_GSM_PORTS; port++) {
		if (gsm_port_is_valid(port)) 
			ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Port %d IMSI (%-15s)\n", port, gsm_get_imsi_number(port));
	}

	return 0;
}


#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_shutdown_port(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_shutdown_port(int fd, int argc, char *argv[])
#endif
{

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm shutdown port";
		e->usage = "Usage: allogsm shutdown port <port>\n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	if (a->argc != 4)
		return CLI_SHOWUSAGE;

	int port=strtol(a->argv[3], NULL, 10);
#endif
#ifdef ASTERISK_1_4
	if (argc != 4)
		return RESULT_SHOWUSAGE;

	int port=strtol(argv[3], NULL, 10);
#endif

	//CLI_CHECK_PORT(port);

	if (!gsm_port_is_valid(port)) {
		ast_log(LOG_WARNING, "Port:'%d' is not configured, please review your gsm.conf\n",port);
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
		return CLI_FAILURE;
#endif
#ifdef ASTERISK_1_4
		return RESULT_FAILURE;
#endif
	}

	_gsm_shutdown_port(port, 0);

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	return CLI_SUCCESS;
#endif
#ifdef ASTERISK_1_4
	return RESULT_SUCCESS;
#endif
}


int _gsm_shutdown_port(int port, int powercycle)
{
	ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Shutting down port %d\n",port);
	gsm_status[port].status=GSM_STATUS_UNINITIALIZED;
	gsm_sms_destroy(port);
	gsm_shutdown_port(port, powercycle);

	return 0;
}

int _gsm_init_port(int port)
{
#if 0
	struct gsm_config cfg;

	if (!gsm_port_is_valid(port)) {
		ast_log(LOG_WARNING, "Port:'%d' is not configured, please review your gsm.conf\n",port);
		return -1;
	}
#endif
	if (gsm_debug)
		ast_log(LOG_DEBUG, "%s() : Initializing gsm port %d\n",
			__FUNCTION__, port);

	/*if (!gsm_check_port(port)) {
		ast_log(LOG_ERROR , "port=(%d) device doesnot exist\n", port);
		return -1;
	}*/

	ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Initializing port %d\n",port);

	_init_mod_port(port);

	ast_log(LOG_DEBUG , "[ALLO_GSM] Calling the GSM init port '%d' !!!!! \n", port );
	gsm_init_port(port, &gsm_cfg[port]);
	gsm_sms_init(port);
	
	usleep(100*1000);

	int retry=1;
	while(retry && (gsm_wait_ready_with_timeout(port, GSM_READY_TIMEOUT) != 0)) {
		retry--;
	}

	if (retry) {
		ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Started gsm port %d\n",port);
	} else {
		ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Failed starting gsm port %d\n", port);
		ast_log(LOG_ERROR, "Error starting gsm port %d\n", port);
		//return -1;
	}

	if (gsm_debug)
		ast_log(LOG_DEBUG, "%s() : Started gsm port %d\n",
			__FUNCTION__, port);

	return 0;
}

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_init_port(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_init_port(int fd, int argc, char *argv[])
#endif
{
	
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm init port";
		e->usage = "Usage:allogsm init port <port>\n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
        if (a->argc != 4)
                return CLI_SHOWUSAGE;

	int port = atoi(a->argv[3]);
#endif
#ifdef ASTERISK_1_4
        if (argc != 4)
                return RESULT_SHOWUSAGE;

	int port = atoi(argv[3]);
#endif

	//CLI_CHECK_PORT(port);

	if (gsm_status[port].status != GSM_STATUS_UNINITIALIZED) {
		ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Port (%d) already initialized.\n", port);
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
		return CLI_FAILURE;
#endif
#ifdef ASTERISK_1_4
		return RESULT_FAILURE;
#endif
	} else {
		_gsm_init_port(port);
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	return CLI_SUCCESS;
#endif
#ifdef ASTERISK_1_4
	return RESULT_SUCCESS;
#endif
	}
}


#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_set_next_simslot(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_set_next_simslot(int fd, int argc, char *argv[])
#endif
{
	int port, ns;

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm set next simslot";
		e->usage = "Usage:allogsm set next simslot <port> <nextslot>\n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	if (a->argc != 6)
    		return CLI_SHOWUSAGE;

	port=strtol(a->argv[4],NULL,10);
	ns=strtol(a->argv[5],NULL,10);
#endif
#ifdef ASTERISK_1_4
	if (argc != 6)
    		return RESULT_SHOWUSAGE;

	port=strtol(argv[4],NULL,10);
	ns=strtol(argv[5],NULL,10);
#endif

	//CLI_CHECK_PORT(port);

	if (!gsm_port_is_valid(port)) {
		ast_log(LOG_WARNING, "Port:'%d' is not configured, please review your gsm.conf\n",port);
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
		return CLI_FAILURE;
#endif
#ifdef ASTERISK_1_4
		return RESULT_FAILURE;
#endif
	}

	int i=gsm_set_next_simslot(port, ns);

	if (i<0)
		ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Setting simslot failed (%s)\n", strerror(errno));

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	return CLI_SUCCESS;
#endif
#ifdef ASTERISK_1_4
	return RESULT_SUCCESS;
#endif
}

static void _gsm_restart_port_sync(int port, int postwait)
{
	unsigned long then = time(NULL);

	if (!gsm_port_is_valid(port)) {
		ast_log(LOG_WARNING, "Port:'%d' is not configured, please review your gsm.conf (not restarting)\n",port);
		return ;
	}

	/* if we're doing a normal (sync) restart, =do not= power cycle the module */
	/* as there is no need and it takes longer to reinitialize that way.       */
	_gsm_shutdown_port(port, 0);
	sleep(3);
	if(_gsm_init_port(port)<0){
		_gsm_shutdown_port(port, 0);
	}

	//Wait for REGISTER EVENT
	sleep(5);
	unsigned long now = time(NULL);
	ast_verbose(CHAN_GSM_VERBOSE_PREFIX "It took us %ld seconds\n", now-then);

	if (gsm_debug)
		ast_log(LOG_DEBUG, "It took us %ld seconds\n", now-then);
}

/* we could just use the _sync() version of the function */
static void* _gsm_restart_thread(void *data)
{
	int port = (int)data;

	unsigned long then = time(NULL);

	if (!gsm_port_is_valid(port)) {
		ast_log(LOG_WARNING, "Port:'%d' is not configured, please review your gsm.conf (not restarting)\n",port);
		return NULL;
	}

	_gsm_shutdown_port(port, 0);
	sleep(3);
	_gsm_init_port(port);

	//Wait for REGISTER EVENT
	sleep(5);
	unsigned long now = time(NULL);
	ast_verbose(CHAN_GSM_VERBOSE_PREFIX "It took us %ld seconds\n", now-then);

	if (gsm_debug)
		ast_log(LOG_DEBUG, "It took us %ld seconds\n", now-then);
pthread_exit(NULL);
return NULL;
}

#if 0
static void _gsm_restart_port_async(int port, int postwait)
{
	pthread_create(&_gsm_restart_threads[port], NULL, _gsm_restart_thread, (void*)port); 
}

#endif

static void _gsm_restart_port(int port, int postwait)
{
	_gsm_restart_port_sync(port, postwait);
}

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_restart_port(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_restart_port(int fd, int argc, char *argv[])
#endif
{
	int port;

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm restart port";
		e->usage = "Usage: allogsm restart port <port>\n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
        if (a->argc != 4)
                return CLI_SHOWUSAGE;

	port=strtol(a->argv[3], NULL, 10);
#endif
#ifdef ASTERISK_1_4
        if (argc != 4)
                return RESULT_SHOWUSAGE;

	port=strtol(argv[3], NULL, 10);
#endif

	//CLI_CHECK_PORT(port);

	_gsm_restart_port(port, 0);

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	return CLI_SUCCESS;
#endif
#ifdef ASTERISK_1_4
	return RESULT_SUCCESS;
#endif
}

struct gsm_op {
	char name[128];
	char origname[128];
	char number[32];
} ;

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_show_ops(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_show_ops(int fd, int argc, char *argv[])
#endif
{
	int port;

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm show ops";
		e->usage = "Usage: allogsm show ops <port>\n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
        if (a->argc != 4)
                return CLI_SHOWUSAGE;

	port=strtol(a->argv[3], NULL, 10);
#endif
#ifdef ASTERISK_1_4
        if (argc != 4)
           return RESULT_SHOWUSAGE;

	port=strtol(argv[3], NULL, 10);
#endif

	//CLI_CHECK_PORT(port);

	gsm_send(port, "AT+COPN", 100);
	ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Getting Operator List, please stand by\n");

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	return CLI_SUCCESS;
#endif
#ifdef ASTERISK_1_4
	return RESULT_SUCCESS;
#endif
}

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_set_op(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_set_op(int fd, int argc, char *argv[])
#endif
{

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm set op";
		e->usage = "Usage: allogsm set op <port> \"<operator>\"\n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
        if (a->argc != 5)
                return CLI_SHOWUSAGE;
#endif
#ifdef ASTERISK_1_4
        if (argc != 5)
                return RESULT_SHOWUSAGE;
#endif

	char buf[64];
	int port;

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	port=strtol(a->argv[3], NULL, 10);
#endif
#ifdef ASTERISK_1_4
	port=strtol(argv[3], NULL, 10);
#endif

	//CLI_CHECK_PORT(port);

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	sprintf(buf,"AT+COPS=1,2,%s",a->argv[4]);
#endif
#ifdef ASTERISK_1_4
	sprintf(buf,"AT+COPS=1,2,%s",argv[4]);
#endif
	gsm_send(port, buf, 100);

	ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Setting Operator, please stand by\n");
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	return CLI_SUCCESS;
#endif
#ifdef ASTERISK_1_4
	return RESULT_SUCCESS;
#endif
}

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_show_status(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_show_status(int fd, int argc, char *argv[])
#endif
{
	int i;

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm show status";
		e->usage = "Usage: allogsm show status\n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif
	/* perform the signal strength query for all channels */
#if 0
	for (i=1; i<MAX_GSM_PORTS; i++) {
		/*if ((gsm_status[i].status == GSM_STATUS_INITIALIZED) && 
		(gsm_status[i].status == GSM_STATUS_UNREGISTERED) && 
		(gsm_status[i].status == GSM_STATUS_REGISTERED) && 
		(gsm_port_is_valid(i))) */
		//ast_log(LOG_ERROR , "[ALLO_GSM] seding AT+CSQ cmd to gsm '%d' \n" , i );

		//gsm_status[i].status = GSM_STATUS_UNREGISTERED;
		gsm_send(i, "AT+CPIN?", 200); usleep(200*1000);
		if(gsm_status[i].status != GSM_STATUS_REGISTERED){
			gsm_send(i, "AT+CFUN=1", 200); usleep(5*1000*1000);
			gsm_send(i, "AT+CPIN?", 200); usleep(200*1000);
		}
		gsm_send(i, "AT+COPS?", 100); usleep(200*1000);
	}
#else
	struct ast_channel *ast=NULL;
	struct gsm_pvt *gsm=NULL;
	int flag[MAX_GSM_PORTS];

	for (i=1; i<MAX_GSM_PORTS; ++i) {
		flag[i]=0;
		if (gsm_port_is_valid(i))
			ast=gsm_get_priv(i);
		if (ast){
#ifdef ASTERISK_11_4
                        if ( (gsm = ast_channel_tech_pvt(ast)) && \
                             ( (gsm->state == GSM_STATE_ATD_OUT) || \
			       (gsm->state == GSM_STATE_PRE_ATD) || \
                               (gsm->state == GSM_STATE_PROCEEDING) || \
                               (gsm->state == GSM_STATE_ALERTING) || \
/*                               (gsm->state == GSM_STATE_HANGUPED) || \		FIXME: Currently not working
                               (gsm->state == GSM_STATE_RINGING) || \ */
		 	       (gsm_slcc[i].ringing == 1)
			     ) 
			   )  {
#else
                        if ( (gsm = ast->tech_pvt) && \
                             ( (gsm->state == GSM_STATE_ATD_OUT) || \
			       (gsm->state == GSM_STATE_PRE_ATD) || \
                               (gsm->state == GSM_STATE_PROCEEDING) || \
                               (gsm->state == GSM_STATE_ALERTING) || \
/*                               (gsm->state == GSM_STATE_HANGUPED) || \		FIXME: Currently not working
                               (gsm->state == GSM_STATE_RINGING) || \*/
		 	       (gsm_slcc[i].ringing == 1)
			     )
			   ) {
#endif
				/*Dont send AT+CPIN? here coz already in call.. Calls may disconnect..*/
				flag[i]=0;
			}else{
				gsm_send(i, "AT+CPIN?", 200); usleep(300*1000);	
				gsm_send(i, "AT+COPS?", 100);
				flag[i]=1;
			}
		}else{
			if (gsm_port_is_valid(i)){
				gsm_send(i, "AT+CPIN?", 200); usleep(300*1000);	
				gsm_send(i, "AT+COPS?", 100);
				flag[i]=1;
			}
		}
	}
	usleep(500*1000);	
#endif
 
#define FORMAT1 "%-4.4s  %-15.15s %-5.5s %-20.20s %-9.9s %-15.15s \n"
#define FORMAT2 "%-4i  %-15.15s %-5.5s %-20.20s %-9.9s %-15.15s \n"
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	ast_cli(a->fd, FORMAT1, "Port", "Status", "InUse", "Provider", "Home Zone", " Signal Quality");
#endif
#ifdef ASTERISK_1_4
	ast_cli(fd, FORMAT1, "Port", "Status", "InUse", "Provider", "Home Zone", " Signal Quality");
#endif
	for (i=1; i<MAX_GSM_PORTS; i++) {
		/* query the signal strength for each channel */
		if (    gsm_status[i].status != GSM_STATUS_UNAVAILABLE &&
			gsm_status[i].status != GSM_STATUS_NOTCONFIGURED ) {
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
				ast_cli(a->fd, FORMAT2,
#endif
#ifdef ASTERISK_1_4
				ast_cli(fd, FORMAT2,
#endif
							gsm_simslot_get(i),
							status2txt[gsm_status[i].status],
							gsm_port_in_use_get(i)?"y ":"n ",
							(gsm_status[i].status==5)?gsm_status[i].provider:"none",
							gsm_status[i].homezone?"y ":"n ",
							rssi2txt(gsm_status[i].rssi, gsm_status[i].status)
							);
		}
	}
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	ast_cli(a->fd, "\n");
#endif
#ifdef ASTERISK_1_4
	ast_cli(fd, "\n");
#endif
/* if thr gsm is unregistered try resetting */
	for (i=1; i<MAX_GSM_PORTS; i++) {
		if((gsm_status[i].status == GSM_STATUS_UNREGISTERED) && flag[i]){
//			gsm_send(i, "AT+CFUN=1", 200); //usleep(500*1000); 
		}
	}
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	return CLI_SUCCESS;
#endif
#ifdef ASTERISK_1_4
	return RESULT_SUCCESS;
#endif
}


#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_show_version(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_show_version(int fd, int argc, char *argv[])
#endif
{

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm show version";
		e->usage = "Usage: allogsm show version\n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	ast_cli(a->fd,"\nchan_gsm version (" CHAN_GSM_VERSION ")\n");
	return CLI_SUCCESS;
#endif
#ifdef ASTERISK_1_4
	ast_cli(fd,"\nchan_gsm version (" CHAN_GSM_VERSION ")\n");
	return RESULT_SUCCESS;
#endif
}

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_peek(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_peek(int fd, int argc, char *argv[])
#endif
{
	unsigned reg;
	char *reg_p;
	struct gsm_req my_gsm_req;

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm peek";
		e->usage = "Usage: allogsm peek <offset>\n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif


#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	if (a->argc != 3) 
                return CLI_SHOWUSAGE;

	reg = strtoul(a->argv[2], &reg_p, 16); 
#endif
#ifdef ASTERISK_1_4
	if (argc != 3) 
                return RESULT_SHOWUSAGE;

	reg = strtoul(argv[2], &reg_p, 16); 
#endif

	if (*reg_p != '\0') {
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
		ast_cli(a->fd,"Invalid offset [%s]\n", a->argv[2]);
		return CLI_SHOWUSAGE;
#endif
#ifdef ASTERISK_1_4
		ast_cli(fd,"Invalid offset [%s]\n", argv[2]);
		return RESULT_SHOWUSAGE;
#endif
	}

	if ((reg < 0) || (reg > MAX_FPGA_OFFSET)) {
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
		ast_cli(a->fd,"Offset [%s] exceeds valid range [0..%x]\n", a->argv[2], MAX_FPGA_OFFSET);	
		return CLI_SHOWUSAGE;
#endif
#ifdef ASTERISK_1_4
		ast_cli(fd,"Offset [%s] exceeds valid range [0..%x]\n", argv[2], MAX_FPGA_OFFSET);	
		return RESULT_SHOWUSAGE;
#endif
	}

	memset(&my_gsm_req, 0, sizeof(my_gsm_req));
	my_gsm_req.type = GSM_PEEK_FPGA;
	my_gsm_req.param1 = reg;

	if (!gsm_do_ioctl(1, GSM_PEEK_FPGA, (int)&my_gsm_req))
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
		ast_cli(a->fd,"register:0x%08x value:0x%08x\n", reg, my_gsm_req.param2);
#endif
#ifdef ASTERISK_1_4
		ast_cli(fd,"register:0x%08x value:0x%08x\n", reg, my_gsm_req.param2);
#endif
	else
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
		ast_cli(a->fd,"Invalid register access/error\n");
#endif
#ifdef ASTERISK_1_4
		ast_cli(fd,"Invalid register access/error\n");
#endif

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	return CLI_SUCCESS;
#endif
#ifdef ASTERISK_1_4
	return RESULT_SUCCESS;
#endif
}

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static char* handle_gsm_poke(struct ast_cli_entry *e, int cmd, struct ast_cli_args *a)
#endif
#ifdef ASTERISK_1_4
static char* handle_gsm_poke(int fd, int argc, char *argv[])
#endif
{
	unsigned reg;
	unsigned value;
	char *reg_p, *value_p;
	struct gsm_req my_gsm_req;

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	switch (cmd) {
	case CLI_INIT:
		e->command = "allogsm poke";
		e->usage = "Usage: allogsm poke <offset> <value>\n";
		return NULL;

	case CLI_GENERATE:
		return NULL;
	}
#endif


#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	if (a->argc != 4) 
                return CLI_SHOWUSAGE;

	reg = strtoul(a->argv[2], &reg_p, 16); 
#endif
#ifdef ASTERISK_1_4
	if (argc != 4) 
                return RESULT_SHOWUSAGE;

	reg = strtoul(argv[2], &reg_p, 16); 
#endif

	if (*reg_p != '\0') {
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
		ast_cli(a->fd,"Invanid offset [%s]\n", a->argv[2]);
		return CLI_SHOWUSAGE;
#endif
#ifdef ASTERISK_1_4
		ast_cli(fd,"Invanid offset [%s]\n", argv[2]);
		return RESULT_SHOWUSAGE;
#endif
	}

	if ((reg < 0) || (reg > MAX_FPGA_OFFSET)) {
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
		ast_cli(a->fd,"Offset [%s] exceeds valid range [0..%x]\n", a->argv[2], MAX_FPGA_OFFSET);	
		return CLI_SHOWUSAGE;
#endif
#ifdef ASTERISK_1_4
		ast_cli(fd,"Offset [%s] exceeds valid range [0..%x]\n", argv[2], MAX_FPGA_OFFSET);	
		return RESULT_SHOWUSAGE;
#endif
	}

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	value = strtoul(a->argv[3], &value_p, 16); 
#endif
#ifdef ASTERISK_1_4
	value = strtoul(argv[3], &value_p, 16); 
#endif

	if (*value_p != '\0') {
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
		ast_cli(a->fd,"Invalid value [%s]\n", a->argv[3]);
		return CLI_SHOWUSAGE;
#endif
#ifdef ASTERISK_1_4
		ast_cli(fd,"Invalid value [%s]\n", argv[3]);
		return RESULT_SHOWUSAGE;
#endif
	}

	memset(&my_gsm_req, 0, sizeof(my_gsm_req));
	my_gsm_req.type = GSM_POKE_FPGA;
	my_gsm_req.param1 = reg;
	my_gsm_req.param2 = value;

	if (!gsm_do_ioctl(1, GSM_POKE_FPGA, (int)&my_gsm_req))
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
		ast_cli(a->fd,"register:0x%08x value:0x%08x\n", reg, my_gsm_req.param2);
#endif
#ifdef ASTERISK_1_4
		ast_cli(fd,"register:0x%08x value:0x%08x\n", reg, my_gsm_req.param2);
#endif
	else
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
		ast_cli(a->fd,"Invalid register access/error\n");
#endif
#ifdef ASTERISK_1_4
		ast_cli(fd,"Invalid register access/error\n");
#endif

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	return CLI_SUCCESS;
#endif
#ifdef ASTERISK_1_4
	return RESULT_SUCCESS;
#endif
}

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
static struct ast_cli_entry chan_gsm_clis[] = {
	AST_CLI_DEFINE(handle_gsm_send_at, "send AT command to port <port>"),
	AST_CLI_DEFINE(handle_gsm_send_sms, "send SMS to port <port> with number <number>"),
	AST_CLI_DEFINE(handle_gsm_send_sms_end, "send end of SMS to port <port> "),
	AST_CLI_DEFINE(handle_gsm_fetch_sms, "fetch all the stored SMS from port <port> and store them in smsdir\n"),
	AST_CLI_DEFINE(handle_gsm_show_sms, "show all the stored SMS rom port <port>\n"),
	AST_CLI_DEFINE(handle_gsm_set_debug, "set the debuglevel to <level>\n"),
	AST_CLI_DEFINE(handle_gsm_debug_port, "set the debuglevel to <level> for <port>\n"),
	AST_CLI_DEFINE(handle_gsm_debug_info, "print debug information\n"),
	AST_CLI_DEFINE(handle_gsm_shutdown_port, "shut down port <port>\n"),
	AST_CLI_DEFINE(handle_gsm_init_port, "initialize given <port>\n"),
	AST_CLI_DEFINE(handle_gsm_set_next_simslot, "set next sim slot to <slot>\n"),
	AST_CLI_DEFINE(handle_gsm_restart_port, "restart allogsm port <port>\n"),
	AST_CLI_DEFINE(handle_gsm_show_ops, "show list of operators\n"),
	AST_CLI_DEFINE(handle_gsm_show_status, "show status of gsm modules\n"),
	AST_CLI_DEFINE(handle_gsm_show_version, "show version of the gsm channel driver\n"),
	AST_CLI_DEFINE(handle_gsm_peek, "read value of a register in FPGA\n"),
	AST_CLI_DEFINE(handle_gsm_poke, "write value to a given register in FPGA\n"),
	AST_CLI_DEFINE(handle_gsm_set_op, "set an operator\n"),
	AST_CLI_DEFINE(handle_gsm_request_state, "only used by astmanproxy\n"),
	AST_CLI_DEFINE(handle_gsm_show_info, "show GSM information\n"),
	AST_CLI_DEFINE(handle_gsm_restart_plx, "Re initialize the PLX module.....\n"),
};
#endif
#ifdef ASTERISK_1_4
static struct ast_cli_entry chan_gsm_clis[] = {
	{{ "allogsm", "send", "at", NULL },
	handle_gsm_send_at, 
	"send AT command to port <port> <command>","Usage: allogsm send at <port> \"<command>\"" },
	
	{{ "allogsm", "send", "sms", NULL },
	handle_gsm_send_sms, 
	"send SMS to port <port> with number <number>","Usage: allogsm send sms <port> <number> \"<message>\"" },

	{{ "allogsm", "send", "sms", "end", NULL},
	handle_gsm_send_sms_end, 
	"send end of SMS to port <port>","Usage: allogsm send sms end <port>"},
	
	{{ "allogsm", "fetch", "sms", NULL },
	handle_gsm_fetch_sms, 
	"fetch all the stored SMS from port <port> and store them in smsdir","Usage: allogsm fetch sms <port>" },
	
	{{ "allogsm", "fetch", "sms", NULL },
	handle_gsm_show_sms, 
	"show all the stored SMS rom port <port>","Usage: allogsm show sms <port>" },
	
	{{ "allogsm", "set", "debug", NULL },
	handle_gsm_set_debug, 
	"Set universal Debug level","Usage: allogsm set debug <level>" },
	
	{{ "allogsm", "debug", "port", NULL },
	handle_gsm_debug_port, 
	"Debug at commands for <port>","Usage: allogsm debug span <port> <level>" },
	
	{{ "allogsm", "debug", "info", NULL },
	handle_gsm_debug_info, 
	"print debug information","Usage: allogsm debug info" },
	
	{{ "allogsm", "shutdown", "port", NULL },
	handle_gsm_shutdown_port, 
	"shut down port <port>","Usage: allogsm shutdown port <port>" },
	
	{{ "allogsm", "init", "port", NULL },
	handle_gsm_init_port, 
	"initialize given <port>","Usage: allogsm init port <port>" },
	
	{{ "allogsm", "set", "next","simslot", NULL },
	handle_gsm_set_next_simslot, 
	"set next sim slot to <slot>","Usage: allogsm set next simslot <port> <nextslot>" },
	
	{{ "allogsm", "restart", "port", NULL },
	handle_gsm_restart_port, 
	"restart gsm port <port>","Usage: allogsm restart port <port>" },
	
	{{ "allogsm", "show", "ops", NULL },
	handle_gsm_show_ops, 
	"show list of operators","Usage: allogsm show ops <port>" },
	
	{{ "allogsm", "show", "status", NULL },
	handle_gsm_show_status, 
	"show status of gsm modules","Usage: allogsm show status" },
	
	{{ "allogsm", "peek", NULL },
	handle_gsm_peek, 
	"read value of a register in FPGA","Usage: allogsm peek <offset>" },
	
	{{ "allogsm", "poke", NULL },
	handle_gsm_poke, 
	"write value to a given register in FPGA","Usage: allogsm poke <offset> <value>" },
	
	{{ "allogsm", "set", "op", NULL },
	handle_gsm_set_op, 
	"set an operator","Usage: allogsm set op <port> \"<operator>\"" },
	
	{{ "allogsm", "request", "state", NULL },
	handle_gsm_request_state, 
	"only used by astmanproxy","Usage: allogsm request state" },
	
	{{ "allogsm", "show", "info", NULL },
	handle_gsm_show_info, 
	"show GSM information","Usage: allogsm show info" },
	
	{{ "allogsm", "restart", "plx", NULL },
	handle_gsm_restart_plx, 
	"Re initialize the PLX module.....","Usage: allogsm show info" },
	
	{{ "allogsm", "show", "version", NULL },
	handle_gsm_show_version, 
	"show version of the gsm channel driver","Usage: allogsm show version" }
};
#endif

/*manager commands*/
#if 1
static int action_send_sms(struct mansession *s, const struct message *m)
#else
static int action_send_sms(struct mansession *s, struct message *m)
#endif
{
        const char *port= astman_get_header(m, "Port");
        const char *number= astman_get_header(m, "Number");
        const char *text= astman_get_header(m, "Text");

        if (ast_strlen_zero(port)) {
                astman_send_error(s, m, "No port specified");
                return 0;
        }
        if (ast_strlen_zero(number)) {
                astman_send_error(s, m, "No number specified");
                return 0;
        }
        if (ast_strlen_zero(text)) {
                astman_send_error(s, m, "No text specified");
                return 0;
        }

	gsm_sms[atoi(port)].s=s;
	gsm_sms[atoi(port)].m=(struct message*)m;

	_gsm_queue_sms(atoi(port), number, text);


	astman_send_ack(s, m, "GsmSendSms: Success");
        return 0;
}

/*manager commands*/
#if 1
static int action_check_sms_state(struct mansession *s, const struct message *m)
#else
static int action_check_sms_state(struct mansession *s, struct message *m)
#endif
{
        const char *port= astman_get_header(m, "Port");

        if (ast_strlen_zero(port)) {
                astman_send_error(s, m, "No port specified");
                return 0;
        }

	char ack[256];
	if (gsm_sms[atoi(port)].state != GSM_SMS_STATE_NONE)
		sprintf(ack, "GsmCheckSMSState: State-Machine Busy (%d)", gsm_sms[atoi(port)].state);
	else
		sprintf(ack, "GsmCheckSMSState: State-Machine IDLE");

	astman_send_ack(s, m, ack);

        return 0;
}

#if 1
/*
 *  * some of the standard methods supported by channels.
 *   */
static int gsm_digit_begin(struct ast_channel *c, char digit)
{
	if (gsm_config_get_bool(SECT_GENERAL, CFG_GEN_DTMFBEGIN)) {
#ifdef ASTERISK_11_4
                struct gsm_pvt *gsm=ast_channel_tech_pvt(c);
#else
                struct gsm_pvt *gsm=c->tech_pvt;
#endif
        	char buf[16];

        	if (!gsm) return -1;

	        ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Sending DTMF %c\n", digit);
		if (gsm_debug)
			ast_log(LOG_DEBUG, "Sending DTMF %c\n", digit);
	        sprintf(buf,"at+vts=%c", digit);
        	gsm_send(gsm->port,buf,100);
	}	

	return 0;
}
#endif

#if 1
static int gsm_digit_end(struct ast_channel *c, char digit, unsigned int duration)
#else
static int gsm_digit_end(struct ast_channel *c, char digit)
#endif
{
	if (!gsm_config_get_bool(SECT_GENERAL, CFG_GEN_DTMFBEGIN)) {
#ifdef ASTERISK_11_4 
                struct gsm_pvt *gsm=ast_channel_tech_pvt(c);
#else
                struct gsm_pvt *gsm=c->tech_pvt;
#endif
	        char buf[16];

	        if (!gsm) return -1;
		
        	ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Sending DTMF %c\n", digit);
		if (gsm_debug)
			ast_log(LOG_DEBUG, "Sending DTMF %c\n", digit);
        	sprintf(buf,"at+vts=%c", digit);
	        gsm_send(gsm->port,buf,100);
	}

	return 0;
}


static int gsm_text(struct ast_channel *c, const char *text)
{
        /* print received messages */
        ast_verbose(CHAN_GSM_VERBOSE_PREFIX " << GSM Received text %s >> \n", text);
        return 0;
}

static int gsm_call(struct ast_channel *c, char *dest, int timeout)
{
#ifdef ASTERISK_11_4
        struct gsm_pvt *gsm=ast_channel_tech_pvt(c);
#else
        struct gsm_pvt *gsm=c->tech_pvt;
#endif
	int i=0;
	int hidecallerid=0;

	if (!gsm) return -1;

	char buf[128];
	char *port_str, *dad, *p;

	ast_copy_string(buf, dest, sizeof(buf)-1);
	p=buf;
	port_str=strsep(&p, "/");
	dad=strsep(&p, "/");

	if (gsm_debug)
#ifdef ASTERISK_11_4 
                ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Call: ext:%s port:%d dest:(%s) -> dad(%s) \n", ast_channel_exten(c), gsm->port, dest, dad);
#else
                ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Call: ext:%s port:%d dest:(%s) -> dad(%s) \n", c->exten, gsm->port, dest, dad);
#endif

	if (gsm_debug)
#ifdef ASTERISK_11_4
                ast_log(LOG_DEBUG, "Call: ext:%s port:%d dest:(%s) -> dad(%s) \n", ast_channel_exten(c), gsm->port, dest, dad);
#else
                ast_log(LOG_DEBUG, "Call: ext:%s port:%d dest:(%s) -> dad(%s) \n", c->exten, gsm->port, dest, dad);
#endif

	char dialstring[128];

	if (gsm->hidecallerid) {
		hidecallerid=1;
	}

	if (hidecallerid)
		sprintf(dialstring,"ATD#31#%s;",dad);
	else
		sprintf(dialstring,"ATD%s;",dad);

	if (gsm_debug)
		ast_log(LOG_DEBUG, "Dialstring is '%s'\n",dialstring);
	/* cannot use fetch_port() here as it has already been done */
#if 0
	if (!gsm_slcc[gsm->port].ringing) {
		gsm_send(gsm->port,dialstring,300);
		gsm->state=GSM_STATE_ATD_OUT;
	} else {

#ifdef ASTERISK_11_4
                ast_log(LOG_WARNING, "Call: ext:%s port:%d is busy (has an incoming call).\n", ast_channel_exten(c), gsm->port);
#else
                ast_log(LOG_WARNING, "Call: ext:%s port:%d is busy (has an incoming call).\n", c->exten, gsm->port);
#endif
		return -1;
	}
#endif
	if (gsm_slcc[gsm->port].ringing) {

#ifdef ASTERISK_11_4
                ast_log(LOG_WARNING, "Call: ext:%s port:%d is busy (has an incoming call).\n", ast_channel_exten(c), gsm->port);
#else
                ast_log(LOG_WARNING, "Call: ext:%s port:%d is busy (has an incoming call).\n", c->exten, gsm->port);
#endif
		return -1;
	}
	
	gsm->state=GSM_STATE_PRE_ATD;
	if (( gsm_sms[gsm->port].state == GSM_SMS_STATE_NONE )){
// || ( gsm_sms[gsm->port].state == GSM_SMS_STATE_SMS_SENT )){
		gsm_send(gsm->port,dialstring,300);
		gsm->state=GSM_STATE_ATD_OUT;
		//gsm_sms[gsm->port].state = GSM_SMS_STATE_NONE;
		return 0;
	}
	for (i=0;i<10;++i){
		sleep(1);
		if (( gsm_sms[gsm->port].state == GSM_SMS_STATE_NONE )){
// || ( gsm_sms[gsm->port].state == GSM_SMS_STATE_SMS_SENT )){
			gsm_send(gsm->port,dialstring,300);
			gsm->state=GSM_STATE_ATD_OUT;
			//gsm_sms[gsm->port].state = GSM_SMS_STATE_NONE;
        		ast_log(LOG_WARNING, "Call Initiation took us %d seconds to complete SMS transaction\n",i+1);
			return 0;
		}
	}

	gsm->state=GSM_STATE_NONE;
#ifdef ASTERISK_11_4
        ast_log(LOG_WARNING, "ext:%s port:%d is busy (Failed because of SMS Transaction. Please try again).\n", ast_channel_exten(c), gsm->port);
#else
        ast_log(LOG_WARNING, "ext:%s port:%d is busy (Failed because of SMS Transaction. Please try again).\n", c->exten, gsm->port);
#endif
	return -1;
}

static int gsm_answer(struct ast_channel *c)
{
#ifdef ASTERISK_11_4 
        struct gsm_pvt *gsm=ast_channel_tech_pvt(c);
#else
        struct gsm_pvt *gsm=c->tech_pvt;
#endif
	struct ctlport *ctl = getctlport(gsm->port);

	if (gsm_debug)
		ast_log(LOG_DEBUG, "Answering call on port:%d\n", gsm->port);

	//gsm_send(gsm->port,"ATA",100);
	if (send_expect(ctl, "ATA", "OK", 0, NULL, 0, DEFAULT_WAIT4MOD) <0) {
		ast_log(LOG_ERROR, "Answering call on port:%d failed !!!!!!!! \n", gsm->port);
	}
	gsm_slcc[gsm->port].ringing = 0;

	if (gsm_debug) 
		ast_log(LOG_DEBUG, "Updating LCD for port:%d to CHANNEL_STATE_IN_USE\n", gsm->port);

	gsm_set_channel_state(gsm->port, CHANNEL_STATE_IN_USE);
	gsm_send_channel_state(gsm->port, CHANNEL_STATE_IN_USE);
	return 0;
}

static int gsm_hangup(struct ast_channel *c)
{
#ifdef ASTERISK_11_4 
        struct gsm_pvt *gsm=ast_channel_tech_pvt(c);
#else
        struct gsm_pvt *gsm=c->tech_pvt;
#endif
	int port=gsm->port;

	gsm_put_priv(gsm->port,NULL);

	if (gsm_debug)
		ast_log(LOG_DEBUG, "Hanging up call on port:%d state:%d\n", gsm->port, gsm->state);

	if ((gsm->state != GSM_STATE_COLLISION) && (gsm->call_type != GSM_CALL_TYPE_SMS)  && ( gsm_sms[gsm->port].state == GSM_SMS_STATE_NONE )){
		if ((gsm->state==GSM_STATE_ATD_OUT)||(gsm->state==GSM_STATE_ALERTING)||(gsm->state==GSM_STATE_PROCEEDING))
		{
			gsm->state=GSM_STATE_HANGUPED;
			sleep(1); //1 second is the schedular time for CLCC execution; if we parallally do a hangup with clcc. we receive error.
		}
		gsm->state=GSM_STATE_HANGUPED;
		gsm_send(gsm->port,"ATH",100);
	}

	gsm_audio_stop(gsm->port);
//	gsm_audio_close(gsm->port);

	if (gsm->dsp)
			ast_dsp_free(gsm->dsp);
	if (gsm->trans)
			ast_translator_free_path(gsm->trans);

	free(gsm);
#ifdef ASTERISK_11_4
		ast_channel_tech_pvt_set(c, NULL);
#else
		c->tech_pvt = NULL;
#endif

	/* ringing cleared here with everything else */
	memset(&gsm_slcc[port],0,sizeof(gsm_slcc[port]));

	gsm_port_release(port);

	if (gsm_debug)
		ast_log(LOG_DEBUG, "Updating LCD for port:%d to CHANNEL_STATE_READY\n", gsm->port);

	/* update the LCD */
	gsm_set_channel_state(gsm->port, CHANNEL_STATE_READY);
	gsm_send_channel_state(port, CHANNEL_STATE_READY);

	return 0;
}

/* This is the Audio write function for the GSM. Here we need to write the frame data to the PLX chip. --- ALLO_GSM -- 19-09-2011 */
static int gsm_write(struct ast_channel *c, struct ast_frame *f)
{
#ifdef ASTERISK_11_4
        struct gsm_pvt *gsm= ast_channel_tech_pvt(c);
#else
        struct gsm_pvt *gsm= c->tech_pvt;
#endif	
	int count = 0, again = 100,
			len;

	switch (f->frametype) {
	case AST_FRAME_VOICE:
			do {
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
				len = cem_plx_audio_write( gsm->port , (char*)f->data.ptr , f->datalen );
				//len = write(gsm->portfd, (char*)f->data.ptr, f->datalen);
#endif
#ifdef ASTERISK_1_4
				len = cem_plx_audio_write( gsm->port , (char*)f->data , f->datalen );
				//len = write(gsm->portfd, (char*)f->data, f->datalen);
#endif
				//ast_log(LOG_WARNING, "%d: writing to port fd(%d) :len:%d:%d:\n", gsm->port, gsm->portfd, f->datalen, len );

				if (len < 0) {
					if (errno == EAGAIN) {
						//ast_log(LOG_DEBUG, "try again EAGAIN pending retries:%d:\n", again);
						continue ;
					}
					ast_log(LOG_WARNING, "%d: error writing to port fd(%d) error(%d,%s)\n", gsm->port, gsm->portfd, errno, strerror(errno));
					ast_queue_hangup(c);
					return 0;
				} else {
					count += len;
				}
			} while (again-- && count < f->datalen);
			//ast_log(LOG_ERROR , "[ALLO_GSM] We are out of the while loop to write into the GSM....... count '%d' f->datalen '%d' \n" , count , f->datalen  );
			if (count < f->datalen) {
				gsm->dropcnt++ ;
				ast_log(LOG_WARNING, "%d: port congestion, dropping %d of %d frames :%d:\n", gsm->port, f->datalen - count, f->datalen, gsm->dropcnt);
			}
			break;
	default:
			ast_log(LOG_WARNING, "%d unhandled frame type: %d\n",gsm->port, f->frametype);
			return -1;
	}

	return 0;
}

static struct ast_frame *gsm_read_dtmf(struct ast_channel *c, char *event)
{
        char *p,*tmp,*c_dtmf;
        int dtmf;
#ifdef ASTERISK_11_4 
        struct gsm_pvt *gsm =ast_channel_tech_pvt(c);
#else
        struct gsm_pvt *gsm =c->tech_pvt;
#endif
        struct ast_frame f = { AST_FRAME_DTMF, };
        p=strchr(event, ":");
        char *q = strsep(&event,",");
        f.len=atoi(event);
       //ast_log(LOG_ERROR,"Char is %s,%s,%s\n",event,p,q);
        if(atoi(event)>=80)
	{
        if (q)
        {
        char *s = strstr(q," ");
        while(*s != '\0')
        {
        if(*s  == '"')
         s++;
        else{
        tmp=s,s++ ;}
        }
//      ast_log(LOG_ERROR,"Char is %s,%s\n",q,tmp);
        if((tmp[0]== '*')|| (tmp[0]=='#'))
        {
        c_dtmf=tmp[0] ;
        ast_log(LOG_DTMF,"DTMF Received is %c \n",c_dtmf);
        }
        else
        {       
        dtmf = atoi(tmp);
        ast_log(LOG_DTMF,"DTMF Received is %d \n",dtmf);
        }
        }
#if ( defined ASTERISK_1_8 || ASTERISK_10_4 )
        if(c_dtmf)
         ast_manager_event(c,EVENT_FLAG_DTMF,
                "DTMF",
                "Channel: %s\r\n"
                "Uniqueid: %s\r\n"
                "Digit: %c\r\n"
                "Direction: %s\r\n"
                "Begin: %s\r\n"
                "End: %s\r\n",
#ifdef ASTERISK_11_4
                ast_channel_name(c),
                ast_channel_uniqueid(c),
#else
                c->name , c->uniqueid ,
#endif
                c_dtmf ,"Received" , "No","Yes");
        else
        ast_manager_event(c,EVENT_FLAG_DTMF,
                "DTMF",
                "Channel: %s\r\n"
                "Uniqueid: %s\r\n"
                "Digit: %d\r\n"
                "Direction: %s\r\n"
                "Begin: %s\r\n"
                "End: %s\r\n",
#ifdef ASTERISK_11_4
                ast_channel_name(c),
                ast_channel_uniqueid(c),
#else
                c->name , c->uniqueid ,
#endif
                c_dtmf ,"Received" , "No","Yes");

#endif
//      ast_log(LOG_DTMF, "DTMF   %d received on %s\n", dtmf, c->name );
        int dtmf_char;
        if ( c_dtmf =='*') {
                dtmf_char = '*' ;
        } else if (c_dtmf == '#') {
                dtmf_char = '#';
        } else if (dtmf < 10) {
                dtmf_char = '0' + dtmf;
        } else {
                dtmf_char = 'A' + (dtmf - 12);
        }
#if ( defined ASTERISK_1_6_2 || defined ASTERISK_1_4 )
        f.subclass = dtmf_char;
#else
        f.subclass.integer = dtmf_char;
#endif
        ast_queue_frame(c, &f);
	}
	else
	return 1 ;
	
}




/* This is the Audio read function for the GSM. Here we need to read from the PLX chip based on the port number of the GSM.. Also here we need to read byte by byte and we need to create the frame and send it to Asterisk --- ALLO_GSM -- 19-09-2011 */
static struct ast_frame *gsm_read(struct ast_channel *c)
{
#ifdef ASTERISK_11_4 
        struct gsm_pvt *gsm = ast_channel_tech_pvt(c);
#else
        struct gsm_pvt *gsm = c->tech_pvt;
#endif
	int count;
//	static int isnull = 0;

#if 0
	/* This is for the rtp read .. new architecture --- ALLO_GSM -- 09-12-2011 */
	struct ast_frame *f;
	struct ctlport *ctl=getctlport(gsm->port);
	f = ast_rtp_read(ctl->rtp);
#endif

	/* In every GSM pvt structure, we need to have ping-pong buffer for Read & Write 
	 * Also for each pvt structure of the GSM we need to have one lock which will prohibits
	 * the over writing of the Data.
	 * Also we need to think of the logic which will fo the needfull for the 
	 * Ping-Pong buffer, to shuffel the pointer locations. 
	 * This is the pointer for read and write cycle of Asterisk...
	 * This pointer will be shuffled between the calls........ ALLO_GSM -- 29-09-2011 */
	count = cem_plx_audio_read( gsm->port , gsm->readbuf , sizeof(gsm->readbuf) );
	//ast_log(LOG_ERROR , "[ALLO_GSM] We are reading the PLX for the Audio !!!!! with total bytes read is '%d' and total size we passed '%d' \n" , count , sizeof(gsm->readbuf) );
	
	if(count<0) {
		ast_log(LOG_ERROR , "[ALLO_GSM] Are we getting error while reading################################ \n" );
		ast_log(LOG_ERROR, "Error: reading gsm port(%d) %s\n",gsm->port, strerror(errno) ) ;
		return NULL ;
	}

	//ast_log(LOG_ERROR , "[ALLO_GSM] b4 adding it to the datalen '%d' \n" , count);
	gsm->read_f.samples = count;
	gsm->read_f.datalen = count;
	gsm->read_f.delivery = ast_tv(0,0);
#if 1 /* PROPER READ */
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
	gsm->read_f.data.ptr = gsm->readbuf;
#endif
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 )
        gsm->read_f.subclass.format.id=GSM_AUDIO_FORMAT;
#endif
#ifdef ASTERISK_1_4
	gsm->read_f.data = gsm->readbuf;
#endif
	gsm->read_f.mallocd = 0;
	gsm->read_f.frametype= AST_FRAME_VOICE;
#ifdef ASTERISK_1_8  
	gsm->read_f.subclass.codec= GSM_AUDIO_FORMAT;
#endif
#if (defined ASTERISK_1_4 || defined ASTERISK_1_6_2)
	gsm->read_f.subclass= GSM_AUDIO_FORMAT;
#endif
#else /* FOR NO VOICE */
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defiend ASTERISK_1_8 || defined ASTERISK_1_6_2)
	gsm->read_f.data.ptr = NULL ;
#endif
#ifdef ASTERISK_1_4
	gsm->read_f.data = NULL ;
#endif
	gsm->read_f.mallocd = 0;
	gsm->read_f.frametype= AST_FRAME_NULL ;
	gsm->read_f.subclass.codec= GSM_AUDIO_FORMAT;
#endif

	//ast_log(LOG_ERROR , "[ALLO_GSM] WE are retrning the audio frame...... with frame type '%s' with the datalen '%d' count '%d' gsm->read_f.samples '%d' \n" , (gsm->read_f.frametype == AST_FRAME_VOICE) ? "AST_FRAME_VOICE" : "AST_FRAME_NULL" , gsm->read_f.datalen , count , gsm->read_f.samples );
	return &gsm->read_f;
}

static int gsm_fixup(struct ast_channel *oldchan, struct ast_channel *newchan)
{
#ifdef ASTERISK_11_4
        struct gsm_pvt *p = ast_channel_tech_pvt(newchan);
#else
        struct gsm_pvt *p = newchan->tech_pvt;
#endif

	if (p->ast_chan == oldchan) {
		p->ast_chan = newchan;
	}

	gsm_masq_priv(oldchan,newchan);

        return 0;
}

#if 1
static int gsm_indicate(struct ast_channel *c, int cond, const void *data, size_t datalen)
#else
static int gsm_indicate(struct ast_channel *c, int cond)
#endif
{
        int res = -1;

        switch (cond) {
                case AST_CONTROL_BUSY:
                case AST_CONTROL_CONGESTION:
                case AST_CONTROL_RINGING:
			return -1;
                case -1:
                        return 0;

                case AST_CONTROL_VIDUPDATE:
                        res = -1;
                        break;
                case AST_CONTROL_HOLD:
                        //ast_moh_start(c, data, g->mohinterpret);
                        break;
                case AST_CONTROL_UNHOLD:
                        //ast_moh_stop(c);
                        break;
                default:
                        //ast_log(LOG_NOTICE, "Don't know how to display condition %d on %s\n", cond, c->name);
                        return -1;
        }

        return 0;
}

static struct ast_channel * gsm_new (struct gsm_pvt *gsm, const char *exten, const char *cidnum, char *cidname, const int state)
{
	struct ast_channel *tmp;
	char gsmname[128];
	sprintf(gsmname,"GSM/%d", gsm->port);

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 )
        struct ast_format gsm_audio_format;
        gsm_audio_format.id = GSM_AUDIO_FORMAT;
#endif

	if (gsm_debug)
		ast_log(LOG_DEBUG, "Allocating new channel for port:%d\n", gsm->port);

#if 1
        //tmp = ast_channel_alloc(1, state, cidnum , cidname, gsmname);
	tmp = ast_channel_alloc(1, state, cidnum, cidname, "", exten, "", 0, "" , gsmname);
#else
        tmp = ast_channel_alloc(1);

#endif

        if (tmp) {
#if 1
#ifdef ASTERISK_11_4 
                        ast_channel_name_set(tmp, gsmname);
#else
                        ast_string_field_build(tmp, name, "%s", gsmname);
#endif

#else
			sprintf(tmp->name, "%s", gsmname);
			ast_setstate(tmp, state);
			tmp->type=gsm_tech.type;
#endif
#ifdef ASTERISK_11_4
                        ast_channel_tech_set(tmp, &gsm_tech);
                        ast_channel_tech_pvt_set(tmp, gsm);
#else
                        tmp->tech = &gsm_tech;
                        tmp->tech_pvt = gsm;
#endif
	
			gsm->portfd=gsm_audio_open(gsm->port);
			
			if (gsm->portfd>=0) {
#ifdef ASTERISK_11_4
                                ast_channel_internal_fd_set(tmp, 0, gsm->portfd);
#else
                                tmp->fds[0] = gsm->portfd;
#endif
			} else {
				ast_log(LOG_WARNING, "Could not open audio fd (%s)\n", strerror(errno));
			}
			
#ifdef ASTERISK_11_4    
                        struct ast_format tmpfmt;
                        ast_format_cap_add(ast_channel_nativeformats(tmp), ast_format_set(&tmpfmt, GSM_AUDIO_FORMAT, 0));
                        ast_format_copy(ast_channel_readformat(tmp), &tmpfmt);
                        ast_format_copy(ast_channel_writeformat(tmp), &tmpfmt);
#endif
#ifdef ASTERISK_10_4
                        struct ast_format tmpfmt;
                        ast_format_cap_add(tmp->nativeformats, ast_format_set(&tmpfmt, GSM_AUDIO_FORMAT, 0));
                        ast_format_copy(&tmp->readformat, &tmpfmt);
                        ast_format_copy(&tmp->writeformat, &tmpfmt);
#endif
#if ( defined ASTERISK_1_8 || defined ASTERISK_1_6_2 || defined ASTERISK_1_4 )
                        tmp->nativeformats = GSM_AUDIO_FORMAT;
                        tmp->readformat = GSM_AUDIO_FORMAT;
                        tmp->writeformat = GSM_AUDIO_FORMAT;
#endif
			if (exten){
#ifdef ASTERISK_11_4 
                                ast_channel_exten_set(tmp, exten);
#else
                                ast_copy_string(tmp->exten, exten, AST_MAX_EXTENSION);
#endif
                        }
			
#ifdef ASTERISK_11_4 
                        ast_channel_context_set(tmp, gsm->context);
#else
                        ast_copy_string(tmp->context, gsm->context, AST_MAX_CONTEXT);
#endif
	
			if (cidnum) {
#ifdef ASTERISK_11_4 
                                ast_channel_caller(tmp)->ani.number.str = strdup(cidnum);
#endif
#if ( defined ASTERISK_10_4 || defined ASTERISK_1_8  )
				tmp->caller.ani.number.str = strdup(cidnum);
#endif
#if ( defined ASTERISK_1_4 || defined ASTERISK_1_6_2 )
				tmp->cid.cid_num = strdup(cidnum);
#endif
			}
			
			if (cidname){
#ifdef ASTERISK_11_4 
                                ast_channel_caller(tmp)->ani.name.str = strdup(cidname);
#endif
#if (defined ASTERISK_10_4 || defined ASTERISK_1_8)
				tmp->caller.ani.name.str = strdup(cidname);
#endif
#if (defined ASTERISK_1_4 || defined ASTERISK_1_6_2)
				tmp->cid.cid_name = strdup(cidname);
#endif
			}
#if 0
		ast_mutex_lock(&bnxgsm_usecnt_lock);
		++bnxgsm_usecnt;
		ast_mutex_unlock(&bnxgsm_usecnt_lock);
#endif
			ast_update_use_count();
		}
		
		gsm->ast_chan = tmp;

	gsm->dsp=ast_dsp_new();
	gsm->dropcnt = 0 ;
	
	if (gsm->dsp) {
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 || defined ASTERISK_1_6_2 )
		ast_dsp_set_features(gsm->dsp, DSP_FEATURE_DIGIT_DETECT );
#endif
#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 || defined ASTERISK_1_8 )
		if (gsm_config_get_bool(SECT_GENERAL, CFG_GEN_RELAXDTMF))
			ast_dsp_set_digitmode(gsm->dsp,
					DSP_DIGITMODE_DTMF |
					DSP_DIGITMODE_RELAXDTMF); // SAM
#endif
#ifdef ASTERISK_1_4
		ast_dsp_set_features(gsm->dsp, DSP_FEATURE_DTMF_DETECT );
		/*if (gsm_config_get_bool(SECT_GENERAL, CFG_GEN_RELAXDTMF))
			ast_dsp_set_digitmode(gsm->dsp,
					DSP_DIGITMODE_DTMF |
					DSP_DIGITMODE_RELAXDTMF); // SAM*/
#endif
	} else { 
		ast_log(LOG_ERROR, " NO DSP!!!!!\n"); // SAM DBG
	}

#if ( defined ASTERISK_11_4 || defined ASTERISK_10_4 )
        struct ast_format ast_format_slin_temp;
        ast_format_slin_temp.id = AST_FORMAT_SLINEAR;
        gsm->trans=ast_translator_build_path(&ast_format_slin_temp, &gsm_audio_format);
#else
        gsm->trans=ast_translator_build_path(AST_FORMAT_SLINEAR, GSM_AUDIO_FORMAT);
#endif

	gsm_put_priv(gsm->port, tmp);
	gsm->state=GSM_STATE_NONE;
	gsm->call_type=GSM_CALL_TYPE_VOICE;

	return tmp;
}

#define gsm_cfg_get_array(name, buf, target, slot)  {char *p1, *p2, *s; \
		s=buf;\
		/*ast_verbose("CFG: element '%s' splitting '%s'\n",name, buf);*/\
		p1=strsep(&s, ","); p2=strsep(&s, ",");\
			if (slot && p2 ) {\
				strcpy(target,p2);\
			} else if (p1)  {\
				strcpy(target,p1);\
			} else {\
				strcpy(target,buf);\
			}\
			/*ast_verbose("CFG: using '%s'\n",target);*/\
		}


static void configure_gsm(struct gsm_pvt *gsm)
{
	int simslot=gsm_simslot_get(gsm->port);
	char context[sizeof(gsm->context)];
	char exten[sizeof(gsm->exten)];
	char hc[32];

	if (gsm_debug)
		ast_log(LOG_DEBUG, "Configuring gsm channel for port:%d\n", gsm->port);

	if (cm_get(config, context, sizeof(context), SECT_PORT, CFG_PORT_CONTEXT, gsm->port)) {
		strcpy(context,default_context);
	}

	gsm_cfg_get_array("context", context, gsm->context, simslot);

	if (cm_get(config, exten, sizeof(exten), SECT_PORT, CFG_PORT_EXTEN, gsm->port)) {
		strcpy(exten,default_exten);
	}

	gsm_cfg_get_array("exten", exten, gsm->exten, simslot);

	if (cm_get(config, hc, sizeof(hc), SECT_PORT, CFG_PORT_HIDECALLERID, gsm->port)) {
		strcpy(hc,"no");
	}

	gsm_cfg_get_array("hidecallerid",hc, hc, simslot);
	gsm->hidecallerid=ast_true(hc);

}

static int check_and_fetch_port(int port)
{
	if (!gsm_port_is_valid(port)) {
		ast_log(LOG_WARNING, "Port:'%d' is not configured, please review your gsm.conf\n",port);
		return -1;
	}

	if (gsm_status[port].status != GSM_STATUS_REGISTERED) {
		ast_log(LOG_WARNING, "There is no Registration for port :%d\n",port);
		//return -1;
		return 0;
	}

	/* gsm_port_fetch is the last Test which might return NULL, else we need to
	 * gsm_port_release, because the in_use flag would stick otherwise */
	if (!gsm_port_fetch(port)) {
		ast_log(LOG_WARNING, "There is already a call on port :%d\n",port);
		return -1;
	}

	return 0;
}


void *csel_occupy (void *p)
{
	int port = (int)p;

	if (!check_and_fetch_port(port))
		return p;

	return NULL;
}
#ifdef ASTERISK_11_4
static struct ast_channel *gsm_request(const char *type, struct ast_format_cap *cap, const struct ast_channel *requestor, const char *gsm_data, int *cause)
#endif
#ifdef ASTERISK_10_4
static struct ast_channel *gsm_request(const char *type, struct ast_format_cap *cap, const struct ast_channel *requestor, void *gsm_data, int *cause)
#endif
#ifdef ASTERISK_1_8
static struct ast_channel *gsm_request(const char *type, format_t format, const struct ast_channel *requestor , void *gsm_data, int *cause)
#endif
#if (defined ASTERISK_1_4 || defined ASTERISK_1_6_2)
static struct ast_channel *gsm_request(const char *type, int format,  void *gsm_data, int *cause)
#endif
{

	char buf[128];
	char *port_str, *ext, *p;
	int port;

	if (!gsm_data){
		ast_log(LOG_ERROR , "[ALLO_GSM] Ops !!!! there is no gsm_data '%p' so returning NULL !!!!!!!!!!!!!!!!!!!!!!!!\n" , gsm_data );
		return NULL;
	}
	ast_log(LOG_DEBUG , "[ALLO_GSM] gsm_data '%s' \n" , (char *)gsm_data );
	ast_copy_string(buf, gsm_data, sizeof(buf)-1);
	p=buf;
	port_str=strsep(&p, "/");
	ext=strsep(&p, "/");
	ast_verbose(CHAN_GSM_VERBOSE_PREFIX "portstr:'%s' ext:'%s' gsm_data '%s'\n",port_str, ext , (char *)gsm_data);

	if (gsm_debug)
		ast_log(LOG_DEBUG, "portstr:'%s' ext:'%s' gsm_data '%s'\n",port_str, ext , (char *)gsm_data );

	if (port_str[0] == 'g' && port_str[1] == ':') {
		char *group = &port_str[2];
		struct csel *cs=NULL;
		int i;
		//Group Call, so let's find a free port
		ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Group call on group: %s\n", group);

		for (i=0;i<MAX_GSM_PORTS; i++) {
			if (csel_groups[i].name &&
				!strcasecmp(csel_groups[i].name, group)) {
					cs=csel_groups[i].cs;
					break;
				}
		}

		if (cs) {
			void *p=csel_get_next(cs);
			if (!p) {
				ast_log(LOG_WARNING, "No free port in group: %s\n",group);
				return NULL;
			}

			port=(int)p;
		} else {
			ast_log(LOG_WARNING,"group: %s not configured\n",group);
			return NULL;
		}

	} else {
		port=strtol(port_str, NULL, 10);

		if (check_and_fetch_port(port)<0){
			ast_log(LOG_ERROR , "[ALLO_GSM] port may be invalid !!!!!!!!!!! \n" );
			return NULL;
		}
	}

	struct gsm_pvt *gsm=malloc(sizeof(struct gsm_pvt));

	if (!gsm) {
		ast_log(LOG_ERROR , "[ALLO_GSM] ops !!!!!!!!! we failed to get the gsm_pvt allocation from malloc !!!!!!!!!!!!!! \n" );
		return NULL;
	}

	memset(gsm,0,sizeof(struct gsm_pvt));
	
	gsm->port=port;

	configure_gsm(gsm);

	if (gsm_debug)
		ast_log(LOG_DEBUG, "Updating LCD for port:%d to CHANNEL_STATE_IN_USE\n", gsm->port);

	gsm_set_channel_state(gsm->port, CHANNEL_STATE_IN_USE);
	gsm_send_channel_state(gsm->port, CHANNEL_STATE_IN_USE);

	return gsm_new(gsm, ext, NULL, NULL, AST_STATE_RINGING);
}


/*sms functions*/

static void output_sms(int port, struct gsm_sms_message *msg)
{
	ast_verbose(CHAN_GSM_VERBOSE_PREFIX "P(%d) SMS RECEIVED: Idx(%d) Number(%s) Date(%s) Text(%s)\n", port,
			msg->idx,
			msg->number,
			msg->date,
			msg->text
			);
}

static void read_sms_pbx_variable(struct ast_channel *ast_chan, int port, struct gsm_sms_message *msg)
{
	char arg_port[2], arg_index[8];
	sprintf(arg_port,"%d", port);
	sprintf(arg_index,"%d", msg->idx);
	pbx_builtin_setvar_helper(ast_chan, "SMSPORT", arg_port);
	pbx_builtin_setvar_helper(ast_chan, "SMSIDX", arg_index);
	pbx_builtin_setvar_helper(ast_chan, "SMSSRC", msg->number);
	pbx_builtin_setvar_helper(ast_chan, "SMSDATE", msg->date);   
	pbx_builtin_setvar_helper(ast_chan, "SMSTEXT", msg->text);
}

static void save_sms(int port, struct gsm_sms_message *msg)
{
	char filename[128];
	cm_get(config, filename, sizeof(filename)-32, SECT_GENERAL, CFG_GEN_SMS_DIR );

	if (!strlen(filename)) {
		ast_log(LOG_WARNING,"cannot save sms, no directory specified (see gsm.conf)\n");
		return;
	}

	struct timeval tv;
	gettimeofday(&tv,NULL);

	char name[64];
	sprintf(name,"/%d-%d-port-%d.sms",(int)tv.tv_sec, (int)tv.tv_usec, port);
	strcat(filename, name);

	ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Saving SMS in %s\n",filename);

	FILE *f=fopen(filename, "w+");

	if (!f) {
		ast_log(LOG_WARNING,"cannot save sms at (%s) error (%s)\n",filename, strerror(errno));
		return;
	}

	fprintf(f,"port=%d\n", port);

	if (gsm_cfg[port].sms_pdu_mode) {
		fprintf(f,"pdu_len=%d\n", msg->pdu_len);
	} else {
		fprintf(f,"callerid=%s\n", msg->number);
		fprintf(f,"date=%s\n", msg->date);
	}
	fprintf(f,"text=%s\n", msg->text);

	fclose(f);

	/*generate a Manager Event*/
	if (gsm_cfg[port].sms_pdu_mode)
		manager_event(EVENT_FLAG_CALL, "NewSMS_PDU", "Port: %d\r\nPDU_LEN: %d\r\nText: %s\r\n", port, msg->pdu_len, msg->text);
	else
		manager_event(EVENT_FLAG_CALL, "NewSMS", "Port: %d\r\nCallerID: %s\r\nDate: %s\r\nText: %s\r\n", port, msg->number, msg->date, msg->text);

}

static int sms_idx[256];


static void sms_idx_add(int idx)
{
	int i;
	for (i=0; i<256; i++) {
		if (!sms_idx[i]) {
			sms_idx[i]=idx;
			//ast_verbose("adding i%d idx %d\n", i,idx);
			break;
		}
	}
}

static int sms_idx_get_next()
{
	int i;
	for (i=0; i<256; i++) {
		if (sms_idx[i]) {
			int idx=sms_idx[i];
			sms_idx[i]=0;
			//ast_verbose("returnind i%d idx %d\n", i,idx);
			return idx;
		}
	}
	return 0;
}

enum gsm_events {
	GSM_EVENT_NONE=0,
	GSM_EVENT_CLIP,				/* callerid */
	GSM_EVENT_RING,				/* ringing */
	GSM_EVENT_BUSY,				/* busy */
	GSM_EVENT_NO_ANSWER,			/* no answer */
	GSM_EVENT_NO_CARRIER,			/* no carrier */
	GSM_EVENT_OK,				/* ok */
	GSM_EVENT_CLCC_CALL_0,			/* active call */
	GSM_EVENT_CLCC_CALL_1,			/* incoming call */
	GSM_EVENT_CLCC_CALL_2,			/* dialing call */
	GSM_EVENT_CLCC_CALL_3,			/* alerting call */
	GSM_EVENT_CSQ,				/* signal strength response */
	GSM_EVENT_CREG_SERVICE_0,		/* not registered, and not looking for a new operator to register to */
	GSM_EVENT_CREG_SERVICE_1,		/* registered, home network */
	GSM_EVENT_CREG_SERVICE_2,		/* not registered, and looking for a new operator to register to */
	GSM_EVENT_CREG_SERVICE_3,		/* registration denied */
	GSM_EVENT_CREG_SERVICE_4,		/* unknown */
	GSM_EVENT_CREG_SERVICE_5,		/* registered and roaming (not on home network) */
	GSM_EVENT_ENTER_SMS,			/* sms entry prompt */
	GSM_EVENT_SMS_ECHO,
	GSM_EVENT_SMS_CMGL_ECHO,		/* list sms messages */
	GSM_EVENT_SMS_TRANSMITTED,		/* sms transmission indication */
	GSM_EVENT_SMS_NEW_MESSAGE_LIST,		/* sms message list item */
	GSM_EVENT_SMS_INCOMING_MESSAGE,		/* new incoming message */
	GSM_EVENT_ERROR,			/* error */
	GSM_EVENT_COPS,				/* provider query */
	GSM_EVENT_INIT,				/* initialization */
	GSM_EVENT_CUSD,				/* CUSD */
	GSM_EVENT_MODEM_CHECK_ERROR,		/* keep it for now */
	GSM_EVENT_CALL_READY,			/* call ready message */
	GSM_EVENT_SIM_PIN,			/* making call ready message */
	GSM_EVENT_COPN,				/* read operator names */
	//GSM_EVENT_CLIP,				/* callerid */
	GSM_EVENT_CME_ERROR,			/* CME error  */
	GSM_EVENT_CMS_ERROR,			/* CMS error  */
	GSM_EVENT_SIM_INSERTED,			/* SIM insertion event */
	GSM_EVENT_SIM_REMOVED,			/* SIM insertion event */
	GSM_EVENT_RESET,			/* SIM Reset*/
	GSM_EVENT_REMOTE_RING,			/* SIM remote ringing*/
	GSM_EVENT_EMG_CALL,			/* SIM network avail for emergency call*/
        GSM_EVENT_DTMF_RECEIVED,                /* DTMF Received*/
	GSM_EVENT_SMS_NEW_MESSAGE,		/* sms message item */

};

#define NUM_EVENTS	38
struct events{
	int id;
	char *text ;
	char *text_str ;
};

struct events events_list[NUM_EVENTS]={
	{GSM_EVENT_NONE, "EVENT NONE", "GSM_EVENT_NONE"},
	{GSM_EVENT_RING, "ringing", "GSM_EVENT_RING"},
	{GSM_EVENT_BUSY, "busy", "GSM_EVENT_BUSY"},
	{GSM_EVENT_NO_ANSWER, "no answer", "GSM_EVENT_NO_ANSWER"},
	{GSM_EVENT_NO_CARRIER, "no carrier", "GSM_EVENT_NO_CARRIER"},
	{GSM_EVENT_OK, "ok", "GSM_EVENT_OK"},
	{GSM_EVENT_CLCC_CALL_0, "active call", "GSM_EVENT_CLCC_CALL_0"},
	{GSM_EVENT_CLCC_CALL_1, "incoming call", "GSM_EVENT_CLCC_CALL_1"},
	{GSM_EVENT_CLCC_CALL_2, "dialing call", "GSM_EVENT_CLCC_CALL_2"},
	{GSM_EVENT_CLCC_CALL_3, "alerting call", "GSM_EVENT_CLCC_CALL_3"},
	{GSM_EVENT_CSQ, "signal strength response", "GSM_EVENT_CSQ"},
	{GSM_EVENT_CREG_SERVICE_0, "not registered, and not looking for a new operator to register to", "GSM_EVENT_CREG_SERVICE_0"},
	{GSM_EVENT_CREG_SERVICE_1, "registered, home network", "GSM_EVENT_CREG_SERVICE_1"},
	{GSM_EVENT_CREG_SERVICE_2, "not registered, and looking for a new operator to register to", "GSM_EVENT_CREG_SERVICE_2"},
	{GSM_EVENT_CREG_SERVICE_3, "registration denied", "GSM_EVENT_CREG_SERVICE_3"},
	{GSM_EVENT_CREG_SERVICE_4, "unknown", "GSM_EVENT_CREG_SERVICE_4"},
	{GSM_EVENT_CREG_SERVICE_5, "registered and roaming (not on home network)", "GSM_EVENT_CREG_SERVICE_5"},
	{GSM_EVENT_ENTER_SMS, "sms entry prompt", "GSM_EVENT_ENTER_SMS"},
	{GSM_EVENT_SMS_ECHO, " EVENT SMS ECHO", "GSM_EVENT_SMS_ECHO"},
	{GSM_EVENT_SMS_CMGL_ECHO, "list sms messages", "GSM_EVENT_SMS_CMGL_ECHO"},
	{GSM_EVENT_SMS_TRANSMITTED, "sms transmission indication", "GSM_EVENT_SMS_TRANSMITTED"},
	{GSM_EVENT_SMS_NEW_MESSAGE_LIST, "sms message list item", "GSM_EVENT_SMS_NEW_MESSAGE_LIST"},
	{GSM_EVENT_SMS_INCOMING_MESSAGE, "new incoming message", "GSM_EVENT_SMS_INCOMING_MESSAGE"},
	{GSM_EVENT_ERROR, "error", "GSM_EVENT_ERROR"},
	{GSM_EVENT_COPS, "provider query", "GSM_EVENT_COPS"},
	{GSM_EVENT_INIT, "initialization", "GSM_EVENT_INIT"},
	{GSM_EVENT_CUSD, "CUSD", "GSM_EVENT_CUSD"},
	{GSM_EVENT_MODEM_CHECK_ERROR, "keep it for now", "GSM_EVENT_MODEM_CHECK_ERROR"},
	{GSM_EVENT_CALL_READY, "call ready message", "GSM_EVENT_CALL_READY"},
	{GSM_EVENT_COPN, "read operator names", "GSM_EVENT_COPN"},
	{GSM_EVENT_CLIP, "callerid", "GSM_EVENT_CLIP"},
	{GSM_EVENT_CME_ERROR, "CME error ", "GSM_EVENT_CME_ERROR,"},
	{GSM_EVENT_CMS_ERROR, "CMS error ", "GSM_EVENT_CMS_ERROR"},
	{GSM_EVENT_SIM_INSERTED, "SIM insertion event", "GSM_EVENT_SIM_INSERTED"},
	{GSM_EVENT_SIM_REMOVED, "SIM insertion event", "GSM_EVENT_SIM_REMOVED"},
	{GSM_EVENT_RESET, "SIM Reset", "GSM_EVENT_RESET"},
	{GSM_EVENT_REMOTE_RING, "SIM remote ringing", "GSM_EVENT_REMOTE_RING"},
	{GSM_EVENT_EMG_CALL, "SIM network avail for emergency call", "GSM_EVENT_EMG_CALL"},
        {GSM_EVENT_DTMF_RECEIVED, "Receiving DTMF", "GSM_EVENT_DTMF_RECEIVED"},
	{GSM_EVENT_SMS_NEW_MESSAGE, "sms message item", "GSM_EVENT_SMS_NEW_MESSAGE"}

	
};

/* parse the call info structure and return the state of the call */
/* note that we do one active call at a time */
static enum gsm_events parse_current_call_state(const char *event)
{
	if (gsm_debug)
		ast_log(LOG_DEBUG, "%s() : event = %s\n", __FUNCTION__, event);

	if (strstr(event, "+CLCC: 1,0,0")) 				
		return GSM_EVENT_CLCC_CALL_0;	/* active -- connected */
	else if (strstr(event, "+CLCC: 1,0,3"))
		return GSM_EVENT_CLCC_CALL_3;	/* alerting */
	else if (strstr(event, "+CLCC: 1,0,2")) 
		return GSM_EVENT_CLCC_CALL_2;	/* dialing */
	else if (strstr(event, "+CLCC: 1,1")) {
		return GSM_EVENT_CLCC_CALL_1;   /* incoming (held) call */
	} else
		return GSM_EVENT_NONE;		/* none that we know of */
}

static enum gsm_events parse_events (char *event) {

	if (gsm_debug) 
		ast_log(LOG_DEBUG, "%s() : event = %s\n", __FUNCTION__, event);

	if (strstr(event, "RING"))
		return GSM_EVENT_RING;
	else if (strstr(event, "+CLIP:"))
		return GSM_EVENT_CLIP;
       else if (strstr(event,"WDDI:"))
                return GSM_EVENT_DTMF_RECEIVED ;
	else if (strstr(event, "BUSY"))
		return GSM_EVENT_BUSY;
	else if (strstr(event, "+CLCC: 1")) 
		return parse_current_call_state(event);
	else if (strstr(event, "NO ANSWER"))
		return GSM_EVENT_NO_ANSWER;
	else if (strstr(event, "NO CARRIER"))
		return GSM_EVENT_NO_CARRIER;
	else if (strstr(event, "+CSQ: "))
		return GSM_EVENT_CSQ;
	else if (strstr(event, "+CREG: 1,0") || strstr(event, "+CREG: 0,0") || strstr(event, "+CREG: 0"))		
		/* not registered and not trying to register */
		return GSM_EVENT_CREG_SERVICE_0;
	else if (strstr(event, "+CREG: 1,1") || strstr(event, "+CREG: 0,1") || strstr(event, "+CREG: 1"))		
		/* registered in the homezone */
		return GSM_EVENT_CREG_SERVICE_1;
	else if (strstr(event, "+CREG: 1,2") || strstr(event, "+CREG: 0,2") || strstr(event, "+CREG: 2"))		
		/* not registered but trying to register */
		return GSM_EVENT_CREG_SERVICE_2;
	else if (strstr(event, "+CREG: 1,3") || strstr(event, "+CREG: 0,3") || strstr(event, "+CREG: 3"))		
		/* registration denied */
		return GSM_EVENT_CREG_SERVICE_3;
	else if (strstr(event, "+CREG: 1,4") || strstr(event, "+CREG: 0,4") || strstr(event, "+CREG: 4"))		
		/* unknown */
		return GSM_EVENT_CREG_SERVICE_4;
	else if (strstr(event, "+CREG: 1,5") || strstr(event, "+CREG: 0,5") || strstr(event, "+CREG: 5"))		
		/* registered and roaming */
		return GSM_EVENT_CREG_SERVICE_5;
	else if (strstr(event, "+CREG: 1"))
		return GSM_EVENT_CREG_SERVICE_1;
	else if (strstr(event, "+CREG:"))
		return GSM_EVENT_CREG_SERVICE_0;
	else if (strstr(event, "Call Ready"))
		return GSM_EVENT_CALL_READY;
        else if (strstr(event, "+CPIN: SIM PIN"))
                return GSM_EVENT_SIM_PIN;
	else if (strstr(event, "+CPIN: READY"))
	{
		return GSM_EVENT_CALL_READY;
	}
	else if (strstr(event, "+CMGW: "))
		return GSM_EVENT_SMS_ECHO;
	else if (strstr(event, "+CMGS: ") || strstr(event, "+CMSS: "))
		return GSM_EVENT_SMS_TRANSMITTED;
	else if (strstr(event, "AT+CMGL=\"ALL\""))
		return GSM_EVENT_SMS_CMGL_ECHO;
	else if (strstr(event, "+CMGR: "))
		return GSM_EVENT_SMS_NEW_MESSAGE;
	else if (strstr(event, "+CMGL: "))
		return GSM_EVENT_SMS_NEW_MESSAGE_LIST;
	else if (strstr(event, "+CMTI: "))
		return GSM_EVENT_SMS_INCOMING_MESSAGE;
	else if (strstr(event, "+COPS:"))
		return GSM_EVENT_COPS;
	else if (strstr(event, "GSMINIT:"))
		return GSM_EVENT_INIT;
	else if (strstr(event, "MODEM_CHECK_ERROR"))
		return GSM_EVENT_MODEM_CHECK_ERROR;
	else if (strstr(event, "+CUSD:"))
		return GSM_EVENT_CUSD;
	else if (strstr(event, "+COPN:"))
		return GSM_EVENT_COPN;
	else if (strstr(event, "+CME ERROR:"))
		return GSM_EVENT_CME_ERROR;
	else if (strstr(event, "+CMS ERROR:"))
		return GSM_EVENT_CMS_ERROR;
	else if (strstr(event, "ERROR"))
		return GSM_EVENT_ERROR;
	else if (strstr(event, "+CSMINS: 1,0"))
		return GSM_EVENT_SIM_REMOVED;
	else if (strstr(event, "+CSMINS: 1,1"))
		return GSM_EVENT_SIM_INSERTED;
	else if (strstr(event, "OK"))
		return GSM_EVENT_OK;
	else if (strstr(event, "+WIND: 0"))
		return GSM_EVENT_SIM_REMOVED;
	else if (strstr(event, "+WIND: 1"))
		return GSM_EVENT_SIM_INSERTED;
	else if (strstr(event, "+WIND: 6,1"))
		return GSM_EVENT_NO_CARRIER;
	else if (strstr(event, "+WIND: 3"))
		return GSM_EVENT_RESET;	// Dont know y
	else if (strstr(event, "+WIND: 7"))
		return GSM_EVENT_EMG_CALL;	
	else if (strstr(event, "+WIND: 2"))
		return GSM_EVENT_REMOTE_RING;	
	else if (strstr(event, ">"))		/* Check this at last clashing with sms text */
		return GSM_EVENT_ENTER_SMS;
	else 
		return GSM_EVENT_NONE;
}

#ifdef DIALPLAN_SMS

#ifdef INCLUDE_NEWLINE
int parse_sms_multi_stage(struct gsm_sms_message **msgptr, char **eventptr, int pdu_mode){
	
	struct gsm_sms_message *msg = *msgptr;
	char *smsbuf;
	char *event = *eventptr;
	int smslen= strlen(event);
	
	smsbuf=event;
//		ast_verbose(CHAN_GSM_VERBOSE_PREFIX "==%s==\n",smsbuf);

	if (gsm_debug)
                ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : pdu_mode:%d, smslen:%d\n", __FILE__, __func__, __LINE__, pdu_mode, smslen);
	
	if (!pdu_mode) { /*parse the sms header*/
                char *p, *r;
                p=strstr(smsbuf,"+CMGR:"); if (!p) return -1; /*CMGR*/
		p++;
//		int end_with_ok = ((smsbuf[smslen-2]=='O')&&(smsbuf[smslen-1]=='K'))?1:0;
//		if(!end_with_ok) return 1; /* STORE THE PART SMS*/

		r=strsep(&p,":"); if (!r) return -1; 	/*CMGR*/
		r=strsep(&p,","); if (!r) return -1;	/*REC READ*/
		r=strsep(&p,"\""); if (!r) return -1;	/*skip*/
		r=strsep(&p,"\""); if (!r) return -1;	/*Number*/
		strcpy(msg->number,r);
		r=strsep(&p,","); if (!r) return -1;	/*NAME*/
		r=strsep(&p,"\""); if (!r) return -1;	/*skip*/
		r=strsep(&p,"\""); if (!r) return -1;	/*date*/
		strcpy(msg->date,r);
/*
		if(end_with_ok){
			strncpy(msg->text, p, SMS_MSG_SZ);
			int msglen = strlen(msg->text);
			msg->text[msglen-2]='\0';
			if (gsm_debug)
                	       ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : msg->text:%s :%d\n", __FILE__, __func__, __LINE__, msg->text, msglen);
			return 0; 	// READ SMS COMPLETE
		}else{
			return 1; 	//SHOULD NOT REACH THIS POINT
		}
*/
	} else {
			//received a PDU:
		char *p=event, *r;
		r=strsep(&p,":"); if (!r) return -1; /*CMGR*/
//		r=strsep(&p,","); if (!r) return -1; /*idx*/
//		msg->idx=atoi(r);
		r=strsep(&p,","); if (!r) return -1;/* 0*/
		r=strsep(&p,","); if (!r) return -1;/* skip ,*/
		r=strsep(&p,",)"); if (!r) return -1;/* get length*/
		msg->pdu_len=atoi(r);
		msg->text[0]=0;

		msg->number[0]=0;
		msg->date[0]=0;
		if (gsm_debug) 
			ast_verbose(CHAN_GSM_VERBOSE_PREFIX "RECEIVING PDU VERSION\n");
	}
return 0;
}

#else // INCLUDE_NEWLINE ^

int parse_sms(struct gsm_sms_message **msgptr, char **eventptr, int pdu_mode){
	
	struct gsm_sms_message *msg = *msgptr;
	char *smsbuf;
	char *event = *eventptr;
	int smslen= strlen(event);
	
	smsbuf=event;
		ast_verbose(CHAN_GSM_VERBOSE_PREFIX "==%s==\n",smsbuf);

	if (gsm_debug)
                ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : pdu_mode:%d, smslen:%d\n", __FILE__, __func__, __LINE__, pdu_mode, smslen);
	
	if (!pdu_mode) { /*parse the sms header*/
                char *p, *r;
                p=strstr(smsbuf,"+CMGR:"); if (!p) return -1; /*CMGR*/
		p++;
		int end_with_ok = ((smsbuf[smslen-2]=='O')&&(smsbuf[smslen-1]=='K'))?1:0;
	
		if (gsm_debug)
                	ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : msg->text:%c%c '%x:%x' end_with_ok:%d \n", __FILE__, __func__, __LINE__, smsbuf[smslen-2],smsbuf[smslen-1], smsbuf[smslen-2],smsbuf[smslen-1], end_with_ok);	

		if (gsm_debug)
                ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : end_with_ok:%d\n", __FILE__, __func__, __LINE__, end_with_ok);

		//   +CMGR: "REC UNREAD","VX-611112",,"13/11/25,11:42:22+22"

		if(!end_with_ok) return 1; /* STORE THE PART SMS*/

		r=strsep(&p,":"); if (!r) return -1; 	/*CMGR*/
		r=strsep(&p,","); if (!r) return -1;	/*REC READ*/
		r=strsep(&p,"\""); if (!r) return -1;	/*skip*/
		r=strsep(&p,"\""); if (!r) return -1;	/*Number*/
		strcpy(msg->number,r);
		r=strsep(&p,","); if (!r) return -1;	/*NAME*/
		r=strsep(&p,"\""); if (!r) return -1;	/*skip*/
		r=strsep(&p,"\""); if (!r) return -1;	/*date*/
		strcpy(msg->date,r);


		if(end_with_ok){
			strncpy(msg->text, p, SMS_MSG_SZ);
			int msglen = strlen(msg->text);
			msg->text[msglen-2]='\0';
			if (gsm_debug)
                                        ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : msg->text:%s :%d\n", __FILE__, __func__, __LINE__, msg->text, msglen);
			return 0; 	// READ SMS COMPLETE
		}else{
			return 1; 	//SHOULD NOT REACH THIS POINT
		}

	} else {
			//received a PDU:
		char *p=event, *r;
		r=strsep(&p,":"); if (!r) return -1; /*CMGR*/
//		r=strsep(&p,","); if (!r) return -1; /*idx*/
//		msg->idx=atoi(r);
		r=strsep(&p,","); if (!r) return -1;/* 0*/
		r=strsep(&p,","); if (!r) return -1;/* skip ,*/
		r=strsep(&p,",)"); if (!r) return -1;/* get length*/
		msg->pdu_len=atoi(r);
		msg->text[0]=0;

		msg->number[0]=0;
		msg->date[0]=0;
		if (gsm_debug) 
			ast_verbose(CHAN_GSM_VERBOSE_PREFIX "RECEIVING PDU VERSION\n");
	}
return 0;
}

#endif
#endif

#if INCLUDE_NEWLINE
int parse_sms_list__response_separated(int port, struct gsm_sms_message **msgptr, char **eventptr, int pdu_mode){
	struct gsm_sms_message *msg = *msgptr;
	char *smsbuf;
	char *event = *eventptr;
	int smslen= strlen(event);
	
	smsbuf=event;


	if (gsm_debug)
                ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : pdu_mode:%d, smslen:%d\n", __FILE__, __func__, __LINE__, pdu_mode, smslen);
	if (!pdu_mode) { /*parse the sms header*/
                char *p, *r;
                p=strstr(smsbuf,"+CMGL:"); if (!p) return -1; /*CMGL*/

		p++;
//		int end_new_sms = (parse_events(p)==GSM_EVENT_SMS_NEW_MESSAGE_LIST)?1:0;
//		int end_with_ok = ((smsbuf[smslen-2]=='O')&&(smsbuf[smslen-1]=='K'))?1:0;
//		if (gsm_debug)
//                	ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : msg->text:%c%c '%x:%x' end_with_ok:%d end_new_sms:%d\n", __FILE__, __func__, __LINE__, smsbuf[smslen-2],smsbuf[smslen-1], smsbuf[smslen-2],smsbuf[smslen-1], end_with_ok, end_new_sms);	

//		if (gsm_debug)
//                ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : end_more_message:%d end_with_ok:%d\n", __FILE__, __func__, __LINE__, end_new_sms, end_with_ok);	


//		if(!((end_new_sms)||(end_with_ok))) return 1; /* STORE THE PART SMS*/

		r=strsep(&p,":"); if (!r) return -1; /*CMGL*/
		r=strsep(&p,","); if (!r) return -1; /*idx*/
		msg->idx=atoi(r);
		r=strsep(&p,","); if (!r) return -1;/*REC READ*/
		r=strsep(&p,"\""); if (!r) return -1;/*skip*/
		r=strsep(&p,"\""); if (!r) return -1;/*Number*/
		strcpy(msg->number,r);
		r=strsep(&p,","); if (!r) return -1;/*NAME*/
		r=strsep(&p,"\""); if (!r) return -1;/*skip*/
		r=strsep(&p,"\""); if (!r) return -1;/*date*/
		strcpy(msg->date,r);
		return 1;
#if 0
		if(end_new_sms){
			char *tmpp=p;

			char *tp=strstr(tmpp,"+CMGL: "); 
			if (gsm_debug)
                                        ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : msg->text:%s\n", __FILE__, __func__, __LINE__, tp);
			int remsmslen = strlen(tp);
			char tbuf[LINE_BUFFER_SIZE+SMS_PART_MSG_SZ];
			strncpy(tbuf, tp, remsmslen);
			*tp='\0';
			if (gsm_debug)
                                        ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : msg->text:%s\n", __FILE__, __func__, __LINE__, p);
			strncpy(msg->text, tmpp, SMS_MSG_SZ);

			if (gsm_debug)
                                        ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : msg->text:%s\n", __FILE__, __func__, __LINE__, msg->text);
			memset(event, 0, smslen);
			strncpy(event,tbuf, remsmslen);
			return 2; //READ NEXT SMS IN LIST
		}else if(end_with_ok){
			strncpy(msg->text, p, SMS_MSG_SZ);
			int msglen = strlen(msg->text);
			msg->text[msglen-2]='\0';
			if (gsm_debug)
                                        ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : msg->text:%s :%d\n", __FILE__, __func__, __LINE__, msg->text, msglen);
			return 0; // READ SMS COMPLETE
		}else{
			return 1; //SHOULD NOT REACH THIS POINT
		}
#endif
	} else {
			//received a PDU:
		char *p=event, *r;
		r=strsep(&p,":"); if (!r) return -1; /*CMGL*/
		r=strsep(&p,","); if (!r) return -1; /*idx*/
		msg->idx=atoi(r);
		r=strsep(&p,","); if (!r) return -1;/* 0*/
		r=strsep(&p,","); if (!r) return -1;/* skip ,*/
		r=strsep(&p,",)"); if (!r) return -1;/* get length*/
		msg->pdu_len=atoi(r);
		msg->text[0]=0;

		msg->number[0]=0;
		msg->date[0]=0;
		if (gsm_debug) 
			ast_verbose(CHAN_GSM_VERBOSE_PREFIX "RECEIVING PDU VERSION\n");
	}
return 0;
}

#endif
int parse_sms_list(int port, struct gsm_sms_message **msgptr, char **eventptr, int pdu_mode){
	struct gsm_sms_message *msg = *msgptr;
	char *smsbuf;
	char *event = *eventptr;
	int smslen= strlen(event);
	
	smsbuf=event;


	if (gsm_debug)
                ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : pdu_mode:%d, smslen:%d\n", __FILE__, __func__, __LINE__, pdu_mode, smslen);
	if (!pdu_mode) { /*parse the sms header*/
                char *p, *r;
                p=strstr(smsbuf,"+CMGL:"); if (!p) return -1; /*CMGL*/

		p++;
		int end_new_sms = (parse_events(p)==GSM_EVENT_SMS_NEW_MESSAGE_LIST)?1:0;
		int end_with_ok = ((smsbuf[smslen-2]=='O')&&(smsbuf[smslen-1]=='K'))?1:0;
		if (gsm_debug)
                	ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : msg->text:%c%c '%x:%x' end_with_ok:%d end_new_sms:%d\n", __FILE__, __func__, __LINE__, smsbuf[smslen-2],smsbuf[smslen-1], smsbuf[smslen-2],smsbuf[smslen-1], end_with_ok, end_new_sms);	

		if (gsm_debug)
                ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : end_more_message:%d end_with_ok:%d\n", __FILE__, __func__, __LINE__, end_new_sms, end_with_ok);	


		if(!((end_new_sms)||(end_with_ok))) return 1; /* STORE THE PART SMS*/

		r=strsep(&p,":"); if (!r) return -1; /*CMGL*/
		r=strsep(&p,","); if (!r) return -1; /*idx*/
		msg->idx=atoi(r);
		r=strsep(&p,","); if (!r) return -1;/*REC READ*/
		r=strsep(&p,"\""); if (!r) return -1;/*skip*/
		r=strsep(&p,"\""); if (!r) return -1;/*Number*/
		strcpy(msg->number,r);
		r=strsep(&p,","); if (!r) return -1;/*NAME*/
		r=strsep(&p,"\""); if (!r) return -1;/*skip*/
		r=strsep(&p,"\""); if (!r) return -1;/*date*/
		strcpy(msg->date,r);


		if(end_new_sms){
			char *tmpp=p;

			char *tp=strstr(tmpp,"+CMGL: "); 
			if (gsm_debug)
                                        ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : msg->text:%s\n", __FILE__, __func__, __LINE__, tp);
			int remsmslen = strlen(tp);
			char tbuf[LINE_BUFFER_SIZE+SMS_PART_MSG_SZ];
			strncpy(tbuf, tp, remsmslen);
			*tp='\0';
			if (gsm_debug)
                                        ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : msg->text:%s\n", __FILE__, __func__, __LINE__, p);
			strncpy(msg->text, tmpp, SMS_MSG_SZ);

			if (gsm_debug)
                                        ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : msg->text:%s\n", __FILE__, __func__, __LINE__, msg->text);
			memset(event, 0, smslen);
			strncpy(event,tbuf, remsmslen);
			return 2; //READ NEXT SMS IN LIST
		}else if(end_with_ok){
			strncpy(msg->text, p, SMS_MSG_SZ);
			int msglen = strlen(msg->text);
			msg->text[msglen-2]='\0';
			if (gsm_debug)
                                        ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : msg->text:%s :%d\n", __FILE__, __func__, __LINE__, msg->text, msglen);
			return 0; // READ SMS COMPLETE
		}else{
			return 1; //SHOULD NOT REACH THIS POINT
		}

	} else {
			//received a PDU:
		char *p=event, *r;
		r=strsep(&p,":"); if (!r) return -1; /*CMGL*/
		r=strsep(&p,","); if (!r) return -1; /*idx*/
		msg->idx=atoi(r);
		r=strsep(&p,","); if (!r) return -1;/* 0*/
		r=strsep(&p,","); if (!r) return -1;/* skip ,*/
		r=strsep(&p,",)"); if (!r) return -1;/* get length*/
		msg->pdu_len=atoi(r);
		msg->text[0]=0;

		msg->number[0]=0;
		msg->date[0]=0;
		if (gsm_debug) 
			ast_verbose(CHAN_GSM_VERBOSE_PREFIX "RECEIVING PDU VERSION\n");
	}
return 0;
}

char *get_event_text(int ev){
	if(ev<NUM_EVENTS){
		return events_list[ev].text;
	}else{
		return "UNKONWN EVENT";
	}
}
char *get_event_text_v2(int ev){
	if(ev<NUM_EVENTS){
		if (events_list[ev].id==ev)
			return events_list[ev].text;
		int i;
		for (i=0;i<NUM_EVENTS;i++){
			if (events_list[i].id==ev)
				return events_list[i].text;
		}
	}else{
		return "UNKONWN EVENT";
	}
	return "UNKONWN EVENT";
}

#define HANDLE_EVENT_NONE	0
#define HANDLE_EVENT_SMS_ERROR  1 << 1

void cb_events(int port, char *event)
{
	struct ast_channel *ast=gsm_get_priv(port);
	struct gsm_pvt *gsm=NULL;
	enum gsm_events ev=parse_events(event);
	int event_handled = HANDLE_EVENT_NONE;
	if(gsm_debug)
		ast_verbose(CHAN_GSM_VERBOSE_PREFIX "[ALLO_GSM]%s:%s:%d : evid:%d event:%s\n", __FILE__, __func__, __LINE__, ev, get_event_text(ev));

	if (ast)
#ifdef ASTERISK_11_4
                gsm=ast_channel_tech_pvt(ast);
#else
                gsm=ast->tech_pvt;
#endif

	if (!strlen(event)) return ; /*skip empty lines*/

	if ((at_debug[port]>0)||gsm_debug) {
		if (ev != GSM_EVENT_NONE){
			if ((at_debug[port]>1)||gsm_debug) {
				ast_verbose(CHAN_GSM_VERBOSE_PREFIX "\tP(%d)<<< ev (%d) state (%d) smsstate (%d) event (%s) \n", port, ev, gsm?gsm->state:-1, gsm_sms[port].state, event);
	//			ast_verbose("EVENT: %s \n", get_event_text_v2(ev));
			}else{
				ast_verbose(CHAN_GSM_VERBOSE_PREFIX "\tP(%d)<<< Event  (%s) \n", port, event);
			}
		}else{
		ast_verbose(CHAN_GSM_VERBOSE_PREFIX "\tP(%d)<<< unknown event state (%d) smsstate (%d) event (%s) \n",port, gsm?gsm->state:-1, gsm_sms[port].state, event);
#if 0
/* enable HEX receive print from here */
			int i;
			ast_verbose("Unknown Received:[");
			for (i=0;i<strlen(event);++i){
				if (event[i]=='\r' )
					ast_verbose("\\r");
				else if (event[i]=='\n' )
					ast_verbose("\\n");
				else 
					ast_verbose(" %X ",event[i]);
			}
			ast_verbose("] \n");
#endif
		}
	}
            
	/* handle "unknown events" which are data (e.g. unknown at compile time) radio sends in response our commands */
	if (ev == GSM_EVENT_NONE)
		gsm_handle_unknown_event(port, event);

	/*note that the OK event might be handled under different switches*/
	/*sms handling*/

	if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : ev:%d\n", __FILE__, __func__, __LINE__, ev);
	if (ev == GSM_EVENT_MODEM_CHECK_ERROR) {
                if (ast && gsm && gsm->state == GSM_STATE_ATD_OUT) {
                        gsm->state=GSM_STATE_HANGUPED;
#ifdef ASTERISK_11_4
                        ast_channel_hangupcause_set(ast, 22);
#else
                        ast->hangupcause=22;
#endif
                        ast_queue_hangup(ast);
		} else {
			ast_verbose(CHAN_GSM_VERBOSE_PREFIX "P(%d)> MODEM RESPONSE DELAYED\n",port);
			ast_log(LOG_WARNING, "P(%d)> MODEM RESPONSE DELAYED(%s)\n", port, event);
		}
		/* restart the radio with full power cycle */
		_gsm_restart_port(port, 1);
		return;
	}

	if (gsm_debug) 
		ast_verbose(CHAN_GSM_VERBOSE_PREFIX " :%s:%s:%d : ev:%d:port%d:smsstate:%d\n", __FILE__, __func__, __LINE__, ev, port, gsm_sms[port].state);


	if (gsm_sms[port].state == GSM_SMS_STATE_EXPECTING_PROMPT) {
		switch (ev) {
			case GSM_EVENT_ERROR:
			case GSM_EVENT_SMS_TRANSMITTED:
			case GSM_EVENT_ENTER_SMS:
			case GSM_EVENT_SMS_INCOMING_MESSAGE:
				break;
			default:
				if (ev!=GSM_EVENT_OK)
					ast_log(LOG_ERROR, "Expecting sms Prompt(>) but got (%s). Ignoring.\n", event);
				return;
		}
	}
	if (gsm_sms[port].state != GSM_SMS_STATE_NONE) {
		struct gsm_sms_message *msg=&gsm_sms[port].inbound_msg;
		char buf[1048];

		switch (ev) {
			/*RECEIVING SMS*/
			case GSM_EVENT_SMS_CMGL_ECHO:
				/*enter list mode*/
				gsm_sms[port].state=GSM_SMS_STATE_LIST;
				if (gsm_debug) 
					ast_verbose(CHAN_GSM_VERBOSE_PREFIX "CMGL_ECHO -> STATE_LIST\n");
			break;
			case GSM_EVENT_SMS_NEW_MESSAGE_LIST:
				/*new sms*/
				/*are we the first new message ?*/
				if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX "NEW_MESSAGE->GET_TEXT\n");
				if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX " %s:%s:%d %d\n", __FILE__, __func__, __LINE__, gsm_sms[port].state);

				char *smsbuf = malloc(LINE_BUFFER_SIZE+SMS_PART_MSG_SZ);
				memset(smsbuf, 0, LINE_BUFFER_SIZE+SMS_PART_MSG_SZ);
				strcpy(smsbuf,event);

 
				if(gsm_sms[port].state == GSM_SMS_STATE_GET_TEXT){
                                      strcpy(smsbuf, gsm_sms[port].sms_part);
                                        strcat(smsbuf, event);
	                 		gsm_sms[port].state=GSM_SMS_STATE_EXPECTING_SMSLIST;
				}
				if (gsm_sms[port].state==GSM_SMS_STATE_EXPECTING_SMSLIST) {
					int sms_recv = 0;
					do{
						if(gsm_debug)
							ast_verbose("BEFORE PARSE SMS LIST :%s:%s:%d res:%d event:%s\n", __FILE__, __func__, __LINE__, sms_recv, smsbuf);
						msg=&gsm_sms[port].inbound_msg;
#if INCLUDE_NEWLINE
						sms_recv = parse_sms_list__response_separated(port, &msg, &smsbuf, gsm_cfg[port].sms_pdu_mode);
#else
                                                sms_recv = parse_sms_list(port, &msg, &smsbuf, gsm_cfg[port].sms_pdu_mode);
#endif
						if(gsm_debug)
							ast_verbose("PARSED SMS LIST :%s:%s:%d res:%d event:%s\n", __FILE__, __func__, __LINE__, sms_recv, smsbuf);
						
						
						switch(sms_recv){
						case 0:
						case 2:
							if(gsm_sms[port].work==GSM_SMS_WORK_SHOW) {
								output_sms(port, &gsm_sms[port].inbound_msg);
								memset(&gsm_sms[port].inbound_msg, 0, sizeof(struct gsm_sms_message));
							}
							if(gsm_sms[port].work==GSM_SMS_WORK_FETCH) {
								save_sms(port, &gsm_sms[port].inbound_msg);
								sms_idx_add(gsm_sms[port].inbound_msg.idx);
								gsm_sms[port].state=GSM_SMS_STATE_FLUSHING;
							}
							break;
						case 1: 
							// STORE THE DATA FOR FURTHUR READ
							strncpy(gsm_sms[port].sms_part, smsbuf, SMS_PART_MSG_SZ);
						        //ast_verbose("Hi part of the sms message is %s in switch case\n ",gsm_sms[port].sms_part);	
                                                        gsm_sms[port].state=GSM_SMS_STATE_GET_TEXT;
							sms_recv=0;
							break;
						default:
							sms_recv=0;
							break;
						}
					}while(sms_recv);

				}

				free(smsbuf);
				smsbuf=NULL;

				if(gsm_debug)
					ast_verbose("HERE AFTER PARSING SMS CHECK FLUSH %d\n", gsm_sms[port].state);

				/* now delete if all sms are saved */
				if(gsm_sms[port].state==GSM_SMS_STATE_FLUSHING){
					if(gsm_debug)
						ast_verbose("FLUSHING SMS LIST NOW %d\n", gsm_sms[port].state);

					int idx = sms_idx_get_next();
					if(idx){
						char buf[32];
						sprintf(buf, "AT+CMGD=%d",idx);
						gsm_send(port,buf,100);
						if (gsm_debug)
							ast_verbose(CHAN_GSM_VERBOSE_PREFIX "sms del %d\n",idx);
					}
				}

			break;
#ifdef DIALPLAN_SMS
#ifdef INCLUDE_NEWLINE
			case GSM_EVENT_SMS_NEW_MESSAGE:
				if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX "NEW_MESSAGE->GET_TEXT\n");
				if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX " %s:%s:%d %d\n", __FILE__, __func__, __LINE__, gsm_sms[port].state);

				char *smsbuff = malloc(LINE_BUFFER_SIZE+SMS_PART_MSG_SZ);
				memset(smsbuff, 0, LINE_BUFFER_SIZE+SMS_PART_MSG_SZ);
				strcpy(smsbuff,event);

				if (gsm_sms[port].state==GSM_SMS_STATE_EXPECTING_SMS) {
					msg=&gsm_sms[port].inbound_msg;
					int sms_recv = parse_sms_multi_stage(&msg, &smsbuff, gsm_cfg[port].sms_pdu_mode);
					switch(sms_recv){
					case -1 :
						if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX "CMGR Parsing Error\n");
						ast_log(LOG_ERROR, "CMGR Parsing Error");
						break;
					case 0: 		
						if(gsm_sms[port].work==GSM_SMS_WORK_READ_LAST_MSG) {
							gsm_sms[port].inbound_msg.idx=gsm_sms[port].last_sms_idx;
							gsm_sms[port].sms_recv_state=GSM_SMS_RECV_CMGR;
#if 0
							/* Create a new channel and start PBX*/
							gsm=malloc(sizeof(struct gsm_pvt));
							if (!gsm) {
								ast_log(LOG_ERROR, "Error allocating memory for new GSM channel.");
								return;
							}
							memset(gsm,0,sizeof(struct gsm_pvt));
							gsm->port=port;

							configure_gsm(gsm);
							struct ast_channel *chan=gsm_new(gsm, "sms", NULL, NULL, AST_STATE_DOWN);
							gsm->call_type=GSM_CALL_TYPE_SMS;

							/* Read response for Last Message and Clear the inbound msg struct */
							read_sms_pbx_variable(chan, port, &gsm_sms[port].inbound_msg);
					
							/* Start by trying whatever the channel is set to */
#if ( defined ASTERISK_1_4 || defined ASTERISK_1_6_2 )
							if (ast_exists_extension(chan, chan->context, chan->exten, chan->priority,chan->cid.cid_num)){
#endif
#if ( defined ASTERISK_1_8 || defined ASTERISK_10_4 )
							if (ast_exists_extension(chan, chan->context, chan->exten, chan->priority,
								S_COR(chan->caller.id.number.valid, chan->caller.id.number.str, NULL))) {
#endif
#ifdef ASTERISK_11_4
                                                        if (ast_exists_extension(chan, ast_channel_context(chan), ast_channel_exten(chan),
                                                                ast_channel_priority(chan),
                                                                S_COR(ast_channel_caller(chan)->id.number.valid, ast_channel_caller(chan)->id.number.str, NULL))) {
#endif
								ast_pbx_start(chan);
							//	ast_hangup(chan); pawan
							}else{
								ast_verbose(" -- exten sms DOESNOT exists in Dialplan\n");
								ast_hangup(chan);
								break;
							}

							int ismsbak, ismsdel;
							ismsbak=gsm_config_get_bool(SECT_GENERAL, CFG_GEN_SMS_BAK) ;
							ismsdel=gsm_config_get_bool(SECT_GENERAL, CFG_GEN_SMS_DEL) ;
						        if(gsm_debug)
								ast_verbose(CHAN_GSM_VERBOSE_PREFIX "ismsbak=%d |  ismsdel=%d\n",ismsbak, ismsdel);
							/*Take bakup of sms received*/
							if (ismsbak){
								save_sms(port, &gsm_sms[port].inbound_msg);
							}

							memset(&gsm_sms[port].inbound_msg, 0, sizeof(struct gsm_sms_message));
							gsm_sms[port].state=GSM_SMS_STATE_NONE;
							gsm_sms[port].work=GSM_SMS_WORK_SHOW;

							/*Delete SMS from SIM*/
							if(ismsdel){
								gsm_sms[port].state=GSM_SMS_STATE_FLUSHING;
								gsm_sms[port].work=GSM_SMS_WORK_READ_LAST_MSG;
#if 1
								char buf[32];
								sprintf(buf, "AT+CMGD=%d",gsm_sms[port].last_sms_idx);
								gsm_send(port,buf,100);
								if (gsm_debug)
									ast_verbose(CHAN_GSM_VERBOSE_PREFIX "sms del %d\n",gsm_sms[port].last_sms_idx);
#endif
							}
#endif
						}
						break;
					default:
						if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Unkonwn Error with GSM_EVENT_SMS_NEW_MESSAGE\n");
						break;
					}
				}
				free(smsbuff);
				smsbuff=NULL;
			break;
#else
			case GSM_EVENT_SMS_NEW_MESSAGE:
				if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX "NEW_MESSAGE->GET_TEXT\n");
				if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX " %s:%s:%d %d\n", __FILE__, __func__, __LINE__, gsm_sms[port].state);

				char *smsbuff = malloc(LINE_BUFFER_SIZE+SMS_PART_MSG_SZ);
				memset(smsbuff, 0, LINE_BUFFER_SIZE+SMS_PART_MSG_SZ);
				strcpy(smsbuff,event);

				if (gsm_sms[port].state==GSM_SMS_STATE_EXPECTING_SMS) {
					msg=&gsm_sms[port].inbound_msg;
					int sms_recv = parse_sms(&msg, &smsbuff, gsm_cfg[port].sms_pdu_mode);
					switch(sms_recv){
					case -1 :
						if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX "SMS Parsing Error\n");
						ast_log(LOG_ERROR, "SMS Parsing Error");
						break;
					case 1:
						if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Partial Message Received(No OK followed by +CMGR)\n");
						ast_log(LOG_ERROR, "Partial Message Received(No OK followed by +CMGR)");
						break;
					case 0: 		
						if(gsm_sms[port].work==GSM_SMS_WORK_READ_LAST_MSG) {
							gsm_sms[port].inbound_msg.idx=gsm_sms[port].last_sms_idx;
							/* Create a new channel and start PBX*/
							gsm=malloc(sizeof(struct gsm_pvt));
							if (!gsm) {
								ast_log(LOG_ERROR, "Error allocating memory for new GSM channel.");
								return;
							}
							memset(gsm,0,sizeof(struct gsm_pvt));
							gsm->port=port;

							configure_gsm(gsm);
							struct ast_channel *chan=gsm_new(gsm, "sms", NULL, NULL, AST_STATE_DOWN);
							gsm->call_type=GSM_CALL_TYPE_SMS;

							/* Read response for Last Message and Clear the inbound msg struct */
							read_sms_pbx_variable(chan, port, &gsm_sms[port].inbound_msg);
					
							/* Start by trying whatever the channel is set to */
#if ( defined ASTERISK_1_4 || defined ASTERISK_1_6_2 )
							if (ast_exists_extension(chan, chan->context, chan->exten, chan->priority,chan->cid.cid_num)){
#endif
#if ( defined ASTERISK_1_8 || defined ASTERISK_10_4 )
							if (ast_exists_extension(chan, chan->context, chan->exten, chan->priority,
								S_COR(chan->caller.id.number.valid, chan->caller.id.number.str, NULL))) {
#endif
#ifdef ASTERISK_11_4
                                                        if (ast_exists_extension(chan, ast_channel_context(chan), ast_channel_exten(chan),
                                                                ast_channel_priority(chan),
                                                                S_COR(ast_channel_caller(chan)->id.number.valid, ast_channel_caller(chan)->id.number.str, NULL))) {
#endif
								ast_pbx_start(chan);
							//	ast_hangup(chan); pawan
							}else{
								ast_verbose(" -- exten sms DOESNOT exists in Dialplan\n");
								ast_hangup(chan);
								break;
							}

							int ismsbak, ismsdel;
							ismsbak=gsm_config_get_bool(SECT_GENERAL, CFG_GEN_SMS_BAK) ;
							ismsdel=gsm_config_get_bool(SECT_GENERAL, CFG_GEN_SMS_DEL) ;
						        if(gsm_debug)
								ast_verbose(CHAN_GSM_VERBOSE_PREFIX "ismsbak=%d |  ismsdel=%d\n",ismsbak, ismsdel);
							/*Take bakup of sms received*/
							if (ismsbak){
								save_sms(port, &gsm_sms[port].inbound_msg);
							}

							memset(&gsm_sms[port].inbound_msg, 0, sizeof(struct gsm_sms_message));
							gsm_sms[port].state=GSM_SMS_STATE_NONE;
							gsm_sms[port].work=GSM_SMS_WORK_SHOW;

							/*Delete SMS from SIM*/
							if(ismsdel){
								gsm_sms[port].state=GSM_SMS_STATE_FLUSHING;
								gsm_sms[port].work=GSM_SMS_WORK_READ_LAST_MSG;
#if 1
								char buf[32];
								sprintf(buf, "AT+CMGD=%d",gsm_sms[port].last_sms_idx);
								gsm_send(port,buf,100);
								if (gsm_debug)
									ast_verbose(CHAN_GSM_VERBOSE_PREFIX "sms del %d\n",gsm_sms[port].last_sms_idx);
#endif
							}
						}
						break;
					default:
						if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Unkonwn Error with GSM_EVENT_SMS_NEW_MESSAGE\n");
						break;
					}
				}
				free(smsbuf);
				smsbuf=NULL;
			break;
#endif // INCLUDE_NEWLINE
#endif //DIALPLAN_SMS
			case GSM_EVENT_NONE:
#ifdef INCLUDE_NEWLINE
				if (gsm_sms[port].sms_recv_state==GSM_SMS_RECV_CMGR) {
					/*its the Text*/
					strcat(msg->text, event);

				} else if (gsm_sms[port].state==GSM_SMS_STATE_GET_TEXT) {
					/*its the Text*/
					strcat(msg->text, event);
					if (msg->idx > 0){
						if(gsm_sms[port].work==GSM_SMS_WORK_SHOW) {
							output_sms(port, &gsm_sms[port].inbound_msg);
							memset(&gsm_sms[port].inbound_msg, 0, sizeof(struct gsm_sms_message));
						}
						if(gsm_sms[port].work==GSM_SMS_WORK_FETCH) {
							save_sms(port, &gsm_sms[port].inbound_msg);
							sms_idx_add(gsm_sms[port].inbound_msg.idx);
//							gsm_sms[port].state=GSM_SMS_STATE_FLUSHING;
							memset(&gsm_sms[port].inbound_msg, 0, sizeof(struct gsm_sms_message));
						}
					}
				}
#else
				if (gsm_sms[port].state==GSM_SMS_STATE_GET_TEXT) {

				 	/*its the Text*/
                                        strcat(msg->text, event);
                                }
#endif

			break;

			case GSM_EVENT_OK:

				if (gsm_debug)
					ast_verbose(CHAN_GSM_VERBOSE_PREFIX "EVENT_OK\n");
				
				if (gsm_sms[port].state == GSM_SMS_STATE_EXPECTING_OK) {
					char buf[40];

					gsm_sms[port].state = GSM_SMS_STATE_EXPECTING_PROMPT;
					if (gsm_save_out_msgs) {
						sprintf(buf,"AT+CMGW=\"%s\"", gsm_sms[port].number);
					} else {
						sprintf(buf,"AT+CMGS=\"%s\"", gsm_sms[port].number);
					}
					gsm_send(port, buf, 0);
					gsm_sms_enter(port);
					break;
				}
#if INCLUDE_NEWLINE
				if (gsm_sms[port].state==GSM_SMS_STATE_GET_TEXT) {
					int sms_recv=0;
/*					char *smsbuf = malloc(sizeof(char) * (SMS_PART_MSG_SZ));
                                  	memset(smsbuf, 0, SMS_PART_MSG_SZ);

					strncpy(smsbuf, gsm_sms[port].sms_part,SMS_PART_MSG_SZ);
                                        strncat(smsbuf, event, SMS_PART_MSG_SZ);
*/
					msg=&gsm_sms[port].inbound_msg;
//					sms_recv = parse_sms_list(port, &msg, &smsbuf, gsm_cfg[port].sms_pdu_mode);

					if(sms_recv==0){
                       				if (gsm_sms[port].work==GSM_SMS_WORK_SHOW) {
					//		output_sms(port, &gsm_sms[port].inbound_msg);
						}
						if (gsm_sms[port].work==GSM_SMS_WORK_FETCH) {
							//save_sms(port, &gsm_sms[port].inbound_msg);
							//sms_idx_add(gsm_sms[port].inbound_msg.idx);
							gsm_sms[port].state=GSM_SMS_STATE_FLUSHING;
						}
					}
					memset(&gsm_sms[port].inbound_msg, 0, sizeof(struct gsm_sms_message));
/*
				        ast_verbose("Hi part of the sms message is %s in switch case\n ",gsm_sms[port].sms_part);	
					free(smsbuf);
					smsbuf=NULL;
*/
				}
#else
				if (gsm_sms[port].state==GSM_SMS_STATE_GET_TEXT) {
					int sms_recv=1;
					char *smsbuf = malloc(sizeof(char) * (SMS_PART_MSG_SZ));
                                  	memset(smsbuf, 0, SMS_PART_MSG_SZ);

					strncpy(smsbuf, gsm_sms[port].sms_part,SMS_PART_MSG_SZ);
                                        strncat(smsbuf, event, SMS_PART_MSG_SZ);

					msg=&gsm_sms[port].inbound_msg;
					sms_recv = parse_sms_list(port, &msg, &smsbuf, gsm_cfg[port].sms_pdu_mode);

					if(sms_recv==0){
                       				if (gsm_sms[port].work==GSM_SMS_WORK_SHOW) {
							output_sms(port, &gsm_sms[port].inbound_msg);
							memset(&gsm_sms[port].inbound_msg, 0, sizeof(struct gsm_sms_message));
						}
						if (gsm_sms[port].work==GSM_SMS_WORK_FETCH) {
							save_sms(port, &gsm_sms[port].inbound_msg);
							sms_idx_add(gsm_sms[port].inbound_msg.idx);
							gsm_sms[port].state=GSM_SMS_STATE_FLUSHING;
						}
					}
				        //ast_verbose("Hi part of the sms message is %s in switch case\n ",gsm_sms[port].sms_part);	
					free(smsbuf);
					smsbuf=NULL;
				}
#endif

				if (gsm_sms[port].state==GSM_SMS_STATE_FLUSHING) {
					/*FIXME*/
					if (gsm_sms[port].work==GSM_SMS_WORK_READ_LAST_MSG){
						if (gsm_debug)
							ast_verbose(CHAN_GSM_VERBOSE_PREFIX "OK Receipt for GSM_SMS_WORK_READ_LAST_MSG\n");
							memset(&gsm_sms[port].inbound_msg, 0, sizeof(struct gsm_sms_message));
					}else{
						int idx = sms_idx_get_next();
						if (idx) {
							char buf[32];
							sprintf(buf, "AT+CMGD=%d",idx);
							gsm_sms[port].state=GSM_SMS_STATE_FLUSHING;
							gsm_send(port,buf,100);
							if (gsm_debug)
								ast_verbose(CHAN_GSM_VERBOSE_PREFIX "sms del %d\n",idx);
							break;
						}
					}
				}
#ifdef INCLUDE_NEWLINE
				if (gsm_sms[port].sms_recv_state==GSM_SMS_RECV_CMGR) {
					//int sms_recv=1;
					char *smsbuf = malloc(sizeof(char) * (SMS_PART_MSG_SZ));
                                  	memset(smsbuf, 0, SMS_PART_MSG_SZ);

					strncpy(smsbuf, gsm_sms[port].sms_part,SMS_PART_MSG_SZ);
                                        //strncat(smsbuf, event, SMS_PART_MSG_SZ);

					msg=&gsm_sms[port].inbound_msg;

//					strncpy(msg->text, gsm_sms[port].sms_part, SMS_MSG_SZ);

					//sms_recv = parse_sms_list(port, &msg, &smsbuf, gsm_cfg[port].sms_pdu_mode);
/*
					if(sms_recv==0){
                       				if (gsm_sms[port].work==GSM_SMS_WORK_SHOW) {
							output_sms(port, &gsm_sms[port].inbound_msg);
							memset(&gsm_sms[port].inbound_msg, 0, sizeof(struct gsm_sms_message));
						}
						if (gsm_sms[port].work==GSM_SMS_WORK_FETCH) {
							save_sms(port, &gsm_sms[port].inbound_msg);
							sms_idx_add(gsm_sms[port].inbound_msg.idx);
							gsm_sms[port].state=GSM_SMS_STATE_FLUSHING;
						}
					}
*/
					ast_verbose("SMS received: Port(%d) IDX(%d) Number(%s) Date(%s) Text(%s)\n", port, msg->idx, msg->number, msg->date, msg->text);
					/* Create a new channel and start PBX*/
					int idialplansmsenable;
					idialplansmsenable =gsm_config_get_bool(SECT_GENERAL, CFG_GEN_SMS_DIALPLAN) ;
					if(gsm_debug)
						ast_verbose(CHAN_GSM_VERBOSE_PREFIX "idialplansmsenable=%d\n",idialplansmsenable);
					if (idialplansmsenable){
						gsm=malloc(sizeof(struct gsm_pvt));
						if (!gsm) {
							ast_log(LOG_ERROR, "Error allocating memory for new GSM channel.");
							return;
						}
						memset(gsm,0,sizeof(struct gsm_pvt));
						gsm->port=port;
						configure_gsm(gsm);
						struct ast_channel *chan=gsm_new(gsm, "sms", NULL, NULL, AST_STATE_DOWN);
						gsm->call_type=GSM_CALL_TYPE_SMS;

						/* Read response for Last Message and Clear the inbound msg struct */
						read_sms_pbx_variable(chan, port, &gsm_sms[port].inbound_msg);
				
						/* Start by trying whatever the channel is set to */
#if ( defined ASTERISK_1_4 || defined ASTERISK_1_6_2 )
						if (ast_exists_extension(chan, chan->context, chan->exten, chan->priority,chan->cid.cid_num)){
#endif
#if ( defined ASTERISK_1_8 || defined ASTERISK_10_4 )
						if (ast_exists_extension(chan, chan->context, chan->exten, chan->priority,
							S_COR(chan->caller.id.number.valid, chan->caller.id.number.str, NULL))) {
#endif
#ifdef ASTERISK_11_4
						if (ast_exists_extension(chan, ast_channel_context(chan), ast_channel_exten(chan),
							ast_channel_priority(chan),
							S_COR(ast_channel_caller(chan)->id.number.valid, ast_channel_caller(chan)->id.number.str, NULL))) {
#endif
							ast_pbx_start(chan);
						//	ast_hangup(chan); pawan
						}else{
							ast_verbose(" -- exten sms DOESNOT exists in Dialplan\n");
							ast_hangup(chan);
							//break;
						}
					}
					int ismsbak, ismsdel;
					ismsbak=gsm_config_get_bool(SECT_GENERAL, CFG_GEN_SMS_BAK) ;
					ismsdel=gsm_config_get_bool(SECT_GENERAL, CFG_GEN_SMS_DEL) ;
					if(gsm_debug)
						ast_verbose(CHAN_GSM_VERBOSE_PREFIX "ismsbak=%d |  ismsdel=%d\n",ismsbak, ismsdel);
					/*Take bakup of sms received*/
					if (ismsbak){
						save_sms(port, &gsm_sms[port].inbound_msg);
					}

					memset(&gsm_sms[port].inbound_msg, 0, sizeof(struct gsm_sms_message));
					gsm_sms[port].state=GSM_SMS_STATE_NONE;
					gsm_sms[port].work=GSM_SMS_WORK_SHOW;

					/*Delete SMS from SIM*/
					if(ismsdel){
						gsm_sms[port].state=GSM_SMS_STATE_FLUSHING;
						gsm_sms[port].work=GSM_SMS_WORK_READ_LAST_MSG;
#if 1
						char buf[32];
						sprintf(buf, "AT+CMGD=%d",gsm_sms[port].last_sms_idx);
						gsm_send(port,buf,100);
						if (gsm_debug)
							ast_verbose(CHAN_GSM_VERBOSE_PREFIX "sms del %d\n",gsm_sms[port].last_sms_idx);
#endif
					}

					free(smsbuf);
					smsbuf=NULL;
				}
#endif			
#ifdef INCLUDE_NEWLINE	
				gsm_sms[port].sms_recv_state = GSM_SMS_RECV_NONE;
#endif
				gsm_sms[port].state=GSM_SMS_STATE_NONE;
				gsm_sms[port].work=GSM_SMS_WORK_SHOW;
			break;

			/*TRANSMITTING SMS*/
			case GSM_EVENT_ERROR:
				gsm_sms[port].s=NULL;
				gsm_sms[port].m=NULL;
				gsm_sms[port].retry=0;
				gsm_sms[port].state=GSM_SMS_STATE_NONE;
				gsm_send_sms_end(port);
                                ast_log(LOG_DEBUG, "SMS transmit ERROR on port %d.\n", port);
				event_handled = HANDLE_EVENT_SMS_ERROR;
				ast_verbose(CHAN_GSM_VERBOSE_PREFIX "SMS transmit ERROR on port %d.\n", port);
				//CHECK HERE for any ast_manager_event Required
				break;	
			case GSM_EVENT_SMS_TRANSMITTED:
				/*if (gsm_sms[port].s && gsm_sms[port].m)
					astman_send_ack(gsm_sms[port].s, gsm_sms[port].m,
							"GsmSendSms: Success");
				*/
				gsm_sms[port].s=NULL;
				gsm_sms[port].m=NULL;
				gsm_sms[port].retry=0;
				gsm_sms[port].state=GSM_SMS_STATE_NONE;
				memset(&gsm_sms[port].outbound_msg, 0, sizeof(struct gsm_sms_message));
                                ast_log(LOG_DEBUG, "SMS successfully transmitted on port %d.\n", port);
				ast_verbose(CHAN_GSM_VERBOSE_PREFIX "SMS successfully transmitted on port %d.\n", port);
#if ( defined ASTERISK_1_8 || defined ASTERISK_10_4 || defined ASTERISK_11_4 )
				ast_manager_event(ast,EVENT_FLAG_CALL,
                                        "SMSSTATUS",
                                        "Channel: GSM/%d\r\n"
                                        "Actionid:%d\r\n",
                                         port,(gsm_sms[port].retry==0) ? 1 : 0);
#endif
				/* get back to PDU mode if that was the mode we were in */
				/* note that this will kick in after we get an OK */
                          	if (gsm_cfg[port].sms_pdu_mode) {
					gsm_send(port, "AT+CMGF=0", 0);
				}
//				gsm_send(port,"AT+CUSD=1,*141# ,15 " , 0 );
			break;

			case GSM_EVENT_SMS_ECHO:
				if (gsm_debug)
					ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Enter SMS Mode\n");

				if (gsm_save_out_msgs) {
					char *p = strchr(event, ':');
					if (p) {
						char txt[100];
						int msg = strtol(p + 1, 0, 10);

						sprintf(txt, "AT+CMSS=%d", msg);
						gsm_send(port, txt, 10);
					}
				}
			break;
                      
		      	
                      case GSM_EVENT_ENTER_SMS:
				{
					if (gsm_debug)
						ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Sending sms (%s)\n",gsm_sms[port].sms);
					/* We have not posted the lock here for another message
					   since SMS needs to be handled as a "transaction". This is the only
					   place we use gsm_send_raw() which does not use the locking mechanism.
                                	   We'll post the lock once we get an OK or an CME_ERROR/CMS_ERROR response. 
                                	 */
					snprintf(buf, sizeof(buf)-1, "%s\x1A",gsm_sms[port].sms);

					if (gsm_debug)
                                        ast_verbose(CHAN_GSM_VERBOSE_PREFIX "HERE CEM :%s:%s:%d : smssize:%d buf:%d: ctrlz:%d\n", __FILE__, __func__, __LINE__, strlen(gsm_sms[port].sms), strlen(buf), buf[strlen(buf)-1]);
					cem_plx_sms_write(port, buf, strlen(buf));
					gsm_sms[port].state=GSM_SMS_STATE_SMS_SENT;
#if 0
					usleep(100);
					buf[0]=26; buf[1]='\0';
					cem_plx_sms_write(port, buf, strlen(buf));
					usleep(500);
					buf[0]=26; buf[1]='\0';
					cem_plx_sms_write(port, buf, strlen(buf));
#endif
				}
				return;
				break;

			case GSM_EVENT_RESET:
				ast_verbose("Got Reset from SIM while sending message...FIXME!!!\n");
				break;
			default:
#if 0
				if((ev!=GSM_EVENT_CMS_ERROR)&&((gsm_sms[port].state == GSM_SMS_STATE_EXPECTING_PROMPT) || (gsm_sms[port].state=GSM_SMS_STATE_SMS_SENT))){
					ast_verbose("Stuck while sending sms get me out of here!!!\n");

					gsm_send_sms_end(port);
					usleep(500);
#if 1

					/* go back to the original PDU mode if we changed it */
					if (gsm_cfg[port].sms_pdu_mode) {
						gsm_send(port, "AT+CMGF=0", 0);
					}

					/* requeue sms message if there was any */
					if ((gsm_sms[port].state == GSM_SMS_STATE_SMS_SENT) && \
					    (strlen(gsm_sms[port].outbound_msg.number)) && \
                                	    (strlen(gsm_sms[port].outbound_msg.text))) {
						ast_log(LOG_WARNING, " retrying message(%s) to number(%s)\n", gsm_sms[port].outbound_msg.text, gsm_sms[port].outbound_msg.number);
						_gsm_queue_sms(port, gsm_sms[port].outbound_msg.number, gsm_sms[port].outbound_msg.text);
					}

					/* reset the SMS state to none (we just failed) */
					gsm_sms[port].state=GSM_SMS_STATE_NONE;

					/* end of "transaction", so we allow the next message to be posted */
					gsm_post_next_msg(port);
#endif
				}
#endif
			break;
		}
	}

	/*Handling Incoming sms notification here.. queueing it here*/
	if (ev==GSM_EVENT_SMS_INCOMING_MESSAGE){
		char *p = strchr(event, ',');
		int index;
		if (strstr(event, "+CMTI:")) {
			if (p) {
				index = atoi(++p);
        			ast_verbose("Received  message number (%d) on sim card  %d\n ",index,port);
				 //char ext[4]="sms";
#ifdef DIALPLAN_SMS
//				gsm_sms[port].work=GSM_SMS_WORK_READ_LAST_MSG;
//				gsm_sms[port].index__waiting_incoming_sms=index;
//				_gsm_read_sms(port, index); //Obtain Last message Received in Var

				++gsm_sms[port].number__waiting_incoming_sms;
				gsm_sms[port].index__waiting_incoming_sms[gsm_sms[port].number__waiting_incoming_sms]=index;
#endif	    
				if(index>=25){
					ast_verbose("Message inbox is full in sim card  (%d)...Delete few messages to continue receiving messages", port);	                                                 
					gsm_status[port].status=GSM_EVENT_ERROR; 
        			}
			        if (gsm_cfg[port].sms_pdu_mode) {
					manager_event(EVENT_FLAG_CALL, "IncomingSMS_PDU", "Port: %d\r\nIndex: %d\r\n", port, index);
				} else {
					manager_event(EVENT_FLAG_CALL, "IncomingSMS", "Port: %d\r\nIndex: %d\r\n", port, index);
				}
			}
		}
	}
	if (ev==GSM_EVENT_ENTER_SMS){
		ast_log(LOG_WARNING,"FIXME: We should never reach here\n");
	}

	/*pre call handling*/
	if (!gsm) {
		if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX "HERE CEM :%s:%s:%d : ev:%d port:%d\n", __FILE__, __func__, __LINE__, ev, port);
		switch(ev) {
			case GSM_EVENT_SIM_PIN:
			case GSM_EVENT_CALL_READY:
				/* this message is received when the radio is ready to go. */
				gsm_status[port].status=GSM_STATUS_REGISTERED;
				ast_verbose(CHAN_GSM_VERBOSE_PREFIX "P(%d)> SIM is ready\n", port);
				// init_mod_port(port);
				// gsm_send(port, "AT+CREG?", 0);
				// gsm_send(port, "AT+COPS?", 0);
				break;

			case GSM_EVENT_NO_CARRIER:
				/* caller hung up before we could answer */
                                ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Last Call cost: %s\n",event);
	
                                gsm_slcc[port].ringing = 0;
				gsm_slcc[port].ringcount = 0;
				break;
	
			case GSM_EVENT_CREG_SERVICE_0:
				gsm_status[port].status=GSM_STATUS_UNREGISTERED;
				gsm_status[port].rssi = 0;
				strcpy(gsm_status[port].provider, "\"none\"   ");
				gsm_status[port].homezone=0;
                                ast_verbose(CHAN_GSM_VERBOSE_PREFIX "  == Module %d NOT Registered @ Network\n", port);
				gsm_set_led(port,LED_RED);
				gsm_send(port, "AT+CSQ", 0);

				if (gsm_debug) {
					ast_log(LOG_DEBUG, "P(%d)> Module NOT Registered @ Network\n", port);
					ast_log(LOG_DEBUG, "Updating LCD for port:%d to CHANNEL_STATE_DOWN\n", port);
				}
				gsm_set_channel_state(port, CHANNEL_STATE_DOWN);
				gsm_send_channel_state(port, CHANNEL_STATE_DOWN);
				break;

			case GSM_EVENT_CREG_SERVICE_1:
				gsm_status[port].status=GSM_STATUS_REGISTERED;
				gsm_send(port, "AT+COPS?", 100);
                                ast_verbose(CHAN_GSM_VERBOSE_PREFIX "  == Module %d Registered @ Network (Homezone)\n", port);

				gsm_status[port].homezone=1;
				gsm_send(port, "AT+CSQ", 0);
				gsm_send(port, "AT+CCWA=0,0", 0);

				if (gsm_debug) {
					ast_log(LOG_DEBUG,  "P(%d)> Module Registered @ Network\n", port);
					ast_log(LOG_DEBUG, "Updating LCD for port:%d to CHANNEL_STATE_READY\n", port);
				}
				gsm_set_channel_state(port, CHANNEL_STATE_READY);
				gsm_send_channel_state(port, CHANNEL_STATE_READY);
				break;

			case GSM_EVENT_CREG_SERVICE_2:
				gsm_status[port].status=GSM_STATUS_UNREGISTERED;
				gsm_status[port].rssi = 0;
				strcpy(gsm_status[port].provider, "\"none\"   ");
				gsm_status[port].homezone=0;

				ast_verbose(CHAN_GSM_VERBOSE_PREFIX "  == Module %d Searching for Network\n", port);
				gsm_send(port, "AT+CSQ", 0);

				if (gsm_debug) { 
					ast_log(LOG_DEBUG, "P(%d)> Module Searching for Network\n", port);
					ast_log(LOG_DEBUG, "Updating LCD for port:%d to CHANNEL_STATE_DOWN\n", port);
				}
				gsm_set_channel_state(port, CHANNEL_STATE_DOWN);
				gsm_send_channel_state(port, CHANNEL_STATE_DOWN);

				break;

			case GSM_EVENT_CREG_SERVICE_3:
				gsm_status[port].status=GSM_STATUS_UNREGISTERED;
				strcpy(gsm_status[port].provider, "\"none\"   ");
				gsm_status[port].homezone=0;
				ast_verbose(CHAN_GSM_VERBOSE_PREFIX "  == Module %d Network Registration DENIED.\n", port);
				gsm_send(port, "AT+CSQ", 0);

				if (gsm_debug) {
					ast_log(LOG_DEBUG, "P(%d)> Module Network Registration DENIED.\n", port);
					ast_log(LOG_DEBUG, "Updating LCD for port:%d to CHANNEL_STATE_DOWN\n", port);
				}
				gsm_set_channel_state(port, CHANNEL_STATE_DOWN);
				gsm_send_channel_state(port, CHANNEL_STATE_DOWN);
				break;

			case GSM_EVENT_CREG_SERVICE_4:
				ast_verbose(CHAN_GSM_VERBOSE_PREFIX "P(%d)> Unknown Event.\n", port);
				if (gsm_debug)
					ast_log(LOG_DEBUG, "P(%d)> Unknown Event.\n", port);
				break;

			case GSM_EVENT_CREG_SERVICE_5:
				gsm_status[port].status=GSM_STATUS_REGISTERED;
				ast_verbose(CHAN_GSM_VERBOSE_PREFIX "  == Module %d Registered @ Network (ROAMING)\n", port);
				gsm_send(port, "AT+COPS?", 100);
				gsm_send(port, "AT+CSQ", 0);
				gsm_send(port, "AT+CCWA=0,0", 0);
				gsm_status[port].homezone=0;

				if (gsm_debug) {
					ast_log(LOG_DEBUG, "P(%d)> Module Registered @ Network\n", port);
					ast_log(LOG_DEBUG, "Updating LCD for port:%d to CHANNEL_STATE_READY\n", port);
			 	}	
				gsm_set_channel_state(port, CHANNEL_STATE_READY);
				gsm_send_channel_state(port, CHANNEL_STATE_READY);
				break;

			case GSM_EVENT_CSQ:
				{
					char *p = strchr(event, ':');
					if (p)
						gsm_status[port].rssi = atoi(++p);
				}
				break;

			case GSM_EVENT_INIT:
				if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX "HERE CEM :%s:%s:%d : ev:%d port:%d\n", __FILE__, __func__, __LINE__, ev, port);
				if (strstr(event, "GSMINIT: PORT NOT INITIALIZED:")) {
					if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX "HERE CEM :%s:%s:%d : ev:%d port:%d\n", __FILE__, __func__, __LINE__, ev, port);
						gsm_status[port].status=GSM_STATUS_UNINITIALIZED;
						gsm_set_led(port,LED_RED);
						ast_log(LOG_WARNING, "P(%d)> ! Module not Initialized: %s\n", port, event);
				} else {
					if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX "HERE CEM :%s:%s:%d : ev:%d port:%d\n", __FILE__, __func__, __LINE__, ev, port);
						gsm_set_led(port,LED_GREEN|LED_BLINK);
						gsm_status[port].status=GSM_STATUS_INITIALIZED;
						//gsm_status[port].status = GSM_STATUS_REGISTERED;

						if (gsm_debug)
							ast_verbose(CHAN_GSM_VERBOSE_PREFIX "P(%d)> Module Initialized, requesting Registration\n", port);
				}
				break;

			case GSM_EVENT_COPS:
				if (!strcasecmp(event, "+COPS: 1")) {
					ast_verbose(CHAN_GSM_VERBOSE_PREFIX "P(%d)> ! Module has no Provider\n", port);
					strcpy(gsm_status[port].provider, "\"none\"   ");
				} else {
					char *p=event, *prov;
					strsep(&p,",");
					strsep(&p,",");
					prov=strsep(&p,"OK");

					if (gsm_debug)
						ast_verbose(CHAN_GSM_VERBOSE_PREFIX "P(%d)> Module Provider (%s)\n", port, prov);
					if (prov)
						strcpy(gsm_status[port].provider, prov);
					else
						strcpy(gsm_status[port].provider, "\"none\"   ");
				}
				gsm_send(port, "AT+CSQ", 0);
				break;
	
			case GSM_EVENT_CLIP:
				sscanf(event,"+CLIP: \"%[+0-9]\",%d",
					gsm_slcc[port].callerid,
					&gsm_slcc[port].type);
				
				if (gsm_debug)
					ast_verbose(CHAN_GSM_VERBOSE_PREFIX "mode: %s cid: %s\n",
						gsm_slcc[port].type==145?"INT":"OTHER",
						gsm_slcc[port].callerid);

		//		break;

			case GSM_EVENT_RING:

				/* mark this line as ringing, we'll clear this once the line is answered or hung up */
				gsm_slcc[port].ringing = 1;

				/* pick up the phone on the second ring message */
				/* so, we can get the +CLIP message in between */
				if (gsm_slcc[port].ringcount == 0) {
					gsm_slcc[port].ringcount++;
#if 1 /* FIXME muiple event problem... CLIP comes with RING event together*/
					char *cidp = strstr(event, "+CLIP:");
					if (cidp){
						sscanf(cidp,"+CLIP: \"%[+0-9]\",%d",
      		  				gsm_slcc[port].callerid,
      		  				&gsm_slcc[port].type);
      		  			
      		  				if (gsm_debug)
      		  					ast_verbose(CHAN_GSM_VERBOSE_PREFIX "mode: %s cid: %s\n",
      		  						gsm_slcc[port].type==145?"INT":"OTHER",
      		  						gsm_slcc[port].callerid);
      		  					
      		  			}
#endif		
					return;
				}

				/* reset the ring count here */			
				gsm_slcc[port].ringcount = 0;

				if (!gsm_port_fetch(port)) {
						ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Port %d already in use\n",port);
						gsm_send(port,"ATH",100);
						break;
				}
		
				/* The GSM CID and the Analog CID are curiously similar
				 * Just like the Analog CID, the GSM CID receives the CID between
                                 * two RING messages in the form of a +CLIP message. So, we pick up
                                 * the incoming call not on the first ring but on the second one :)
                                 */

				gsm=malloc(sizeof(struct gsm_pvt));
				if (!gsm) {
					ast_log(LOG_ERROR, "Error allocating memory for new GSM channel.");
					return;
				}

				memset(gsm,0,sizeof(struct gsm_pvt));

				gsm->port=port;

				configure_gsm(gsm);
				if (gsm_debug)
					ast_verbose(CHAN_GSM_VERBOSE_PREFIX " --> exten:%s callerid:%s\n",gsm->exten,
						gsm_slcc[port].callerid);

				char calleridbuf[64];
				char *cid=gsm_slcc[port].callerid;

				if (    gsm_config_get_bool(SECT_GENERAL, CFG_GEN_SKIP_PLUS) &&
					strlen(cid) &&
					gsm_slcc[port].type==145) {
					cid++; /*skip the '+'*/
				}

				if ( gsm_slcc[port].type==129) {
					char prefix[16];
					cm_get(config, prefix, sizeof(prefix), SECT_PORT, CFG_PORT_CID_PREFIX, port);

					if (gsm_debug) 
						ast_verbose(CHAN_GSM_VERBOSE_PREFIX "type==129, prefix=%s\n", prefix);
					if (!ast_strlen_zero(prefix)) {
						strcpy(calleridbuf, prefix);
						strcat(calleridbuf, gsm_slcc[port].callerid);
						cid=calleridbuf;
					}
				}

				struct ast_channel *chan=gsm_new(gsm, gsm->exten, cid, NULL, AST_STATE_RINGING);

				ast_pbx_start(chan);
				break;

			case GSM_EVENT_CUSD:
				{
                                               char *p=strstr(event, "+CUSD: ");
						if (p) {
						p+=strlen("+CUSD: ");
							ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Last sms cost: %s\n",p);
							manager_event(EVENT_FLAG_CALL, "GSM_USSD", "Port: %d\r\nMessage: %s\r\n", port, p);
						}
				}
				break;

			case GSM_EVENT_COPN:
				{
						char *p=strstr(event, "+COPN: ");
						if (p) {
							p+=strlen("+COPN: ");
							ast_verbose(CHAN_GSM_VERBOSE_PREFIX "%s\n", p);
						}
				}
				break;

			case GSM_EVENT_ERROR:
				        if(gsm_debug)
                                        	//ast_verbose(LOG_ERROR, "port=(%d) GSM_EVENT_ERROR : last command  (%s)\n",port, gsm_get_last_command(port));
				/* end of "transaction", so we allow the next message to be posted */
				gsm_post_next_msg(port);
				break;

			case GSM_EVENT_CME_ERROR:
				{
					char *p = strchr(event, ':');
					char *cme_text_msg;
					int cme_error = -1;

					if (p)
						cme_error = atoi(++p);

					if ((cme_text_msg = (char*)gsm_get_cme_text(cme_error))) {
						if(gsm_debug)
							ast_log(LOG_ERROR, "port=(%d) GSM_EVENT_CME_ERROR : %d:%s last command  (%s)\n",
								port, cme_error, cme_text_msg, gsm_get_last_command(port));
					} else {
						if(gsm_debug)
							ast_log(LOG_ERROR, "port=(%d) GSM_EVENT_CME_ERROR : %d last command  (%s)\n", 
								port, cme_error, gsm_get_last_command(port));
					}

					if((cme_error==CME_ERROR_SIM_FAILURE) 
						|| (cme_error==CME_ERROR_SIM_NOT_INSERTED)
						|| (cme_error==CME_ERROR_SIM_WRONG)
						|| (cme_error==CME_ERROR_SIM_POWERED_DOWN)
						|| (cme_error==CME_ERROR_SIM_INVALID_NETWORK_REJECT)
					){ 
						gsm_status[port].status=GSM_STATUS_UNREGISTERED;
						if (gsm_debug) ast_verbose(CHAN_GSM_VERBOSE_PREFIX "gsm unregistered port %d\n", port);
					}

					gsm_handle_cme_error(port, cme_error);
				}
				/* end of "transaction", so we allow the next message to be posted */
				gsm_post_next_msg(port);
				break;

			case GSM_EVENT_CMS_ERROR:
				{
					char *p = strchr(event, ':');
					char *cms_text_msg;
					int cms_error = -1;

					if (p)
						cms_error = atoi(++p);

					if ((cms_text_msg = (char*)gsm_get_cms_text(cms_error))) {
						if(gsm_debug)
	                                             ast_log(LOG_ERROR, "port=(%d) GSM_EVENT_CMS_ERROR : %d:%s last command (%s)\n",
							 port, cms_error, cms_text_msg, gsm_get_last_command(port));
					} else {
						if(gsm_debug)
							ast_log(LOG_ERROR, "port=(%d) GSM_EVENT_CMS_ERROR : %d last command (%s)\n",
								port, cms_error, gsm_get_last_command(port));
					}

					gsm_handle_cms_error(port, cms_error);
				}
				/* go back to the original PDU mode if we changed it */
				if (gsm_cfg[port].sms_pdu_mode) {
					gsm_send(port, "AT+CMGF=0", 0);
				}

				/* requeue sms message if there was any */
				if ((gsm_sms[port].state == GSM_SMS_STATE_SMS_SENT) && \
				    (strlen(gsm_sms[port].outbound_msg.number)) && \
                                    (strlen(gsm_sms[port].outbound_msg.text))) {
					ast_log(LOG_WARNING, " retrying message(%s) to number(%s)\n", gsm_sms[port].outbound_msg.text, gsm_sms[port].outbound_msg.number);
					if (gsm_sms[port].retry < 2 ){
						gsm_sms[port].retry++;
						_gsm_queue_sms(port, gsm_sms[port].outbound_msg.number, gsm_sms[port].outbound_msg.text);
					 } else {
						ast_log(LOG_NOTICE,"Failed: Not enough balance, Trys(%d) Text(%s) Num(%s)\n", gsm_sms[port].retry+1, gsm_sms[port].outbound_msg.text,gsm_sms[port].outbound_msg.number);
						gsm_sms[port].retry = 0 ;
					}
                                }

				/* reset the SMS state to none (we just failed) */
				gsm_sms[port].state=GSM_SMS_STATE_NONE;

				/* end of "transaction", so we allow the next message to be posted */
				gsm_post_next_msg(port);
				break;

			case GSM_EVENT_OK:
				/* end of "transaction", so we allow the next message to be posted */
			//	gsm_send(port,"AT+CAOC=2",0);
                                
                                gsm_post_next_msg(port);
				break;

			case GSM_EVENT_SIM_INSERTED:
//				if (gsm_debug)
					ast_log(LOG_DEBUG, "port=(%d) SIM insertion detected.\n", port);

				/* Query the IMSI number */
				gsm_send(port, "AT+CIMI", 0);
				break;

			case GSM_EVENT_SIM_REMOVED:
//				if (gsm_debug)
					ast_log(LOG_DEBUG, "port=(%d) SIM removal detected.\n", port);
				/* Toggle the radio functionality to force an update on SIM status */
				gsm_send(port, "AT+CFUN=0", 0);
				gsm_send(port, "AT+CFUN=1", 0);
				break;
			case GSM_EVENT_RESET:
				if(gsm_debug) ast_verbose("RESET IS done.. We have to initialize monules now!!!\n");
				init_mod_port(port);
				break;

			default:
			break;
		}
	}
	//ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 ) \n" );

	if (!gsm) { 
		if(gsm_debug) ast_log(LOG_ERROR , "[ALLO_GSM] Ops !!!!!!! no gsm !!!! we are returning from herere !!!!!!!!!!!!!!!!!!!!!!!!!!!!\n" );
		return;
	}

	/*during call handling*/
	switch (ev) {
		case GSM_EVENT_RING:
			//ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 1 ) \n" );
			if (gsm_debug)
				ast_verbose(CHAN_GSM_VERBOSE_PREFIX " -> RING\n");
			break;

		case GSM_EVENT_NO_CARRIER:
		case GSM_EVENT_NO_ANSWER:
		case GSM_EVENT_BUSY:
			//ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 2 ) \n" );
                       if (gsm_debug){
			//	ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 2 . 1 ) \n" );
				ast_verbose(CHAN_GSM_VERBOSE_PREFIX " -> BUSY/NO CARRIER/CALL_0\n");
			}
			if (ast && gsm->state != GSM_STATE_HANGUPED) {
			//	ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 2 . 2 ) \n" );
				gsm->state=GSM_STATE_HANGUPED;
#ifdef ASTERISK_11_4 
                                ast_channel_hangupcause_set(ast, 17);
#else
                                ast->hangupcause=17;
#endif
				ast_queue_hangup(ast);
			}
                       char *p=strstr(event, "+CUSD: ");
                       if (p) {
                          p+=strlen("+CUSD: ");
                          ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Last Call cost : %s\n",p);
                          manager_event(EVENT_FLAG_CALL, "GSM_USSD", "Port: %d\r\nMessage: %s\r\n", port, p);
                                                       }

                        /* line no longer ringing, so it's safe to send SMS */
			//	ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 2 . 3 ) \n" );
			gsm_slcc[port].ringing = 0;
			//	ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 2 . 4 ) \n" );
			/* allow the next message to be posted */
			gsm_post_next_msg(port);
			//	ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 2 . 5 ) \n" );
			break;
		
		 case GSM_EVENT_DTMF_RECEIVED:
                        //ast_verbose("Event %s\n",event);
                        gsm_read_dtmf(ast,event);
                        break;


		case GSM_EVENT_OK:
		//	ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 3 ) \n" );
			if (gsm_debug)
				ast_verbose(CHAN_GSM_VERBOSE_PREFIX " -> OK\n");
			/* allow the next message to be posted */
		       ast_verbose("event=%s\n",event); 
                        gsm_post_next_msg(port);
			if (gsm->state != GSM_STATE_ATD_OUT) break;
			break;

		case GSM_EVENT_CLCC_CALL_0:
		//	ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 4 ) \n" );
			/* only send answer if you have not done so yet */
			if (gsm->state != GSM_STATE_ANSWERED) {
				if (gsm_debug)
					ast_verbose(CHAN_GSM_VERBOSE_PREFIX " -> ANSWER\n");
				ast_queue_control(ast, AST_CONTROL_ANSWER);
				int res=gsm_audio_start(gsm->port);
				if (res<0) {
					ast_log(LOG_WARNING, " couldn't start audio error (%d,%s)\n", errno, strerror(errno));
				}
				gsm->state = GSM_STATE_ANSWERED;
			} else {
				ast_log(LOG_ERROR , "[ALLO_GSM] This is an error call is alredy answered ? \n" );
			}
			break;

		case GSM_EVENT_CLCC_CALL_2:
		//	ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 5 ) \n" );
			if (gsm->state == GSM_STATE_ATD_OUT) {
				if (gsm_debug)
					ast_verbose(CHAN_GSM_VERBOSE_PREFIX " -> PROCEEDING\n");
				
				if ( gsm_cfg[gsm->port].early_media == 1 ){
					ast_queue_control(ast, AST_CONTROL_PROGRESS);
					if (gsm_debug)
						ast_verbose(CHAN_GSM_VERBOSE_PREFIX " -> gsm_cfg.early_media: %d ANSWERED\n", gsm_cfg[1].early_media,gsm->port);
				}else{
					ast_queue_control(ast, AST_CONTROL_RINGING);
					if (gsm_debug)
						ast_verbose(CHAN_GSM_VERBOSE_PREFIX " -> gsm_cfg.early_media: %d RINGING\n", gsm_cfg[1].early_media);
				}
			         int res=gsm_audio_start(gsm->port);
                                if (res<0) {
                                        ast_log(LOG_WARNING, " couldn't start audio error (%d,%s)\n", errno, strerror(errno));
                                }

                            gsm->state = GSM_STATE_PROCEEDING;

                         }
			break;

		case GSM_EVENT_CLCC_CALL_3:
		//	ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 6 ) \n" );
			{ 	//inband info available
				int res=gsm_audio_start(gsm->port);
				if (res<0) {
					ast_verbose(LOG_WARNING, " couldn't start audio error (%d,%s)\n", errno, strerror(errno));
				}
			}
			if (gsm->state == GSM_STATE_PROCEEDING) {
				if (gsm_debug)
					ast_verbose(CHAN_GSM_VERBOSE_PREFIX " -> ALERTING\n");
				if ( gsm_cfg[gsm->port].early_media != 1 ){
					ast_queue_control(ast, AST_CONTROL_RINGING);
				}
				gsm->state = GSM_STATE_ALERTING;
			}	
			break;

	/*	case GSM_EVENT_OK:
			ast_verbose(" -> OK\n");
			break;*/

		case GSM_EVENT_NONE:
		//	ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 7 ) \n" );
			if (gsm_debug)
				ast_verbose(CHAN_GSM_VERBOSE_PREFIX " -> NONE\n");
			break;

		case GSM_EVENT_CME_ERROR:
		//	ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 8 ) \n" );
			{
				char *p = strchr(event, ':');
				char *cme_text_msg;
				int cme_error = -1;

				if (p)
					cme_error = atoi(++p);

				if ((cme_text_msg = (char*)gsm_get_cme_text(cme_error))) {
					ast_log(LOG_ERROR, "port=(%d) GSM_EVENT_CME_ERROR : %d:%s last command  (%s)\n",
						port, cme_error, cme_text_msg, gsm_get_last_command(port));
				} else {
					ast_log(LOG_ERROR, "port=(%d) GSM_EVENT_CME_ERROR : %d last command (%s)\n",
						port, cme_error, gsm_get_last_command(port));
				}

				gsm_handle_cme_error(port, cme_error);
			}

			/* end of "transaction", so we allow the next message to be posted */
			gsm_post_next_msg(port);
			break;

		case GSM_EVENT_CMS_ERROR:
		//	ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 9 ) \n" );
			{
				char *p = strchr(event, ':');
				char *cms_text_msg;
				int cms_error = -1;

				if (p)
					cms_error = atoi(++p);

				if ((cms_text_msg = (char*)gsm_get_cms_text(cms_error))) {
					ast_log(LOG_ERROR, "port=(%d) GSM_EVENT_CMS_ERROR : %d:%s last command (%s)\n",
						port, cms_error, cms_text_msg, gsm_get_last_command(port));
				} else {
					ast_log(LOG_ERROR, "port=(%d) GSM_EVENT_CMS_ERROR : %d last command (%s)\n",
						port, cms_error, gsm_get_last_command(port));
				}

				gsm_handle_cms_error(port, cms_error);
			}
			/* go back to the original PDU mode if we changed it */
			if (gsm_cfg[port].sms_pdu_mode) {
				gsm_send(port, "AT+CMGF=0", 0);
			}
			/* reset the SMS state to none (we just failed) */
			gsm_sms[port].state=GSM_SMS_STATE_NONE;

			/* end of "transaction", so we allow the next message to be posted */
			gsm_post_next_msg(port);
			break;

		case GSM_EVENT_ERROR:
		//	ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 10 ) \n" );
			ast_log(LOG_ERROR, "GSM EVENT ERROR wo. gsm obj\n");
			/* end of "transaction", so we allow the next message to be posted */

		//	ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 10 ) \n" );
			if (gsm_debug){
		//		ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 10 . 1 ) \n" );
				ast_verbose(CHAN_GSM_VERBOSE_PREFIX " -> BUSY/NO CARRIER/CALL_0\n");
			}
			if (event_handled != HANDLE_EVENT_NONE)
				break;
			if (ast && gsm->state != GSM_STATE_HANGUPED) {
		//		ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 10 . 2 ) \n" );
				gsm->state=GSM_STATE_HANGUPED;
#ifdef ASTERISK_11_4 
                                ast_channel_hangupcause_set(ast, 17);
#else
                                ast->hangupcause=17;
#endif
				ast_queue_hangup(ast);
			}
			/* line no longer ringing, so it's safe to send SMS */
		//		ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 10 . 3 ) \n" );
			gsm_slcc[port].ringing = 0;


			gsm_post_next_msg(port);
			break;

		case GSM_EVENT_SIM_INSERTED:
		//	ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 11 ) \n" );
			if (gsm_debug)
				ast_log(LOG_DEBUG, "port=(%d) SIM insertion detected during call(?).\n", port);
			break;

		case GSM_EVENT_SIM_REMOVED:
		//	ast_log(LOG_ERROR , "[ALLO_GSM] ( 6 . 12 ) \n" );
			if (gsm_debug)
				ast_log(LOG_DEBUG, "port=(%d) SIM removal detected during call.\n", port);
			break;

		default:
			break;
	}
//	ast_log(LOG_ERROR , "[ALLO_GSM] ( 7 ) \n" );
}

static int gsm_send_sms_exec(struct ast_channel *chan, void *data)
{
	int port;
	AST_DECLARE_APP_ARGS(args,
				AST_APP_ARG(port);
				AST_APP_ARG(number);
				AST_APP_ARG(sms);
				);

	if (ast_strlen_zero(data)) {
		ast_log(LOG_WARNING, "This application requires arguments.\n");
		return -1;
	}

	AST_STANDARD_APP_ARGS(args, data);

	if (args.argc != 3) {
		ast_log(LOG_WARNING, "Wrong argument count\n");
		return 0;
	}


	port = strtol(args.port, NULL, 10);

#if 1
	_gsm_queue_sms(port, args.number, args.sms);
#else
	if(strlen(args.sms)<=SMS_MSG_SZ){
		_gsm_queue_sms(port, args.number, args.sms);
	}
	else{
		char buf[128];
		sprintf(buf,"AT+CMMS=1");
		gsm_send(port, buf, 0);
		ast_verbose("SETTING FOR MUSTIPLE MESSAGES !!!!!!!!!!\n");

		int s=0;
		for(s=0; s<strlen(buf); s+=128 ){
			char tbuf[128];
			memset(tbuf, 0, 128);
			strncpy(tbuf, &buf[s], 128);
		}
		_gsm_queue_sms(port, args.number, args.sms);
	}
#endif

	return 0;
}

static int gsm_set_simslot_exec(struct ast_channel *chan, void *data)
{
	int port, slot, wait;
	AST_DECLARE_APP_ARGS(args,
		AST_APP_ARG(port);
		AST_APP_ARG(slot);
		AST_APP_ARG(wait);
	);

 	if (ast_strlen_zero(data)) {
		ast_log(LOG_WARNING, "This application requires arguments.\n");
		return -1;
	}

	AST_STANDARD_APP_ARGS(args, data);

	if (args.argc < 2) {
		ast_log(LOG_WARNING, "Wrong argument count\n");
		return 0;
	}

	port = strtol(args.port, NULL, 10);
	slot = strtol(args.slot, NULL, 10);

	if (args.argc == 3)
		wait = strtol(args.wait, NULL, 10);
	else
		wait = 5;

	//ast_verbose("Setting Simslot:%d on port:%d\n", slot, port);

	int i=gsm_set_next_simslot(port, slot);
	if (i<0) {
		ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Setting simslot failed (%s)\n", strerror(errno));
		return -1;
	}

	if (i)	
		_gsm_restart_port(port, wait) ;
	else 
		ast_verbose(CHAN_GSM_VERBOSE_PREFIX "not setting Simslot, we have it already\n");

	return 0;
}


static void _init_mod_port(int port)
{
	char buf[256];
	char pin[sizeof(gsm_cfg[port].pin)];
	char smsc[sizeof(gsm_cfg[port].smsc)];
	char initfile[sizeof(gsm_cfg[port].initfile)];
	char sms_pdu_mode[256];
	char early_media[32];
	int simslot=0;

	if (gsm_debug)
		ast_verbose(CHAN_GSM_VERBOSE_PREFIX "Initializing port %d\n",port);

	simslot=gsm_simslot_next_get(port);

        if(gsm_debug)
	ast_verbose(CHAN_GSM_VERBOSE_PREFIX "[ALLO_GSM] Initializing port %d(%d)\n",port, simslot);

	/* this is a port that is not available */
	if (simslot<0) {
        if(gsm_debug)
		ast_log(LOG_ERROR, "Error accessing port %d\n",port);
		return;
	}

	gsm_status[port].status=GSM_STATUS_UNAVAILABLE;

	/*not measurable*/
	gsm_status[port].rssi=99;
	strcpy(gsm_status[port].provider,"\"none\"   ");

	gsm_cfg[port].port=1;

	if (cm_get(config, pin, sizeof(pin), SECT_PORT, CFG_PORT_PIN, port)) {
			strcpy(pin,"");
	}
	gsm_cfg_get_array("pin", pin, gsm_cfg[port].pin, simslot);

	if (gsm_debug)
		ast_verbose(CHAN_GSM_VERBOSE_PREFIX " cfg port (%d) pin (%s)\n",port,gsm_cfg[port].pin);


	if (cm_get(config, initfile, sizeof(buf), SECT_PORT, CFG_PORT_INITFILE, port)) {
		strcpy(initfile, "");
	}
	gsm_cfg_get_array("initfile",initfile, gsm_cfg[port].initfile, simslot);

	if (cm_get(config, smsc, sizeof(smsc), SECT_PORT, CFG_PORT_SMSC, port)) {
		strcpy(smsc, "");
	}

	if (cm_get(config, sms_pdu_mode, sizeof(sms_pdu_mode), SECT_PORT, CFG_PORT_SMS_PDU_MODE, port)) {
		strcpy(sms_pdu_mode, "no");
	}

	if (ast_true(sms_pdu_mode))
		gsm_cfg[port].sms_pdu_mode=1;
	else
		gsm_cfg[port].sms_pdu_mode=0;

	if (cm_get(config, early_media, sizeof(early_media), SECT_PORT, CFG_PORT_EARLY_MEDIA, port)) {
		strcpy(early_media, "yes");
	}

        if(gsm_debug)
		ast_verbose(CHAN_GSM_VERBOSE_PREFIX "early_media >%s< ast_true()=%d\n",early_media, ast_true(early_media));

	if (ast_true(early_media))
		gsm_cfg[port].early_media=1;
	else
		gsm_cfg[port].early_media=0;

	gsm_cfg_get_array("smsc", smsc, gsm_cfg[port].smsc, simslot);

	char rxgain[32];
	if (cm_get(config, rxgain, sizeof(rxgain), SECT_PORT, CFG_PORT_RX_GAIN, port)) {
		strcpy(rxgain, "0");
	}

	gsm_cfg[port].rx_gain = atoi(rxgain);

	char txgain[32];
	if (cm_get(config, txgain, sizeof(txgain), SECT_PORT, CFG_PORT_TX_GAIN, port)) {
		strcpy(txgain, "0");
	}

	gsm_cfg[port].tx_gain = atoi(txgain);

        if(gsm_debug)
	ast_verbose(CHAN_GSM_VERBOSE_PREFIX " cfg port (%d) tx/rx gain(%d/%d) \n",port,gsm_cfg[port].tx_gain, gsm_cfg[port].rx_gain);

	char ms[8];
	if (cm_get(config, ms, sizeof(ms), SECT_PORT, CFG_PORT_DTMF_DURATION, port)) {
		strcpy(ms, "0");
	}

	gsm_cfg[port].dtmf_duration= atoi(ms)/100;
        
        if(gsm_debug)
        {     
         int i ;
	for(i=0;i<MAX_GSM_PORTS;i++)
	{
         gsm_send(i,"AT+IPR=1",100);
         gsm_send(i,"AT+IPR=921600",100);
         gsm_send(i,"AT&W",100);
	}
	}
}

pthread_t gsm_load_thread;


#if 1
static int load_module(void)
#else
int load_module(void)
#endif

{
	ast_mutex_init(&gsm_mutex);

#if 0
	fp = fopen("/home/projects/gsm/morning_coffee.alaw" , "r");
	if(!fp){
		fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] Failed to open the audio file..... exiting the function !!!!! \n" , __FILE__ , __func__ , __LINE__  );
		exit(-1);
	} else {
		fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] We have opened the file................................... \n" , __FILE__ , __func__ , __LINE__  );
	}
#endif

#if 0
	pthread_create(&gsm_load_thread,NULL,load_module_thread,NULL);
	pthread_join(&gsm_load_thread,NULL);
#else
	load_module_thread(NULL);

	int plx_shutdown_status  = gsm_plx_shutdown_status();
	if(plx_shutdown_status){
		unload_module();
		return AST_MODULE_LOAD_FAILURE;
	}

#endif

	usleep(500*1000);
#if 1
        return AST_MODULE_LOAD_SUCCESS;
#else
	return 0;
#endif
}

void gsm_cleanup_func(void)
{      
        if(gsm_debug)	ast_verbose("[ALLO_GSM] Cleaning up here..\n");
	gsm_cleanup();
	if(gsm_debug)   ast_verbose("[ALLO_GSM] Cleaned here..\n");
}


void restart_plx ( void )
{


	int i = 0;
	ast_log(LOG_ERROR , "[ALLO_GSM] We are now re----initalizatiing the PLX........\n");
	for (i=0; i<total_plx_devices ; i++)
		Cmd_Reset(&Gbl_DeviceObj[i] , NULL );
	return;
	//ast_log(LOG_ERROR , "[ALLO_GSM] We are now re----initalizatiing the PLX........\n");
	CmdLine_Initialize();
//	int ExitCode = 0;
	//Gbl_pNodeCurrent = NULL;
	total_plx_devices = DeviceListCreate( PLX_API_MODE_PCI , NULL);

	for (i = 0 ; i < total_plx_devices ; i++){
		//ast_log(LOG_ERROR , "[ALLO_GSM] We are now opening the PLX Device number '%d'\n" , i );
		// Select first PLX device
		Gbl_pNodeCurrent[i] = DeviceNodeGetByNum(i, TRUE /*PLX only device*/    );
		if (Gbl_pNodeCurrent[i] == NULL){
			Cons_printf("ERROR: No PCI Devices found\n\n");
			fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] ERROR: No PCI Devices found \n" , __FILE__ , __func__ , __LINE__  );
		} else {
			fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] Oh !!!! gr8 !!! we found the PCI devices........\n" , __FILE__ , __func__ , __LINE__  );
		}

		// Select the device
		if (Gbl_pNodeCurrent[i] != NULL){
			fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] We are opening the pci device \n" , __FILE__ , __func__ , __LINE__  );
			PlxPci_DeviceOpen( &Gbl_pNodeCurrent[i]->Key, &Gbl_DeviceObj[i] );
			
			fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] Mapping the PCI BAR registers \n" , __FILE__ , __func__ , __LINE__  );
			// Map valid PCI BAR spaces
			PciSpacesMap( &Gbl_DeviceObj[i] , Gbl_pNodeCurrent[i], i);
			
			fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] Common buffer properties \n" , __FILE__ , __func__ , __LINE__  );
			// Get Common buffer properties
			CommonBufferMap( &Gbl_DeviceObj[i] );
			
			fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] marking the selected device \n" , __FILE__ , __func__ , __LINE__  );
			// Mark device as selected
			Gbl_pNodeCurrent[i]->bSelected = TRUE;
		}
	}

}

int gsm_sms_init(int port){
		gsm_sms[port].s=NULL;
		gsm_sms[port].m=NULL;
		gsm_sms[port].state=GSM_SMS_STATE_NONE;
		gsm_sms[port].work=GSM_SMS_WORK_SHOW;

		gsm_sms[port].retry=0;

		memset(&gsm_sms[port].outbound_msg, 0, sizeof(struct gsm_sms_message));
		memset(&gsm_sms[port].inbound_msg, 0, sizeof(struct gsm_sms_message));

		memset(gsm_sms[port].soc_filename, 0 , sizeof(gsm_sms[port].soc_filename));
		memset(gsm_sms[port].sms, 0 , sizeof(gsm_sms[port].sms));
		memset(gsm_sms[port].number, 0 , sizeof(gsm_sms[port].number));

		gsm_sms[port].soc_id=-1;
		gsm_sms[port].incoming_sms_counter=0;

		snprintf( gsm_sms[port].soc_filename , sizeof(gsm_sms[port].soc_filename)-1 , "/tmp/gsm_sms_fifo_%d_%d" , port, getuid()); /* This is for the FIFO communication used for the IPC */
		int res = unlink(gsm_sms[port].soc_filename);
		if (access(gsm_sms[port].soc_filename, F_OK) == -1) {
		        int res = mkfifo(gsm_sms[port].soc_filename, 0777);
        		if (res != 0) {
		            fprintf(stderr, "Could not create SMS FIFO %s\n" , gsm_sms[port].soc_filename );
		            //exit(1);
        		}
    		}

		gsm_sms[port].soc_id=open(gsm_sms[port].soc_filename, O_RDWR );
		if(gsm_sms[port].soc_id< 0){
			perror("SMS FIFO open failed ???? ");
		}
		fcntl(gsm_sms[port].soc_id, F_SETFL, O_NONBLOCK);

return 0;
}



int gsm_sms_destroy(int port){
	gsm_sms[port].state=GSM_SMS_STATE_NONE;
	gsm_sms[port].work=GSM_SMS_WORK_SHOW;

	if(gsm_sms[port].soc_id>0){
		close(gsm_sms[port].soc_id);
	}
	gsm_sms[port].soc_id=-1;

	snprintf( gsm_sms[port].soc_filename , sizeof(gsm_sms[port].soc_filename)-1 , "/tmp/gsm_sms_fifo_%d_%d" , port, getuid()); /* This is for the FIFO communication used for the IPC */
	unlink(gsm_sms[port].soc_filename);

return 0;
}

void* load_module_thread(void* data)
{
	int i;
	ast_mutex_lock(&gsm_mutex);
	memset(gsm_slcc, 0, sizeof(gsm_slcc));

        if(gsm_debug)
		ast_verbose("[ALLO_GSM] We are now initalizatiing the PLX........\n");

	CmdLine_Initialize();
//	int ExitCode = 0;
//	Gbl_pNodeCurrent = NULL;
	total_plx_devices = DeviceListCreate( PLX_API_MODE_PCI , NULL );

	for (i = 0 ; i < total_plx_devices ; i++){
        	if(gsm_debug)
			ast_verbose("[ALLO_GSM] We are now opening the PLX Device number '%d'\n" , i );
		// Select first PLX device
		Gbl_pNodeCurrent[i] = DeviceNodeGetByNum(i, TRUE /*PLX only device*/    );
		
		if (Gbl_pNodeCurrent[i] == NULL){   
			if(gsm_debug){
				Cons_printf("ERROR: No PCI Devices found\n\n");
				fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] ERROR: No PCI Devices found \n" , __FILE__ , __func__ , __LINE__  );
			}	
		}else{
		        if(gsm_debug)
				fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] Oh !!!! gr8 !!! we found the PCI devices........\n" , __FILE__ , __func__ , __LINE__  );
		}

		// Select the device
		if (Gbl_pNodeCurrent[i] != NULL){
		        if(gsm_debug)
				fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] We are opening the pci device \n" , __FILE__ , __func__ , __LINE__  );
		
			PlxPci_DeviceOpen( &Gbl_pNodeCurrent[i]->Key, &Gbl_DeviceObj[i] );
		
	        	if(gsm_debug)
				fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] Mapping the PCI BAR registers \n" , __FILE__ , __func__ , __LINE__  );

			// Map valid PCI BAR spaces
			PciSpacesMap( &Gbl_DeviceObj[i] , Gbl_pNodeCurrent[i], i );
		
		        if(gsm_debug)
				fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] Common buffer properties \n" , __FILE__ , __func__ , __LINE__  );
		
			// Get Common buffer properties
			CommonBufferMap( &Gbl_DeviceObj[i] );
		
		        if(gsm_debug)
				fprintf(stderr,"'%s':'%s':'%d'[ALLO_GSM] marking the selected device \n" , __FILE__ , __func__ , __LINE__  );
		
			// Mark device as selected
			Gbl_pNodeCurrent[i]->bSelected = TRUE;
		}
	}
#if 0
	/* Not Enabling interrupt handler here because they are using send_expect to initialise.. which doesnt use intr method to read response FIXME*/
	gsm_start_int_thread();
#endif
	for (i=1; i<MAX_GSM_PORTS; i++) {
	        if(gsm_debug)
			ast_verbose("[ALLO_GSM] We are calling the init port for GSM '%d' gsm_cfg[i].port '%d' and MAX_GSM_PORTS '%d' \n" , i , gsm_cfg[i].port , MAX_GSM_PORTS );
		/* Setting default value before initialise */
		gsm_status[i].status=GSM_STATUS_UNREGISTERED;
		//if (gsm_cfg[i].port) {
			if (gsm_init_port(i, &gsm_cfg[i])<0) {
        			if(gsm_debug)
					ast_log(LOG_ERROR, "gsm_cfg: error initializing port %d\n", i);
				return NULL;
			} else {
			        if(gsm_debug)
					ast_verbose("[ALLO_GSM] Gr888888888888888888 we have initialized the GSM port '%d' \n" , i );
			}
			gsm_sms_init(i);

		//} else {
		//	ast_log(LOG_ERROR , "[ALLO_GSM] Opssss !! port is not available so not going to init the GSM port '%d' \n" , i );
		//}
	}

	gsm_config_init();

        if(gsm_debug)
	ast_verbose("Completed parsing config files...\n");

	char filename[256];
	memset(filename, 0, 256);
	cm_get(config, filename, sizeof(filename)-32, SECT_GENERAL, CFG_GEN_SMS_DIR );
	
	if ((mkdir(filename,0777) < 0) && (errno != EEXIST)){
	        if(gsm_debug)
			ast_log(LOG_WARNING, "Couldn't create sms save dir (%s) error(%s)\n",filename, strerror(errno));
	}

        if(gsm_debug)
		ast_verbose("[ALLO_GSM] %s:%s:%d...\n", __FILE__, __func__, __LINE__);
	char debug[16];
	cm_get(config, debug, sizeof(debug), SECT_GENERAL, CFG_GEN_DEBUG);
	gsm_debug=strtol(debug,NULL,10);

	memset(csel_groups,0x00,sizeof(csel_groups));
	memset(gsm_cfg,0x00,sizeof(gsm_cfg));
	memset(gsm_status,0x00,sizeof(gsm_status));

        if(gsm_debug)
	ast_verbose("[ALLO_GSM] %s:%s:%d...\n", __FILE__, __func__, __LINE__);
	/*initialize the gsm_config*/
	int  next;
	int *prev = NULL;

        if(gsm_debug)
	ast_log(LOG_ERROR , "[ALLO_GSM] Now we are going to initialize the GSM ports !!!!! \n" );
	for (; cm_get_next_id(config, SECT_PORT, prev, &next); prev = &next) {
		char name[128], method[128];
		int i;
		char slot[32];

		if (next <=0 || next >= MAX_GSM_PORTS) {
        		if(gsm_debug)
				ast_log(LOG_WARNING, "ignoring port %d: invalid port id\n", next);
			continue;
		}

		/*if (!gsm_check_port(next)) {
			ast_log(LOG_WARNING, "ignoring port %d: missing module\n", next);
			continue;
		}*/

		cm_get(config, name, sizeof(name), SECT_PORT, CFG_PORT_NAME, next);
		cm_get(config, method, sizeof(method), SECT_PORT, CFG_PORT_METHOD, next);
		for (i=0;i<MAX_GSM_PORTS;i++) {
			if (!csel_groups[i].name) {
				//we're at the end of the list, so
				//we add a new CSEL object
				csel_groups[i].name=strdup(name);
				csel_groups[i].cs = csel_create(
					method,
					NULL, /*parm*/
					csel_occupy, /*occupy*/
					NULL /*free*/
				);
			}

			if (!strcmp(csel_groups[i].name, name)) {
				//FIXME: add port to csel
				csel_add(csel_groups[i].cs, (void*)next);
				break;
			}
		}

		if (cm_get(config, slot, sizeof(slot), SECT_PORT, CFG_PORT_SLOT, next)) {
			strcpy(slot,"0");
		}

		gsm_set_next_simslot(next, slot[0]=='1'?1:0);

		_init_mod_port(next);

		char resetiv[32];
		if (cm_get(config, resetiv, sizeof(resetiv), SECT_PORT, CFG_PORT_RESET_INTERVAL, next)) {
			strcpy(resetiv, "0");
		}

		if (atoi(resetiv)>0) {
			gsm_tasks_add( atoi(resetiv) * 1000, gsm_resetinterval, (void*)next);
		}

	        if(gsm_debug)
			ast_log(LOG_ERROR , "[ALLO_GSM] Looping to the next gsm port !!! \n" );
	}

	for (i=0; i<256; i++)
		sms_idx[i]=0;

	char sysdebug[16];
	if (cm_get(config, sysdebug, sizeof(sysdebug), SECT_GENERAL, CFG_GEN_SYSLOG_DEBUG, next)) {
		strcpy(sysdebug, "no");
	}

	/* change gsm_debug for the time being */
	gsm_debug = ast_true(sysdebug);
	gsm_set_debuglevel(gsm_debug);

        if(gsm_debug)
	ast_log(LOG_ERROR , "[ALLO_GSM] Calling gsm_init function.......\n" );
	if (gsm_init( cb_events , gsm_cfg, ast_true(sysdebug)) <0) {
        if(gsm_debug)
		ast_log(LOG_ERROR, "Unable to initialize GSM\n");
		ast_mutex_unlock(&gsm_mutex);
		return NULL;
	}
#if 1
	/* Enabling interrupt handler here because they are using send_expect to initialise.. which doesnt use intr method to read response FIXME*/
	gsm_start_int_thread(total_plx_devices);
#endif
        if(gsm_debug)
		ast_log(LOG_ERROR , "[ALLO_GSM] Calling gsm register.......\n" );
#if  ( defined ASTERISK_11_4 || defined ASTERISK_10_4 )
        struct ast_format tmpfmt;
        if (!(gsm_tech.capabilities = ast_format_cap_alloc())) {
                ast_log(LOG_ERROR , "[ALLO_GSM] Unable to initialize GSM\n" );
                return NULL;
        }
        ast_format_cap_add(gsm_tech.capabilities, ast_format_set(&tmpfmt, AST_FORMAT_ULAW, 0));
        ast_format_cap_add(gsm_tech.capabilities, ast_format_set(&tmpfmt, AST_FORMAT_ALAW, 0));
#endif
        if (ast_channel_register(&gsm_tech)) {
	        if(gsm_debug)
        	        ast_log(LOG_ERROR, "Unable to register channel type 'GSM'\n");
		ast_mutex_unlock(&gsm_mutex);
		return NULL;
        }

	ast_cli_register_multiple(chan_gsm_clis, sizeof(chan_gsm_clis) / sizeof(struct ast_cli_entry));
	ast_manager_register( "GsmSendSms", 0, action_send_sms, "Send SMS on GSM" );
	ast_manager_register( "GsmCheckSMSState", 0, action_check_sms_state, "Check the SMS statemachine state" );

	ast_register_application("gsm_set_simslot", gsm_set_simslot_exec, "gsm_set_simslot",
				 "gsm_set_simslot(<port>,<0|1>[,<waitseconds>])n"
				 "changes the to be used simslot for port <port> to either\n"
				 "0 or 1 (0 is the external accessible)\n"
				 "Waits for <waitseconds> seconds, to receive\n"
				 "a Network Register Event (5 seconds should be enough and is default)\n"
		);

	ast_register_application("gsm_send_sms", gsm_send_sms_exec, "gsm_send_sms",
				 "gsm_send_sms <port> <number> <smstext>\n"
				 "sends the smstext to the given port and number\n"
		);

	ast_register_atexit(gsm_cleanup_func);

#if 0
	char hz[32];
	if (cm_get(config, hz, sizeof(hz), SECT_GENERAL, CFG_GEN_CHEKHZ, next)) {
		strcpy(hz, "0");
	}

	if (ast_true(hz))
		gsm_tasks_add( 10 * 1000, gsm_check_homezone, NULL);

#endif

        if(gsm_debug)
		ast_log(LOG_ERROR , "[ALLO_GSM] We are adding call state check CLCC......... \n" );
	gsm_tasks_add(CALL_STATUS_CHECK_PERIOD_SEC * 1000, gsm_query_call_state, NULL);
	sms_sched_id = gsm_tasks_add(SMS_SENDING * 1000, gsm_sms_sender_func, NULL); // CHANGE: SMS_SENDING is added instead of SMS_SEND_PERIOD_SEC
	gsm_tasks_add(LCD_UPDATE_DELAY * 1000, gsm_update_lcd_status, NULL);

	gsm_initialized=1;

	ast_mutex_unlock(&gsm_mutex);

	return NULL;
}

pthread_t gsm_unload_thread;


static int close_plx(){

	int i = 0;
	for(i=0; i< total_plx_devices; i++){
		PLX_STATUS ret ;
            		if(gsm_debug) ast_verbose("[ALLO_GSM] Releasing plx devices...%d\n", i);
	         	if(Gbl_pNodeCurrent[i] && (Gbl_pNodeCurrent[i]->bSelected == TRUE)){	
	                if(gsm_debug) ast_verbose("[ALLO_GSM] Releasing plx devices...%d\n", i);
		        PciSpacesUnmap( &Gbl_DeviceObj[i], Gbl_pNodeCurrent[i],i);
		        if(gsm_debug) 	ast_verbose("[ALLO_GSM] Unmap pci ...\n");
	        	CommonBufferUnmap( &Gbl_DeviceObj[i] );
			if(gsm_debug) ast_verbose("[ALLO_GSM] Unmap buff ...\n");
		        ret = PlxPci_DeviceClose( &Gbl_DeviceObj[i] );
			if(ret==ApiSuccess)
			  if(gsm_debug)	ast_verbose("[ALLO_GSM] Closed plx devices...\n");
			else
                          if(gsm_debug) ast_verbose("[ALLO_GSM] Closing plx devices failed ret...%d\n", ret);
		}
	}

	CmdLine_CmdDeleteAll();
return 0;
}


int gsm_cleanup(){
	int i=0;

	for (i=1; i<MAX_GSM_PORTS; i++) {
		gsm_send(i,"AT+CFUN=0",0);
		gsm_sms_destroy(i);
	}

	gsm_shutdown(total_plx_devices);
	close_plx();
return 0;
}

#if 1
static int unload_module(void)
#else
int unload_module(void)
#endif
{

	ast_mutex_lock(&gsm_mutex);
	ast_cli_unregister_multiple(chan_gsm_clis, sizeof(chan_gsm_clis) / sizeof(struct ast_cli_entry));
	ast_manager_unregister( "GsmSendSms" );
	ast_manager_unregister( "GsmCheckSMSState" );
	ast_unregister_application("gsm_set_simslot");
	ast_unregister_application("gsm_send_sms");
 	ast_channel_unregister(&gsm_tech);
	gsm_config_exit();
	if (gsm_initialized) {
		gsm_tasks_destroy();
		gsm_cleanup();
		gsm_initialized = 0;
	}
	ast_unregister_atexit(gsm_cleanup_func);

	ast_mutex_unlock(&gsm_mutex);
	usleep(100*1000);

	return 0;

}

pthread_t gsm_reload_thread;

void* reload_module_thread(void* parm)
{
	struct gsm_config gsm_prev_cfg[MAX_GSM_PORTS];
	char shutdown_port[MAX_GSM_PORTS];
	char start_port[MAX_GSM_PORTS];
	char busy_port[MAX_GSM_PORTS];
	int *prev = NULL;
	int next;
	int i;
	unsigned long then = time(NULL);

	ast_mutex_lock(&gsm_mutex);

	memset(shutdown_port, 0, sizeof(shutdown_port));
	memset(start_port, 0, sizeof(start_port));
	memset(busy_port, 0, sizeof(busy_port));

	memcpy(gsm_prev_cfg, gsm_cfg, sizeof(gsm_prev_cfg));

	for (i=1; i < MAX_GSM_PORTS;i++) {
		busy_port[i] = gsm_port_in_use_get(i);
		if (!busy_port[i]) {
			memset(&csel_groups[i],0,sizeof(struct csel_groups));
			memset(&gsm_cfg[i],0,sizeof(struct gsm_config));
			memset(&gsm_status[i],0,sizeof(struct gsm_status_s));
		}
	}

	gsm_config_exit();
	gsm_config_init();

	char filename[128];
	cm_get(config, filename, sizeof(filename)-32, SECT_GENERAL, CFG_GEN_SMS_DIR );
	
	if ((mkdir(filename,0777) < 0) && (errno != EEXIST))
	{
		ast_log(LOG_WARNING, "Couldn't create sms save dir (%s) error(%s)\n",filename, strerror(errno));
	}

	char debug[16];
	cm_get(config, debug, sizeof(debug), SECT_GENERAL, CFG_GEN_DEBUG);
	gsm_debug = strtol(debug,NULL,10);

	char sysdebug[16];
	if (cm_get(config, sysdebug, sizeof(sysdebug), SECT_GENERAL, CFG_GEN_SYSLOG_DEBUG, next)) {
		strcpy(sysdebug, "no");
	}

	/* re-initialize the gsm_config*/
	for (; cm_get_next_id(config, SECT_PORT, prev, &next); prev = &next) {
		char name[128], method[128];
		char slot[32];

		if (next <=0 || next >= MAX_GSM_PORTS) {
			ast_log(LOG_WARNING, "ignoring port %d: invalid port id\n", next);
			continue;
		}

		/*if (!gsm_check_port(next)) {
			ast_log(LOG_WARNING, "ignoring port %d: missing module\n", next);
			continue;
		}*/

		if (!busy_port[next]) {
			cm_get(config, name, sizeof(name), SECT_PORT, CFG_PORT_NAME, next);
			cm_get(config, method, sizeof(method), SECT_PORT, CFG_PORT_METHOD, next);
			for (i=0;i<MAX_GSM_PORTS;i++) {
				if (!csel_groups[i].name) {
					//we're at the end of the list, so
					//we add a new CSEL object
					csel_groups[i].name=strdup(name);
					csel_groups[i].cs = csel_create(
						method,
						NULL, /*parm*/
						csel_occupy, /*occupy*/
						NULL /*free*/
					);
				}

				if (!strcmp(csel_groups[i].name, name)) {
					//FIXME: add port to csel
					csel_add(csel_groups[i].cs, (void*)next);
					break;
				}
			}

			if (cm_get(config, slot, sizeof(slot), SECT_PORT, CFG_PORT_SLOT, next)) {
				strcpy(slot,"0");
			}

			gsm_set_next_simslot(next, slot[0]=='1'?1:0);

			_init_mod_port(next);
		}

	}

	for (i = 1; i < MAX_GSM_PORTS; i++) {
		
		//if (!gsm_check_port(i)) continue;

		if ((gsm_prev_cfg[i].port == 0) && (gsm_cfg[i].port == 1)) {
			/* starting a port from fresh */
			ast_verbose("port=(%d) Starting\n", i);
			shutdown_port[i] = 0;
			start_port[i] = 1;
		} else if ((gsm_prev_cfg[i].port == 1) && (gsm_cfg[i].port == 1)) {
			/* restarting an existing port after checking if there is an active call on that port */
			ast_verbose("port=(%d) %s\n", i, (busy_port[i] ? "NOT Restarting (busy)." : "Restarting."));
			shutdown_port[i] = 1;
			start_port[i] = 1;
		} else if ((gsm_prev_cfg[i].port == 1) && (gsm_cfg[i].port == 0)) {
			/* shutting down an existing port, need to check if there's an active call on that port */
			ast_verbose("port=(%d) %s\n", i, (busy_port[i] ? "NOT Shutting Down (busy)." : "Shutting down."));
			shutdown_port[i] = 1;
			start_port[i] = 0;
		} else {
			/* do nothing case --> port was down and will be down */
		}
	}

	for (i=0; i<256; i++)
		sms_idx[i]=0;

	/* process the shutdowns first */
	for (i=1; i < MAX_GSM_PORTS;i++) {
		if (busy_port[i]) {
			ast_log(LOG_DEBUG, "port=(%d) Busy. Skipping\n", i);
			continue;
		}
		if (shutdown_port[i]) {	/* before shutdown, check to be sure there are no calls on this port */
			ast_log(LOG_DEBUG, "port=(%d) Shutting Down.\n", i);
			gsm_sms_destroy(i);
			gsm_shutdown_port(i, 0);
			ast_log(LOG_DEBUG, "port=(%d) Shutdown OK.\n", i);
		}
	}

	/* wait for 3 seconds */
//	sleep(3);

	/* process the starts next */
	for (i=1; i < MAX_GSM_PORTS;i++) {
		if (busy_port[i]) {
			ast_log(LOG_DEBUG, "port=(%d) Busy. Skipping\n", i);
			continue;
		}
		if (start_port[i]) {
			ast_log(LOG_DEBUG, "port=(%d) Initializing.\n", i);
			gsm_init_port(i, &gsm_cfg[i]);
			gsm_sms_init(i);
			ast_log(LOG_DEBUG, "port=(%d) Initialization OK.\n", i);
		}
	}

	/* wait for all ports to be ready (last step) */
	for (i=1; i < MAX_GSM_PORTS;i++) {
		if (busy_port[i]) {
			ast_log(LOG_DEBUG, "port=(%d) Busy. Skipping\n", i);
			continue;
		}
		if (start_port[i]) { /* ONLY if it's been restarted */
			ast_log(LOG_DEBUG, "port=(%d) Waiting for ready signal.\n", i);
			if (gsm_wait_ready_with_timeout(i, GSM_READY_TIMEOUT) == 0)
				ast_log(LOG_DEBUG, "port=(%d) Waiting for ready signal OK.\n", i);
			else
				ast_log(LOG_ERROR, "port=(%d) Timed out waiting for ready signal.\n", i);
		}
	}

	ast_mutex_unlock(&gsm_mutex);

	unsigned long now = time(NULL);

	ast_log(LOG_DEBUG, "It took us %ld seconds to reload/restart configuration\n", now-then);

	return 0;
}


#if 1
static int reload_module(void)
#else
int reload_module(void)
#endif
{
	reload_module_thread(NULL);
	return 0;
}

#define AST_MODULE "chan_gsm"
#if 1
AST_MODULE_INFO(ASTERISK_GPL_KEY,
                                AST_MODFLAG_DEFAULT,
                                "Channel driver for gsm cards",
                                .load = load_module,
                                .unload = unload_module,
                                .reload = reload_module,
                           );
#else

char *desc="chan_gsm";

char *description(void)
{
        return desc;
}

char *key(void)
{
        return ASTERISK_GPL_KEY;
}

int usecount(void)
{
	return 0;
}

#endif

